VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsHBody"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Const AU = 149597870 'Astronomical unit in km
Const PARSEC = 30856775670286.6 'Parsec in km
Const PI = 3.14159265358979
Const TPI = 6.28318530717959
Friend Function DistSize(strHBody As String) As String
'Return distance and apparent radius
    Dim udtHbody As HBody
    Dim udtDms As DMS
    Dim cDMS As New clsDMS
    
    Call TrueHBody(strHBody, dblDate + dblTime, udtHbody)
    If udtHbody.DistanceTopo > 10000000000# Then
        DistSize = strHBody & "'s distance and size" & vbCrLf & "Geocentric distance " & Format(udtHbody.DistanceGeo / PARSEC, strFormat(lngPrecision + 1)) & " parsec" & vbCrLf
        DistSize = DistSize & "Topocentric distance " & Format(udtHbody.DistanceTopo / PARSEC, strFormat(lngPrecision + 1)) & " parsec" & vbCrLf
    Else
        DistSize = strHBody & "'s distance and size" & vbCrLf & "Geocentric distance " & Format(udtHbody.DistanceGeo, strFormat(lngPrecision / 2)) & " km" & vbCrLf
        DistSize = DistSize & "Topocentric distance " & Format(udtHbody.DistanceTopo, strFormat(lngPrecision / 2)) & " km" & vbCrLf
    End If
    If udtHbody.Radius < 0.01 Then
        udtDms.blnSign = True
        udtDms.intDegreesHours = 0
        udtDms.intMinutes = 0
        udtDms.dblSeconds = udtHbody.Radius * 3600
    Else
        Call cDMS.ToDMS(udtHbody.Radius, udtDms)
    End If
    If udtDms.intMinutes > 0 Then
        DistSize = DistSize & "Topocentric radius " & udtDms.intMinutes & "'" & Format(udtDms.dblSeconds, strFormat(lngPrecision)) & """"
    Else
        DistSize = DistSize & "Topocentric radius " & Format(udtDms.dblSeconds, strFormat(lngPrecision - Int(Log10(udtDms.dblSeconds)) + 2)) & """"
    End If
    If strHBody <> "Sun" Then
        DistSize = DistSize & vbCrLf & "Geocentric ecliptic elongation " & strAngle(udtHbody.EclElong, CInt(lngPrecision))
        If strHBody = "Moon" Then DistSize = DistSize & vbCrLf & "Simple geocentric illumination " & Format((1 - cosD(udtHbody.ElongationGeo)) * 50, strFormat(lngPrecision + 2)) & "% (" & strAngle(udtHbody.ElongationGeo, CInt(lngPrecision)) & ")"
        DistSize = DistSize & vbCrLf & "Topocentric illumination " & Format(udtHbody.Phase * 100, strFormat(lngPrecision + 2)) & "% (" & strAngle(acosD(1 - 2 * udtHbody.Phase), CInt(lngPrecision)) & ")"
    End If
End Function
Friend Sub TrueHBody(strHBody As String, dblFix As Double, udtHbody As HBody)
    Dim dblMoonFix As Double 'Time for Moon corrected for differences in lunar acceleration
    Dim dblL As Double
    Dim dblB As Double
    Dim dblR As Double
    Dim dblLS As Double
    Dim dblBS As Double
    Dim dblRS As Double
    Dim dblX As Double
    Dim dblY As Double
    Dim dblZ As Double
    Dim dblDelta As Double 'Light time
    Dim dblDiameter As Double
    Dim intI As Integer
    Dim cSun As New clsSun
    Dim udtSun As HBody
    Dim dblDMS As Double
    Dim dblBeta As Double
    Dim dblRRMH As Double
    Dim dblDPMH As Double
    Dim dblT As Double
    Dim dblOmega As Double
    Dim dblEps As Double 'Inclination or Earth's axis
    Dim cPlanet As New clsPlanet
    Dim cMoon As New clsMoon
    Dim dblLp As Double
    Dim dblD As Double
    Dim dblM As Double
    Dim dblMp As Double
    Dim dblF As Double
    Dim dblA1 As Double
    Dim dblA2 As Double
    Dim dblA3 As Double
    Dim dblE As Double
    Dim dblEE(2) As Double
    Dim dblPar As Double
    Dim dblXi As Double
    Dim dblZeta As Double
    Dim dblTheta As Double
    Dim dblX2 As Double
    Dim dblY2 As Double
    Dim dblZ2 As Double
    Dim dblA As Double
    Dim dblC As Double
    
    Select Case strHBody
        Case "Sun":
            dblDiameter = 1392000
        Case "Mercury":
            dblDiameter = 4880
        Case "Venus":
            dblDiameter = 12103.6
        Case "Moon":
            dblDiameter = 3476
        Case "Mars":
            dblDiameter = 6790
        Case "Jupiter":
            dblDiameter = 116600
        Case "Saturn":
            dblDiameter = 100000
        Case Else
            intI = 0
            While intI < intNStars - 1 And strHBody <> udtStar(intI).strName
                intI = intI + 1
            Wend
                If strHBody <> udtStar(intI).strName Then
                MsgBox ("Invalid heavenly body name")
            End If
    End Select
    Select Case strHBody
    Case "Sun"
        If blnEarth And Not blnChangedInput And dblFix = udtSunSave.Fix And dblFix <> 0 Then
            Call CopyHBody(udtSunSave, udtHbody)
        Else
            dblT = ToJ2000(dblFix)
            dblOmega = 125.04 - 1934.136 * dblT 'Used for nutation correction
            dblEps = Eps(dblT) + 0.00256 * cosD(dblOmega)
            'If blnLowPre Then
            '    dblL0 = MeanSun(dblFix)
            '    dblM = FracCirc(357.52911 + dblT * (35999.05029 - 0.0001537 * dblT))
            '    dblE = 0.016708634 - dblT * (0.000042037 + 0.0000001267 * dblT)
            '    dblC = (1.914602 - dblT * (0.004817 + 0.000014 * dblT)) * sinD(dblM) + (0.019993 - 0.000101 * dblT) * sinD(2 * dblM) + 0.000289 * sinD(3 * dblM)
            '    dblNu = dblM + dblC
            '    udtSun.EclLong = FracCirc(dblL0 + dblC - 0.00569 - 0.00478 * sinD(dblOmega)) 'Apparent ecliptic longitude
            '    udtSun.EclDecl = 0
            '    udtSun.DistanceGeo = 1.00001018 * (1 - Square(dblE)) / (1 + dblE * cosD(dblNu)) * 149597870 'in km
            'Else
                Call cPlanet.HelioPlanet("Earth", dblFix, udtHbody.EclLong, udtHbody.EclDecl, udtHbody.DistanceGeo)
                udtHbody.EclLong = FracCirc(180 + udtHbody.EclLong - 0.00569 - 0.00478 * sinD(dblOmega))
                udtHbody.EclDecl = -udtHbody.EclDecl
            'End If
            Call ConvCoords(udtHbody, dblFix, udtWeatherNow)
            udtHbody.Phase = 1
            udtHbody.Radius = atn2D(dblDiameter / 2 / udtHbody.DistanceTopo, 1) 'Apparent radius of Sun
            udtHbody.EclElong = 0
            udtHbody.ElongationGeo = 0
            udtHbody.ElongationTopo = 0
            udtHbody.Fix = dblFix
            Call CopyHBody(udtHbody, udtSunSave)
        End If
    Case "Moon"
        If blnMoonRead And Not blnChangedInput And dblFix = udtMoonSave.Fix Then
            Call CopyHBody(udtMoonSave, udtHbody)
        Else
            If Not blnMoonRead Then 'First time, read table
                Call ReadHBody("Moon", udtMercury, lngMoonLR, lngMoonB, udtStar)
                blnMoonRead = True
            End If
            dblT = ((dblFix + 14.25 + 365.25) / 365.25 - 2000) / 100 + 0.445 'Centuries since 1955.5
            If dblT >= 0 Then
                dblMoonFix = dblFix
            Else
                dblMoonFix = dblFix + 0.91072 * (LunAcc - LunAccMoon) * Square(dblT) / 86400
            End If
            dblT = ToJ2000(dblMoonFix)
            dblLp = cMoon.MeanMoon(dblMoonFix)
            dblD = dblT * (1 / 545868 - dblT / 113065000)
            dblD = FracCirc(297.8501921 + dblT * (445267.1114034 - dblT * (0.0018819 - dblD)))
            dblM = FracCirc(357.5291092 + dblT * (35999.0502909 - dblT * (0.0001536 - dblT / 24490000)))
            dblMp = dblT * (1 / 69699 - dblT / 14712000)
            dblMp = FracCirc(134.9633964 + dblT * (477198.8675055 + dblT * (0.0087414 + dblMp)))
            dblF = dblT * (1 / 3526000 - dblT / 863310000)
            dblF = FracCirc(93.272095 + dblT * (483202.0175233 - dblT * (0.0036539 + dblF)))
            dblA1 = FracCirc(119.75 + dblT * 131.849)
            dblA2 = FracCirc(53.09 + dblT * 479264.29)
            dblA3 = FracCirc(313.45 + dblT * 481266.484)
            dblE = 1 - dblT * (0.002516 + dblT * 0.0000074)
            dblEE(0) = 1
            For intI = 1 To 2
                dblEE(intI) = dblEE(intI - 1) * dblE
            Next
            udtHbody.EclLong = 0
            udtHbody.DistanceGeo = 0
            udtHbody.EclDecl = 0
            For intI = 0 To 59
                dblPar = dblD * lngMoonLR(0, intI) + dblM * lngMoonLR(1, intI) + dblMp * lngMoonLR(2, intI) + dblF * lngMoonLR(3, intI)
                dblPar = (dblPar - 360 * Int(dblPar / 360)) / RADCON
                udtHbody.EclLong = udtHbody.EclLong + lngMoonLR(4, intI) * dblEE(Abs(lngMoonLR(1, intI))) * Sin(dblPar)
                udtHbody.DistanceGeo = udtHbody.DistanceGeo + lngMoonLR(5, intI) * dblEE(Abs(lngMoonLR(1, intI))) * Cos(dblPar)
                dblPar = dblD * lngMoonB(0, intI) + dblM * lngMoonB(1, intI) + dblMp * lngMoonB(2, intI) + dblF * lngMoonB(3, intI)
                dblPar = (dblPar - 360 * Int(dblPar / 360)) / RADCON
                udtHbody.EclDecl = udtHbody.EclDecl + lngMoonB(4, intI) * dblEE(Abs(lngMoonB(1, intI))) * Sin(dblPar)
            Next
            udtHbody.EclLong = dblLp + (udtHbody.EclLong + 3958 * sinD(dblA1) + 1962 * sinD(dblLp - dblF) + 318 * sinD(dblA2)) / 1000000
            dblOmega = 125.04 - 1934.136 * dblT 'Used for nutation correction
            'Convert to apparent longitude correcting for abberation and nutation
            udtHbody.EclLong = FracCirc(udtHbody.EclLong - 0.00569 * Cos(dblD) - 0.00478 * sinD(dblOmega))
            udtHbody.EclDecl = (udtHbody.EclDecl - 2235 * sinD(dblLp) + 382 * sinD(dblA3) + 175 * sinD(dblA1 - dblF) + 175 * sinD(dblA1 + dblF) + 127 * sinD(dblLp - dblMp) - 115 * sinD(dblLp + dblMp)) / 1000000
            udtHbody.DistanceGeo = 385000.56 + udtHbody.DistanceGeo / 1000
        Call ConvCoords(udtHbody, dblFix, udtWeatherNow)
        Call TrueHBody("Sun", dblFix, udtSun)
        udtHbody.EclElong = FracCirc2(udtHbody.EclLong - udtSun.EclLong)
        udtHbody.ElongationGeo = sinD(udtHbody.DeclGeo) * sinD(udtSun.DeclTopo) + cosD(udtHbody.DeclGeo) * cosD(udtSun.DeclGeo) * cosD(udtHbody.RAGeo - udtSun.RAGeo)
        If udtHbody.ElongationGeo > 0.999995 Then
            udtHbody.ElongationGeo = Sqr(Square(udtSun.RAGeo - udtHbody.RATopo) * cosD((udtHbody.DeclGeo + udtSun.DeclGeo) / 2) + Square(udtHbody.DeclGeo - udtSun.DeclGeo))
        ElseIf udtHbody.ElongationGeo <= -1 Then
            udtHbody.ElongationGeo = 180
        Else
            udtHbody.ElongationGeo = acosD(udtHbody.ElongationGeo)
        End If
        udtHbody.ElongationTopo = sinD(udtHbody.DeclTopo) * sinD(udtSun.DeclTopo) + cosD(udtHbody.DeclTopo) * cosD(udtSun.DeclTopo) * cosD(udtHbody.RATopo - udtSun.RATopo)
        If udtHbody.ElongationTopo > 0.999995 Then
            udtHbody.ElongationTopo = Sqr(Square(udtSun.RATopo - udtHbody.RATopo) * cosD((udtHbody.DeclTopo + udtSun.DeclTopo) / 2) + Square(udtHbody.DeclTopo - udtSun.DeclTopo))
        ElseIf udtHbody.ElongationTopo <= -1 Then
            udtHbody.ElongationTopo = 180
        Else
            udtHbody.ElongationTopo = acosD(udtHbody.ElongationTopo)
        End If
        udtHbody.Radius = asinD(dblDiameter / 2 / udtHbody.DistanceTopo)
        'Calculation of topocentric phase accurate to within 0.0022%
        dblDMS = Sqr(Square(udtHbody.DistanceTopo) + Square(udtSun.DistanceTopo) - 2 * udtHbody.DistanceTopo * udtSun.DistanceTopo * cosD(udtHbody.ElongationTopo))
        If Square(udtHbody.DistanceTopo) + Square(dblDMS) < Square(udtSun.DistanceTopo) Then
            dblBeta = 90 - asinD(sinD(udtHbody.ElongationTopo) * udtSun.DistanceTopo / dblDMS)
        Else
            dblBeta = asinD(sinD(udtHbody.ElongationTopo) * udtSun.DistanceTopo / dblDMS) - 90
        End If
        dblRRMH = asinD(1505.152 / udtHbody.DistanceTopo)
        dblDPMH = Sqr(Square(1505.152) + Square(udtHbody.DistanceTopo) - 2 * 1505.152 * udtHbody.DistanceTopo * cosD(dblBeta))
        udtHbody.Phase = (1 - asinD(1505.152 * sinD(dblBeta) / dblDPMH) / dblRRMH) / 2
        udtHbody.Fix = dblFix
            Call CopyHBody(udtHbody, udtMoonSave)
        End If
    Case "Mercury", "Mars", "Venus", "Jupiter", "Saturn"
        dblDelta = 0
        For intI = 0 To 2
            Call cPlanet.HelioPlanet(strHBody, dblFix - dblDelta, dblL, dblB, dblR)
            Call cPlanet.HelioPlanet("Earth", dblFix, dblLS, dblBS, dblRS)
            Call TrueHBody("Sun", dblFix - dblDelta, udtSun)
            dblX = dblR * cosD(dblB) * cosD(dblL) - dblRS * cosD(dblBS) * cosD(dblLS)
            dblY = dblR * cosD(dblB) * sinD(dblL) - dblRS * cosD(dblBS) * sinD(dblLS)
            dblZ = dblR * sinD(dblB) - dblRS * sinD(dblBS)
            dblDelta = Sqr(Square(dblX) + Square(dblY) + Square(dblZ)) * 3.86068915885E-11
        Next
        udtHbody.EclLong = atn2D(dblY, dblX)
        udtHbody.EclDecl = atn2D(dblZ, Sqr(Square(dblX) + Square(dblY)))
        If udtHbody.EclDecl >= 180 Then udtHbody.EclDecl = udtHbody.EclDecl - 360
        udtHbody.DistanceGeo = dblDelta / 3.86068915885E-11
        Call ConvCoords(udtHbody, dblFix, udtWeatherNow)
        udtHbody.EclElong = FracCirc2(udtHbody.EclLong - udtSun.EclLong)
        udtHbody.ElongationGeo = sinD(udtHbody.DeclGeo) * sinD(udtSun.DeclTopo) + cosD(udtHbody.DeclGeo) * cosD(udtSun.DeclGeo) * cosD(udtHbody.RAGeo - udtSun.RAGeo)
        If udtHbody.ElongationGeo > 0.999995 Then
            udtHbody.ElongationGeo = Sqr(Square(udtSun.RAGeo - udtHbody.RATopo) * cosD((udtHbody.DeclGeo + udtSun.DeclGeo) / 2) + Square(udtHbody.DeclGeo - udtSun.DeclGeo))
        ElseIf udtHbody.ElongationGeo <= -1 Then
            udtHbody.ElongationGeo = 180
        Else
            udtHbody.ElongationGeo = acosD(udtHbody.ElongationGeo)
        End If
        udtHbody.ElongationTopo = sinD(udtHbody.DeclTopo) * sinD(udtSun.DeclTopo) + cosD(udtHbody.DeclTopo) * cosD(udtSun.DeclTopo) * cosD(udtHbody.RATopo - udtSun.RATopo)
        If udtHbody.ElongationTopo > 0.999995 Then
            udtHbody.ElongationTopo = Sqr(Square(udtSun.RATopo - udtHbody.RATopo) * cosD((udtHbody.DeclTopo + udtSun.DeclTopo) / 2) + Square(udtHbody.DeclTopo - udtSun.DeclTopo))
        ElseIf udtHbody.ElongationTopo <= -1 Then
            udtHbody.ElongationTopo = 180
        Else
            udtHbody.ElongationTopo = acosD(udtHbody.ElongationTopo)
        End If
        udtHbody.Radius = asinD(dblDiameter / 2 / udtHbody.DistanceTopo)
        'Calculation of topocentric phase accurate to within 0.0022%
        dblDMS = Sqr(Square(udtHbody.DistanceTopo) + Square(udtSun.DistanceTopo) - 2 * udtSun.DistanceTopo * udtHbody.DistanceTopo * cosD(udtHbody.ElongationTopo))
        If Square(udtHbody.DistanceTopo) + Square(dblDMS) < Square(udtSun.DistanceTopo) Then
            dblBeta = 90 - asinD(sinD(udtHbody.ElongationTopo) * udtSun.DistanceTopo / dblDMS)
        Else
            dblBeta = asinD(sinD(udtHbody.ElongationTopo) * udtSun.DistanceTopo / dblDMS) - 90
        End If
        dblRRMH = asinD(dblDiameter * 0.433 / udtHbody.DistanceTopo)
        dblDPMH = Sqr(Square(dblDiameter * 0.433) + Square(udtHbody.DistanceTopo) - 2 * dblDiameter * 0.433 * udtHbody.DistanceTopo * cosD(dblBeta))
        udtHbody.Phase = (1 - asinD(dblDiameter * 0.4332 * sinD(dblBeta) / dblDPMH) / dblRRMH) / 2
    Case Else 'Star
        If Not blnStarRead Then 'First time, read table
            Call ReadHBody("Star", udtMercury, lngMoonLR, lngMoonB, udtStar)
            blnStarRead = True
        End If
        intI = 0
        While intI < intNStars - 1 And strHBody <> udtStar(intI).strName
            intI = intI + 1
        Wend
        If strHBody <> udtStar(intI).strName Then
            MsgBox ("Star not found")
            End
        End If
        dblT = ToJ2000(dblFix) * 36525 / 36524.2199
        dblXi = (2306.2181 * (dblT + 0.30188 * (dblT + 0.017998 * dblT))) / 3600
        dblZeta = (2306.2181 * (dblT + 1.09468 * (dblT + 0.018203 * dblT))) / 3600
        dblTheta = (2004.3109 * (dblT + 0.42665 * (dblT + 0.041833 * dblT))) / 3600
        With udtStar(intI)
            dblX = .dblDist * cosD(.dblDec) * cosD(.dblRA)
            dblY = .dblDist * cosD(.dblDec) * sinD(.dblRA)
            dblZ = .dblDist * sinD(.dblDec)
            dblX2 = dblX + ((dblX / .dblDist) * .dblDDist / 977792 - dblZ * .dblDDec * cosD(.dblRA) / 206265 - dblY * .dblDRA / 206265) * dblT * 100
            dblY2 = dblY + ((dblY / .dblDist) * .dblDDist / 977792 - dblZ * .dblDDec * sinD(.dblRA) / 206265 + dblX * .dblDRA / 206265) * dblT * 100
            dblZ2 = dblZ + ((dblZ / .dblDist) * .dblDDist / 977792 + .dblDist * .dblDDec * cosD(.dblDec) / 206265) * dblT * 100
        End With
        With udtHbody
            .RAGeo = atn2D(dblY2, dblX2)
            .DeclGeo = atn2D(dblZ2, Sqr(Square(dblX2) + Square(dblY2)))
            .DistanceGeo = Sqr(Square(dblX2) + Square(dblY2) + Square(dblZ2)) * 30856800000000#
            dblA = cosD(.DeclGeo) * sinD(.RAGeo + dblZeta)
            dblB = cosD(dblTheta) * cosD(.DeclGeo) * cosD(.RAGeo + dblZeta) - sinD(dblTheta) * sinD(.DeclGeo)
            dblC = sinD(dblTheta) * cosD(.DeclGeo) * cosD(.RAGeo + dblZeta) + cosD(dblTheta) * sinD(.DeclGeo)
            .DeclGeo = asinD(dblC)
            .RAGeo = FracCirc(atn2D(dblA, dblB) - dblZeta)
            'Convert to ecliptic coordinates
            dblEps = Eps(ToJ2000(dblFix))
            .EclLong = atn2D(sinD(.RAGeo) * cosD(dblEps) + tanD(.DeclGeo) * sinD(dblEps), cosD(.RAGeo))
            .EclDecl = asinD(sinD(.DeclGeo) * cosD(dblEps) - cosD(.DeclGeo) * sinD(dblEps) * sinD(.RAGeo))
        End With
        Call ConvCoords(udtHbody, dblFix, udtWeatherNow)
        Call TrueHBody("Sun", dblFix, udtSun)
        udtHbody.EclElong = FracCirc2(udtHbody.EclLong - udtSun.EclLong)
        udtHbody.ElongationGeo = sinD(udtHbody.DeclGeo) * sinD(udtSun.DeclTopo) + cosD(udtHbody.DeclGeo) * cosD(udtSun.DeclGeo) * cosD(udtHbody.RAGeo - udtSun.RAGeo)
        If udtHbody.ElongationGeo > 0.999995 Then
            udtHbody.ElongationGeo = Sqr(Square(udtSun.RAGeo - udtHbody.RATopo) * cosD((udtHbody.DeclGeo + udtSun.DeclGeo) / 2) + Square(udtHbody.DeclGeo - udtSun.DeclGeo))
        ElseIf udtHbody.ElongationGeo <= -1 Then
            udtHbody.ElongationGeo = 180
        Else
            udtHbody.ElongationGeo = acosD(udtHbody.ElongationGeo)
        End If
        udtHbody.ElongationTopo = sinD(udtHbody.DeclTopo) * sinD(udtSun.DeclTopo) + cosD(udtHbody.DeclTopo) * cosD(udtSun.DeclTopo) * cosD(udtHbody.RATopo - udtSun.RATopo)
        If udtHbody.ElongationTopo > 0.999995 Then
            udtHbody.ElongationTopo = Sqr(Square(udtSun.RATopo - udtHbody.RATopo) * cosD((udtHbody.DeclTopo + udtSun.DeclTopo) / 2) + Square(udtHbody.DeclTopo - udtSun.DeclTopo))
        ElseIf udtHbody.ElongationTopo <= -1 Then
            udtHbody.ElongationTopo = 180
        Else
            udtHbody.ElongationTopo = acosD(udtHbody.ElongationTopo)
        End If
        udtHbody.Radius = asinD(udtStar(intI).dblDiam / 2 / udtHbody.DistanceTopo)
        udtHbody.Phase = 1
    End Select
End Sub
Friend Sub ReadHBody(strName As String, udtPars As VSOP, lngMoonLR() As Long, lngMoonB() As Long, udtStar() As StarData)
    Dim intFactor As Integer
    Dim intComponent As Integer
    Dim strLine As String
    Dim blnFoundData As Boolean
    Dim intI As Integer
    Dim intJ As Integer
    Dim varTemp As Variant
    
    blnFoundData = True
    Select Case strName
    Case "Moon"
        Open "MoonLong.txt" For Input Access Read As 1
        Input #1, strLine 'First line is a comment
        For intI = 0 To 59
            For intJ = 0 To 5
                varTemp = GetValue(1, "~", "Long", -100000000, 100000000)
                If IsNull(varTemp) Then
                    MsgBox "Error in ReadHBody: invalid or missing data for Moon longitude and distance"
                    blnFoundData = False
                    End
                Else
                    lngMoonLR(intJ, intI) = varTemp
                End If
            Next
        Next
        Close 1
        Open "Moonlat.txt" For Input Access Read As 1
        Input #1, strLine 'First line is a comment
        For intI = 0 To 59
            For intJ = 0 To 4
                varTemp = GetValue(1, "~", "Long", -100000000, 100000000)
                If IsNull(varTemp) Then
                    MsgBox "Error in ReadHBody: invalid or missing data for Moon latitude and distance"
                    blnFoundData = False
                    End
                Else
                    lngMoonB(intJ, intI) = varTemp
                End If
            Next
        Next
        Close 1
    Case "Mercury", "Venus", "Mars", "Earth", "Jupiter", "Saturn"
        Open strName & ".txt" For Input Access Read As 1
        ReDim udtPars.L(0)
        ReDim udtPars.B(0)
        ReDim udtPars.R(0)
        strLine = GetNextLine()
        While Left(strLine, 1) = "L"
            varTemp = Mid(strLine, 2, 1)
            If Not IsNumeric(varTemp) Then
                MsgBox "Error in ReadHBody: Invalid power coefficient for L in the data for " & strName
                blnFoundData = False
                End
            Else
                intFactor = varTemp
            End If
            ReDim Preserve udtPars.L(intFactor)
            intComponent = 1
            While Mid(strLine, 2, 1) = intFactor And Left(strLine, 1) = "L"
                If intComponent <> GetNextLine() Then
                    MsgBox "Error in ReadHBody: Invalid ordinal coefficient for L in the data for " & strName
                    End
                End If
                ReDim Preserve udtPars.L(intFactor).A(1 To intComponent)
                ReDim Preserve udtPars.L(intFactor).B(1 To intComponent)
                ReDim Preserve udtPars.L(intFactor).C(1 To intComponent)
                varTemp = GetValue(1, "#", "Long", 0, 3000000000000#)
                If IsNull(varTemp) Then
                    blnFoundData = False
                    MsgBox "Error in ReadHBody: Invalid amplitude for L(" & intComponent & ") in the data for " & strName
                    End
                End If
                udtPars.L(intFactor).A(intComponent) = varTemp
                varTemp = GetValue(1, "#", "Double", 0, 6.284)
                If IsNull(varTemp) Then
                    blnFoundData = False
                    MsgBox "Error in ReadHBody: Invalid phase for L(" & intComponent & ") in the data for " & strName
                    End
                End If
                udtPars.L(intFactor).B(intComponent) = varTemp
                varTemp = GetValue(1, "#", "Double", 0, 300000)
                If IsNull(varTemp) Then
                    blnFoundData = False
                    MsgBox "Error in ReadHBody: Invalid frequency for L(" & intComponent & ") in the data for " & strName
                    End
                End If
                udtPars.L(intFactor).C(intComponent) = varTemp
                intComponent = intComponent + 1
                strLine = GetNextLine()
            Wend
            udtPars.L(intFactor).N = intComponent - 1
        Wend
        udtPars.NL = intFactor
        While Left(strLine, 1) = "B"
            varTemp = Mid(strLine, 2, 1)
            If Not IsNumeric(varTemp) Then
                MsgBox "Error in ReadHBody: Invalid power coefficient for B in the data for " & strName
                blnFoundData = False
                End
            Else
                intFactor = varTemp
            End If
            ReDim Preserve udtPars.B(intFactor)
            intComponent = 1
            While Mid(strLine, 2, 1) = intFactor And Left(strLine, 1) = "B"
                If intComponent <> GetNextLine() Then
                    MsgBox "Error in ReadHBody: Invalid ordinal coefficient for L in the data for " & strName
                    End
                End If
                ReDim Preserve udtPars.B(intFactor).A(1 To intComponent)
                ReDim Preserve udtPars.B(intFactor).B(1 To intComponent)
                ReDim Preserve udtPars.B(intFactor).C(1 To intComponent)
                varTemp = GetValue(1, "#", "Long", 0, 1000000000)
                If IsNull(varTemp) Then
                    blnFoundData = False
                    MsgBox "Error in ReadHBody: Invalid amplitude for B(" & intComponent & ") in the data for " & strName
                    End
                End If
                udtPars.B(intFactor).A(intComponent) = varTemp
                varTemp = GetValue(1, "#", "Double", 0, 6.284)
                If IsNull(varTemp) Then
                    blnFoundData = False
                    MsgBox "Error in ReadHBody: Invalid phase for B(" & intComponent & ") in the data for " & strName
                    End
                End If
                udtPars.B(intFactor).B(intComponent) = varTemp
                varTemp = GetValue(1, "#", "Double", 0, 300000)
                If IsNull(varTemp) Then
                    blnFoundData = False
                    MsgBox "Error in ReadHBody: Invalid frequency for B(" & intComponent & ") in the data for " & strName
                    End
                End If
                udtPars.B(intFactor).C(intComponent) = varTemp
                intComponent = intComponent + 1
                strLine = GetNextLine()
            Wend
            udtPars.B(intFactor).N = intComponent - 1
        Wend
        udtPars.NB = intFactor
        While Left(strLine, 1) = "R"
            varTemp = Mid(strLine, 2, 1)
            If Not IsNumeric(varTemp) Then
                MsgBox "Error in ReadHBody: Invalid power coefficient for L in the data for " & strName
                blnFoundData = False
                End
            Else
                intFactor = varTemp
            End If
            ReDim Preserve udtPars.R(intFactor)
            intComponent = 1
            While Mid(strLine, 2, 1) = intFactor And Left(strLine, 1) = "R"
                If intComponent <> GetNextLine() Then
                    MsgBox "Error in ReadHBody: Invalid ordinal coefficient for R in the data for " & strName
                    End
                End If
                ReDim Preserve udtPars.R(intFactor).A(1 To intComponent)
                ReDim Preserve udtPars.R(intFactor).B(1 To intComponent)
                ReDim Preserve udtPars.R(intFactor).C(1 To intComponent)
                varTemp = GetValue(1, "#", "Long", 0, 1000000000)
                If IsNull(varTemp) Then
                    blnFoundData = False
                    MsgBox "Error in ReadHBody: Invalid amplitude for R(" & intComponent & ") in the data for " & strName
                    End
                End If
                udtPars.R(intFactor).A(intComponent) = varTemp
                varTemp = GetValue(1, "#", "Double", 0, 6.284)
                If IsNull(varTemp) Then
                    blnFoundData = False
                    MsgBox "Error in ReadHBody: Invalid phase for R(" & intComponent & ") in the data for " & strName
                    End
                End If
                udtPars.R(intFactor).B(intComponent) = varTemp
                varTemp = GetValue(1, "#", "Double", 0, 300000)
                If IsNull(varTemp) Then
                    blnFoundData = False
                    MsgBox "Error in ReadHBody: Invalid frequency for R(" & intComponent & ") in the data for " & strName
                    End
                End If
                udtPars.R(intFactor).C(intComponent) = varTemp
                intComponent = intComponent + 1
                strLine = GetNextLine()
            Wend
            udtPars.R(intFactor).N = intComponent - 1
        Wend
        udtPars.NR = intFactor
        Close 1
    Case "Star"
        Open "Stars.txt" For Input Access Read As 1
        intNStars = 0
        While Not EOF(1)
            ReDim Preserve udtStar(intNStars)
            With udtStar(intNStars)
                varTemp = GetValue(1, "#", "String")
                If IsNull(varTemp) Then
                    blnFoundData = False
                    MsgBox ("Error in ReadHBody: Invalid star name")
                    End
                End If
                .strName = varTemp
                varTemp = GetValue(1, "#", "Double", 0, 360, True, False)
                If IsNull(varTemp) Then
                    blnFoundData = False
                    MsgBox ("Error in ReadHBody: Invalid star right ascension")
                    End
                End If
                .dblRA = varTemp
                varTemp = GetValue(1, "#", "Double", -90, 90, True, True)
                If IsNull(varTemp) Then
                    blnFoundData = False
                    MsgBox ("Error in ReadHBody: Invalid star declination")
                    End
                End If
                .dblDec = varTemp
                varTemp = GetValue(1, "#", "Double", 0, 10000000000#, False, False)
                If IsNull(varTemp) Then
                    blnFoundData = False
                    MsgBox ("Error in ReadHBody: Invalid star distance")
                    End
                End If
                .dblDist = varTemp
                varTemp = GetValue(1, "#", "Double", -15, 15, False, False)
                If IsNull(varTemp) Then
                    blnFoundData = False
                    MsgBox ("Error in ReadHBody: Invalid star change in right ascension")
                    End
                End If
                .dblDRA = varTemp
                varTemp = GetValue(1, "#", "Double", -15, 15, False, False)
                If IsNull(varTemp) Then
                    blnFoundData = False
                    MsgBox ("Error in ReadHBody: Invalid star change in declination")
                    End
                End If
                .dblDDec = varTemp
                varTemp = GetValue(1, "#", "Double", -300000, 300000, True, False)
                If IsNull(varTemp) Then
                    blnFoundData = False
                    MsgBox ("Error in ReadHBody: Invalid star change in distance")
                    End
                End If
                .dblDDist = varTemp
                varTemp = GetValue(1, "#", "Double", -1.5, 30, True, False)
                If IsNull(varTemp) Then
                    blnFoundData = False
                    MsgBox ("Error in ReadHBody: Invalid star magnitude")
                    End
                End If
                .dblMag = varTemp
                varTemp = GetValue(1, "#", "Double", 0, 10000000000#, False, False)
                If IsNull(varTemp) Then
                    blnFoundData = False
                    MsgBox ("Error in ReadHBody: Invalid star diameter")
                    End
                End If
                .dblDiam = varTemp
            End With
            intNStars = intNStars + 1
        Wend
        Close 1
    Case Else
        MsgBox "Error in ReadHBody: invalid object name"
        blnFoundData = False
        End
    End Select
End Sub
Friend Function ToJ2000(dblFix As Double) As Double
'Julian centuries since J2000
    Dim cJDE As New clsJDE
    Dim udtDateOut As MyDate
    Dim udtTimeOut As Mytime
    
    ToJ2000 = (cJDE.fixed_jde(dblFix) - 2451545) / 36525
End Function
Friend Function Eps(dblT As Double) As Double 'Inclination of Earth's axis
    
    Dim dblU As Double 'Myriads of years
    
    If Abs(dblT) <= 100 Then
        dblU = dblT / 100
        Eps = (7.12 + dblU * (27.87 + dblU * (5.79 + dblU * 2.45)))
        Eps = (51.38 + dblU * (249.67 + dblU * (39.05 - dblU * Eps)))
        Eps = (1.55 - dblU * (1999.25 - dblU * Eps))
        Eps = 23.4392911111111 - dblU / 3600 * (4680.93 + dblU * Eps)
    Else
        Eps = 23.4392911111111 - dblT / 3600 * (46.815 + dblT * (0.00059 - dblT * 0.001813))
    End If
End Function
Friend Sub ConvCoords(udtBody As HBody, dblFix As Double, udtWeatherNow As WeatherNow)
    'From J2000 date, ecliptic coordinates and distance, calculate the other coordinates
    Dim dblM As Double
    Dim dblC As Double
    Dim dblNu As Double
    Dim dblOmega As Double
    Dim dblEps As Double
    Dim dblT As Double
    Dim dblLatGeo As Double
    Dim dblRho As Double
    Dim dblSinPar As Double
    Dim dblRefR As Double
    Dim cLST As New clsLST
    Dim dblTheta As Double
    Dim cHBody As New clsHBody
    
    dblT = cHBody.ToJ2000(dblFix)
    'Evaluate nutation parameters
    dblM = FracCirc(357.52911 + dblT * (35999.05029 - 0.0001537 * dblT))
    dblC = (1.914602 - dblT * (0.004817 + 0.000014 * dblT)) * sinD(dblM) + (0.019993 - 0.000101 * dblT) * sinD(2 * dblM) + 0.000289 * sinD(3 * dblM)
    dblNu = dblM + dblC
    dblOmega = 125.04 - 1934.136 * dblT 'Used for nutation correction
    dblEps = Eps(dblT) + 0.00256 * cosD(dblOmega)
    'Convert to RA and declination
    udtBody.RAGeo = atn2D(cosD(dblEps) * sinD(udtBody.EclLong) - tanD(udtBody.EclDecl) * sinD(dblEps), cosD(udtBody.EclLong))
    udtBody.DeclGeo = asinD(sinD(udtBody.EclDecl) * cosD(dblEps) + cosD(udtBody.EclDecl) * sinD(dblEps) * sinD(udtBody.EclLong))
    'Use LST to find hour angle
    udtBody.HourAngGeo = cLST.FixToLST(dblFix, False) - udtBody.RAGeo
    'Conver to altitude azimuth
    udtBody.AzGeo = FracCirc(atn2D(sinD(udtBody.HourAngGeo), cosD(udtBody.HourAngGeo) * sinD(udtLocation.dblLatitude) - tanD(udtBody.DeclGeo) * cosD(udtLocation.dblLatitude)) + 180)
    udtBody.AltGeo = asinD(sinD(udtLocation.dblLatitude) * sinD(udtBody.DeclGeo) + cosD(udtLocation.dblLatitude) * cosD(udtBody.DeclGeo) * cosD(udtBody.HourAngGeo))
    'Correct for parallax
    dblLatGeo = atn2D(Square(0.99664719) * tanD(udtLocation.dblLatitude), 1)
    dblRho = (6378.14 + udtLocation.dblHeight / 1000) / 6378.14
    dblSinPar = sinD(365459.06 / udtBody.DistanceGeo)
    udtBody.HourAngTopo = atn2D(dblRho * cosD(dblLatGeo) * dblSinPar * sinD(udtBody.HourAngGeo), cosD(udtBody.DeclGeo) - dblRho * cosD(dblLatGeo) * dblSinPar * cosD(udtBody.HourAngGeo))
    If udtBody.HourAngTopo > 180 Then udtBody.HourAngTopo = udtBody.HourAngTopo - 360
    udtBody.DeclTopo = atn2D((sinD(udtBody.DeclGeo) - dblRho * sinD(dblLatGeo) * dblSinPar) * cosD(udtBody.HourAngTopo), cosD(udtBody.DeclGeo) - dblRho * cosD(dblLatGeo) * dblSinPar * cosD(udtBody.HourAngGeo))
    If udtBody.DeclTopo > 180 Then udtBody.DeclTopo = udtBody.DeclTopo - 360
    udtBody.RATopo = udtBody.RAGeo - udtBody.HourAngTopo
    udtBody.HourAngTopo = udtBody.HourAngGeo + udtBody.HourAngTopo
    udtBody.AzTopo = FracCirc(atn2D(sinD(udtBody.HourAngTopo), cosD(udtBody.HourAngTopo) * sinD(udtLocation.dblLatitude) - tanD(udtBody.DeclTopo) * cosD(udtLocation.dblLatitude)) + 180)
    udtBody.AltTopo = asinD(sinD(udtLocation.dblLatitude) * sinD(udtBody.DeclTopo) + cosD(udtLocation.dblLatitude) * cosD(udtBody.DeclTopo) * cosD(udtBody.HourAngTopo))
    dblTheta = sinD(dblLatGeo) * sinD(udtBody.DeclTopo) + cosD(dblLatGeo) * cosD(udtBody.DeclTopo) * cosD(udtBody.HourAngGeo)
    If dblTheta > 0.999995 Then
        dblTheta = Sqr(Square(udtBody.HourAngGeo) * cosD((dblLatGeo + udtBody.DeclTopo) / 2) + Square(dblLatGeo - udtBody.DeclTopo))
    ElseIf dblTheta <= -1 Then
        dblTheta = 180
    Else
        dblTheta = acosD(dblTheta)
    End If
    udtBody.DistanceTopo = Sqr(Square(udtBody.DistanceGeo) + Square(dblRho * 6378.14) - 2 * udtBody.DistanceGeo * dblRho * 6378.14 * cosD(dblTheta))
    'Correct for refraction
    dblRefR = Refract(udtBody.AltTopo, True, udtWeatherNow, udtBody.RefrValid)
    If dblRefR = 90 Then
        udtBody.AltRefr = -90 'Too far below the horizon to calculate
    Else
        udtBody.AltRefr = udtBody.AltTopo + Refract(udtBody.AltTopo, True, udtWeatherNow, udtBody.RefrValid)
    End If
End Sub
Friend Function Refract(dblAltitude As Double, blnToApparent As Boolean, udtWeatherNow As WeatherNow, blnRefrValid As Boolean) As Double
'Calculate the adjustment for refraction
    Dim dblRefract As Double
    Dim dblDiff As Double
    Dim intI As Integer
    Dim strLine As String
    Dim varTemp As Variant
    Dim cSky As New clsSky

    If dblAltitude < 5 And Not blnRefractRead Then 'First time, read table
        Open "Refract.txt" For Input Access Read As 1
        For intI = 0 To 15
            varTemp = GetValue(1, "#", "Double", -5, 5)
            If IsNull(varTemp) Then
                MsgBox "Error in refract reading near horizon refraction values"
                End
            End If
            dblRefA(intI) = varTemp
            varTemp = GetValue(1, "#", "Double", 0, 5)
            If IsNull(varTemp) Then
                MsgBox "Error in refract reading near horizon refraction values"
                End
            End If
            dblRefR(intI) = varTemp
        Next
        Close 1
        Call cSky.spline(dblRefA, dblRefR, dblRefR2, 16)
        blnRefractRead = True
    End If
    blnRefrValid = True
    If blnToApparent Then
        If dblAltitude >= 4 Then
            'Formula from Astronomical Algorithms
            Refract = 1.02 / tanD(dblAltitude + 10.3 / (dblAltitude + 5.11)) / 60 * 273.15 / 283.15
        ElseIf dblAltitude < -1.626 - 1.1 * Sqr(udtLocation.dblHeight / 1000) Or dblAltitude < -6 Then
            blnRefrValid = False
            Refract = 0
        ElseIf dblAltitude <= -3.5 Then
            Refract = (4.08 * dblAltitude + 0.8166 * Square(dblAltitude))
        End If
        If blnRefrValid And dblAltitude < 4.829444444 And dblAltitude > -4.1366 Then
            dblRefract = cSky.splint(dblRefA, dblRefR, dblRefR2, 16, dblAltitude)
            If dblAltitude < -3.5 Then
                Refract = dblRefract * (dblAltitude + 4.1366) / 0.6366 + Refract * (-3.5 - dblAltitude) / 0.6366
            ElseIf dblAltitude < 4 Then
                Refract = dblRefract
            Else
                Refract = dblRefract * (4.829444444 - dblAltitude) / 0.829444444 + Refract * (dblAltitude - 4) / 0.829444444
            End If
        End If
        If blnRefrValid Then Refract = Refract * udtWeatherNow.dblPressure / 1013.25 * 273.15 / (273.15 + udtWeatherNow.dblTemperature)
    Else
        dblRefract = 0
        dblDiff = 1
        blnRefrValid = True
        While dblDiff > 0.00001 And blnRefrValid
            Refract = Refract(dblAltitude - dblRefract, True, udtWeatherNow, blnRefrValid)
            dblDiff = Abs(Refract - dblRefract)
            dblRefract = Refract
        Wend
        If Not blnRefrValid Then Refract = 0
    End If
End Function
Function EveningSight(strHBody As String, lngFix As Long) As Boolean
'Find out if the geocentric Moon is new or old at true midday
    Dim cSun As New clsSun
    Dim dblMidday As Double
    Dim udtHbody As HBody
    Dim udtSun As HBody
    
    Call Meridian("Sun", lngFix, True, dblMidday)
    'If strHBody = "Moon" Or strHBody = "Mercury" Or strHBody = "Venus" Or strHBody = "Mars" Or strHBody = "Jupiter" Or strHBody = "Saturn" Then
        Call TrueHBody(strHBody, dblMidday, udtHbody)
        Call TrueHBody("Sun", dblMidday, udtSun)
        EveningSight = FracCirc(udtHbody.EclLong - udtSun.EclLong) < 180
    'Else
    '    MsgBox "Error in EveningSight: invalid object name: " & strHBody
    '    End
    'End If
End Function
Friend Sub RiseSet(strHBody As String, lngFix As Long, blnSet As Boolean, dblRiseSetTime As Double, blnApparent As Boolean, blnNeverRises As Boolean, blnNeverSets As Boolean, Optional dblAltitude As Double = 0, Optional blnSeaLevelHorizon As Boolean = False)
    'Calculate Moon Rise or set
    Dim dblMidday As Double
    Dim intI As Double
    Dim intDayShift As Integer
    Dim dblORS As Double 'Previous iteration
    Dim dblOORS As Double '2nd previous iteration
    
    'Use the local midday as the initial guess
    Call Meridian(strHBody, lngFix, True, dblMidday)
    dblRiseSetTime = dblMidday
    'Calculate the rise/set time using the position of the Moon at midday
    dblRiseSetTime = RiseSet2(strHBody, 0, dblRiseSetTime, blnSet, blnApparent, blnNeverRises, blnNeverSets, blnSeaLevelHorizon, dblAltitude)
    'If the time is not within half a lunar day of midday, adjust the day
    intDayShift = 0
    If dblRiseSetTime > dblMidday + 0.5 Then
        dblRiseSetTime = dblRiseSetTime - 1
        intDayShift = -1
    ElseIf dblRiseSetTime < dblMidday - 0.5 Then
        dblRiseSetTime = dblRiseSetTime + 1
        intDayShift = 1
    End If
    'Use the new time to calculate the position of the Moon for rise/set
    intI = 0
    While intI < 10 And (intI < 2 Or Square(dblRiseSetTime - dblORS) >= 1 / 1728000 * Abs(dblORS - dblOORS))
        'Allow at least two iterations
        'Exit once it is clear that the next iteration will improve things by less that 1/20 s
        'Quit if over 10 iterations are required
        intI = intI + 1
        dblOORS = dblORS
        dblORS = dblRiseSetTime
        dblRiseSetTime = RiseSet2(strHBody, intDayShift, dblRiseSetTime + intDayShift, blnSet, blnApparent, blnNeverRises, blnNeverSets, blnSeaLevelHorizon, dblAltitude)
    Wend
    'If convergence was not acheived take an average of the last two values
    If (Square(dblRiseSetTime - dblORS) >= 1 / 1728000 * Abs(dblORS - dblOORS)) Then
        dblRiseSetTime = (dblRiseSetTime + dblORS) / 2
    End If
End Sub
Friend Function RiseSet2(strHBody As String, intDayShift As Integer, dblFix As Double, blnSet As Boolean, blnApparent As Boolean, blnNeverRises As Boolean, blnNeverSets As Boolean, blnSeaLevelHorizon As Boolean, dblAltitude As Double) As Double
    Dim dblTheta0 As Double
    Dim udtHbody As HBody
    Dim dblH0 As Double
    Dim dblDip As Double
    Dim cLST As New clsLST
    Dim cHBody As New clsHBody
    Dim cSky As New clsSky
    
    dblTheta0 = cLST.FixToLST(dblFix - intDayShift, False)
    Call cHBody.TrueHBody(strHBody, dblFix - intDayShift, udtHbody)
    Call frmWeather.GetWeatherNow(dblFix - intDayShift, 0, udtWeatherNow)
    If blnApparent Then
        If blnSeaLevelHorizon Then
            dblDip = -udtHbody.Radius + cSky.SeaLevelHorizon(udtWeatherNow)
        Else
            dblDip = -udtHbody.Radius - cHBody.Refract(0, False, udtWeatherNow, udtHbody.RefrValid) + dblAltitude
        End If
    Else
        dblDip = dblAltitude
    End If
    dblH0 = sinD(dblDip) - sinD(udtLocation.dblLatitude) * sinD(udtHbody.DeclTopo) / cosD(udtLocation.dblLatitude) / cosD(udtHbody.DeclTopo)
    If Abs(dblH0) > 1000000# Then 'at pole deal with roungin errors
        blnNeverRises = udtHbody.AltRefr < dblDip Or Not udtHbody.RefrValid
        blnNeverSets = Not blnNeverRises
    Else
        blnNeverRises = dblH0 > 1
        blnNeverSets = dblH0 < -1
    End If
    If dblH0 < -1 Then
        dblH0 = -1
    ElseIf dblH0 > 1 Then
        dblH0 = 1
    End If
    If blnSet Then
        RiseSet2 = FracCirc2(udtHbody.RATopo - dblTheta0 + acosD(dblH0)) / 360 + dblFix
    Else
        RiseSet2 = FracCirc2(udtHbody.RATopo - dblTheta0 - acosD(dblH0)) / 360 + dblFix
    End If
End Function
Friend Sub Meridian(strHBody As String, lngFix As Long, blnNoon As Boolean, dblMeridianTime As Double)
'Find Noon or Midnight for a particular day (lngFix as fixed radix)
    Dim cLST As New clsLST
    Dim dblTheta0 As Double
    Dim udtHbody(3) As HBody
    Dim dblH0 As Double
    Dim dblH As Double
    Dim dblHH As Double
    Dim dblY(3) As Double
    Dim dblAlpha As Double
    Dim dblDelta As Double
    Dim cDeltaT As New clsDeltaT
    Dim dblDip As Double
    Dim udtWeatherNow As WeatherNow
    Dim cHBody As New clsHBody
    
    'Find celestial longitude at meridian at mean solar midday
    dblTheta0 = cLST.FixToLST(lngFix + 0.5 - udtLocation.dblLongitude / 360, False)
    'Find the position of the Sun at mean solar midday and for the days before and after
    Call cHBody.TrueHBody(strHBody, lngFix - 0.5 - udtLocation.dblLongitude / 360, udtHbody(0))
    Call cHBody.TrueHBody(strHBody, lngFix + 0.5 - udtLocation.dblLongitude / 360, udtHbody(1))
    Call cHBody.TrueHBody(strHBody, lngFix + 1.5 - udtLocation.dblLongitude / 360, udtHbody(2))
    'First approximation
    If blnNoon Then
        dblMeridianTime = (udtHbody(1).RATopo - dblTheta0 - udtLocation.dblLongitude) / 360 + 0.5
        'Ensure that Noon is between midnight mean solar time and the next midnight
        While dblMeridianTime < -udtLocation.dblLongitude / 360
            dblMeridianTime = dblMeridianTime + 1
        Wend
        While dblMeridianTime >= 1 - udtLocation.dblLongitude / 360
            dblMeridianTime = dblMeridianTime - 1
        Wend
    Else
        dblMeridianTime = FracCirc(udtHbody(1).RATopo - dblTheta0 - udtLocation.dblLongitude) / 360
        'Ensure that Midnight is between the previous noon mean solar time and this noon
        While dblMeridianTime < -0.5 - udtLocation.dblLongitude / 360
            dblMeridianTime = dblMeridianTime + 1
        Wend
        While dblMeridianTime >= 0.5 - udtLocation.dblLongitude / 360
            dblMeridianTime = dblMeridianTime - 1
        Wend
    End If
    'Interpolate to increase accuracy
    dblY(0) = udtHbody(0).RATopo
    dblY(1) = udtHbody(1).RATopo
    dblY(2) = udtHbody(2).RATopo
    dblAlpha = Interp(dblY, dblMeridianTime + udtLocation.dblLongitude / 360 + 0.5, 3)
    dblY(0) = udtHbody(0).DeclTopo
    dblY(1) = udtHbody(1).DeclTopo
    dblY(2) = udtHbody(2).DeclTopo
    dblDelta = Interp(dblY, dblMeridianTime + udtLocation.dblLongitude / 360 + 0.5, 3)
    dblH = cLST.FixToLST(lngFix + dblMeridianTime, False)
    If Not blnNoon Then dblH = dblH - 180
    dblMeridianTime = dblMeridianTime - (dblH - dblAlpha) / 360 + lngFix
End Sub
Friend Function MagText(strHBody As String) As String
    Dim udtHbody As HBody
    Dim dblMagn As Double
    Dim dblAppMag As Double
    Dim dblBSky As Double
    Dim dblKA As Double
    Dim dblKOz As Double
    Dim dblKR As Double
    Dim dblKW As Double
    Dim dblXA As Double
    Dim dblXOz As Double
    Dim dblXG As Double
    Dim dblP As Double
    Dim intPrec As Integer
    Dim cSky As New clsSky
    
    Call TrueHBody(strHBody, dblDate + dblTime, udtHbody)
    dblMagn = Magnitude(strHBody, udtHbody)
    MagText = strHBody & "'s magnitude above the atmosphere " & Format(dblMagn, strFormat(lngPrecision + 1))
    If udtHbody.RefrValid Then
        dblAppMag = dblMagn + cSky.DeltaM(dblDate + dblTime, udtHbody.AltTopo, udtHbody.AzTopo, 2)
        MagText = MagText & vbCrLf & "From the ground " & Format(dblAppMag, strFormat(lngPrecision + 1))
        dblBSky = cSky.BSky(dblDate + dblTime, udtHbody.AltRefr, udtHbody.AzTopo, 2)
        intPrec = -Int(Log10(dblBSky)) + lngPrecision + 1
        If intPrec < 0 Then intPrec = 0
        MagText = MagText & vbCrLf & "Sky brightness " & Format(dblBSky, strFormat(intPrec)) & " cd/m^2"
        MagText = MagText & vbCrLf & "Lg(B) " & Format(Log10(dblBSky), strFormat(lngPrecision + 1))
        dblP = HBProbVis(strHBody, dblDate + dblTime)
        intPrec = -Int(Log10(dblP)) + lngPrecision - 1
        If dblP > 0.99 And dblP < 0.99999999 Then intPrec = -Int(Log10(1 - dblP)) + lngPrecision - 1
        If intPrec > 8 Then intPrec = 8
        If lngPrecision = 0 Then intPrec = 0
        MagText = MagText & vbCrLf & "Probability of visibility" & Format(dblP * 100, strFormat(intPrec)) & "%"
    Else
        MagText = MagText & vbCrLf & "The " & strHBody & " is well below the horizon."
    End If
End Function
Friend Function HBProbVis(strHBody As String, dblFix As Double) As Double
    Dim udtHbody As HBody
    Dim udtSun As HBody
    Dim dblMagn As Double
    Dim dblAppMag As Double
    Dim dblBSky As Double
    Dim dblKA As Double
    Dim dblKOz As Double
    Dim dblKR As Double
    Dim dblKW As Double
    Dim dblXA As Double
    Dim dblXOz As Double
    Dim dblXG As Double
    Dim dblP As Double
    Dim dblSubtend As Double
    Dim dblSubtendOuter As Double
    Dim dblUsefulWidth As Double
    Dim dblLogB As Double
    Dim dblAlpha As Double
    Dim dblSubtendInner As Double
    Dim dblPerimeter As Double
    Dim dblAngle As Double
    Dim dblAltitude As Double
    Dim dblAzimuth As Double
    Dim dblAltRefr As Double
    Dim cSky As New clsSky
    Dim cMoon As New clsMoon
    Const SFactor = 2.4
    
    Call frmWeather.GetWeatherNow(dblFix, 0, udtWeatherNow)
    Call TrueHBody(strHBody, dblFix, udtHbody)
    Call TrueHBody("Sun", dblFix, udtSun)
    dblMagn = Magnitude(strHBody, udtHbody)
    If udtHbody.RefrValid Then
        If strHBody = "Moon" Then
            Call cMoon.BrightLimb(dblFix, dblAngle, dblSubtend, dblAltitude, dblAzimuth, False)
            Call cMoon.BrightLimb(dblFix, dblAngle, dblSubtend, dblAltRefr, dblAzimuth, True)
        Else
            dblAltitude = udtHbody.AltTopo
            dblAltRefr = udtHbody.AltRefr
            dblAzimuth = udtHbody.AzTopo
        End If
        dblAppMag = dblMagn + cSky.DeltaM(dblFix, dblAltitude, dblAzimuth, 2)
        dblBSky = cSky.BSky(dblFix, dblAltitude, dblAzimuth, 2)
        Call cSky.GetK(dblFix, 2, udtSun.RATopo, udtSun.HourAngTopo, dblKA, dblKOz, dblKR, dblKW)
        Call cSky.GetX(dblFix, 2, 90 - dblAltitude, 90 - dblAltRefr, dblXA, dblXOz, dblXG)
        Select Case strHBody
        Case "Sun"
            HBProbVis = cSky.ProbVis(PI * Square(udtHbody.Radius), TPI * udtHbody.Radius, dblBSky, dblAppMag, dblKA, dblXA)
        Case "Moon"
            'Reduce the crescent by more than Danjon suggests because the ends are fainter
            If dblSubtend >= 180 Then
                dblSubtendOuter = 180
            Else
                dblSubtendOuter = 180 - (180 - dblSubtend) * SFactor
                If dblSubtendOuter < 0 Then dblSubtendOuter = 0
            End If
            dblUsefulWidth = cSky.UsefulWidth(dblBSky)
            dblLogB = Log10(dblBSky)
            dblAlpha = acosD(2 * udtHbody.Phase - 1) 'Phase in degrees
            dblSubtendInner = (1 - Square((1 - udtHbody.Phase) * udtHbody.Radius / (udtHbody.Radius - dblUsefulWidth))) / (1 - Square(1 - udtHbody.Phase))
            If dblSubtendInner <= 0 Then
                dblSubtendInner = 0
            Else
                dblSubtendInner = asinD(Sqr(dblSubtendInner)) * 2
            End If
            If dblAlpha <= 90 Then
                dblPerimeter = Abs(El2(tanD(180 - dblSubtendInner / 2), cosD(dblAlpha), 1, Square(cosD(dblAlpha))))
            Else
                dblPerimeter = Abs(El2(tanD(dblSubtendInner / 2), cosD(dblAlpha), 1, Square(cosD(dblAlpha))))
            End If
            dblPerimeter = udtHbody.Radius * (PI * dblSubtendOuter / 180 + 2 * dblPerimeter)
            HBProbVis = cSky.ProbVis(PI * Square(udtHbody.Radius) * udtHbody.Phase, dblPerimeter, dblBSky, dblAppMag, dblKA, dblXA)
        Case Else
            HBProbVis = cSky.ProbVis(0, 0, dblBSky, dblAppMag, dblKA, dblXA)
        End Select
    Else
        HBProbVis = 0
    End If
End Function
Friend Function Magnitude(strHBody As String, udtHbody As HBody) As Double
    Dim dblRD As Double
    Dim dblI As Double
    Dim intI As Integer
    Dim dblY(2) As Double
    Dim intX0 As Integer
    Dim dblDMS As Double
    Dim udtSun As HBody
    Dim varTemp As Variant
    Dim dblT As Double
    Dim dblB As Double
    Dim dblA As Double
    Dim dblBB As Double
    Dim dblL As Double
    Dim dblOmega As Double
    Dim dblU1 As Double
    Dim dblU2 As Double
    Dim dblDU As Double
    Dim cSun As New clsSun
'Calculate the magnitude as seen from above the atmosphere
    Select Case strHBody
    Case "Sun"
        Magnitude = -26.73 + 5 * Log10(udtHbody.DistanceTopo / AU)
    Case "Moon"
        'Calculate the magnitude of the Moon as seen from above the atmosphere
        'Moon's phase in degrees
        dblI = acosD(2 * udtHbody.Phase - 1)
        'Planet's distance from the Sun times distance to planet in AU^2
    '    dblRD = Abs(sinD(udtMoon.ElongationTopo) * udtMoon.DistanceTopo / sinD(180 - udtMoon.ElongationTopo - dblI) * udtMoon.DistanceTopo / AU / AU)
        'Magnitude = -12.73 + 5 * Log10(udtMoon.DistanceTopo / 384400) + 0.026 * dblI + 0.000000004 * Square(Square(dblI))
        If Not blnMoonMagRead Then
            Open "MoonMag.txt" For Input As #1
            For intI = 0 To 180
                varTemp = GetValue(1, "#", "Double", -20, 20)
                If IsNull(varTemp) Then
                    MsgBox "Error in Magnitude: Invalid magnitude in Moon magnitude file"
                    End
                End If
                dblMoonMag(intI) = varTemp
            Next
            Close #1
        End If
        intX0 = Int(dblI) - 0.5
        If intX0 < 0 Then
            dblY(0) = dblMoonMag(1)
            dblY(1) = dblMoonMag(0)
            dblY(2) = dblMoonMag(1)
        Else
            If intX0 > 178 Then intX0 = 178
            dblY(0) = dblMoonMag(intX0)
            dblY(1) = dblMoonMag(intX0 + 1)
            dblY(2) = dblMoonMag(intX0 + 2)
        End If
        Call TrueHBody("Sun", dblDate + dblTime, udtSun)
        dblDMS = Sqr(Square(udtHbody.DistanceTopo) + Square(udtSun.DistanceTopo) - 2 * udtHbody.DistanceTopo * udtSun.DistanceTopo * cosD(udtHbody.ElongationTopo)) / 149597870
        Magnitude = Interp(dblY, dblI - intX0, 3) + 5 * Log10(udtHbody.DistanceTopo / 384400 * dblDMS)
    Case "Mercury", "Venus", "Mars", "Jupiter", "Saturn"
        'Planet's phase in degrees
        dblI = acosD(2 * udtHbody.Phase - 1)
        'Planet's distance from the Sun times distance to planet in AU^2
        dblRD = Abs(sinD(udtHbody.ElongationTopo) * udtHbody.DistanceTopo / sinD(180 - udtHbody.ElongationTopo - dblI) * udtHbody.DistanceTopo / AU / AU)
        Select Case strHBody
        Case "Mercury"
            Magnitude = 1.16 + 5 * Log10(dblRD) + (dblI - 50) * (0.02838 + (dblI - 50) * 0.0001023)
        Case "Venus"
            Magnitude = -4# + 5 * Log10(dblRD) + dblI * (0.01322 + dblI * dblI * 0.0000004247)
        Case "Mars"
            Magnitude = -1.3 + 5 * Log10(dblRD) + dblI * 0.01486
        Case "Jupiter"
            Magnitude = -8.93 + 5 * Log10(dblRD)
        Case "Saturn"
            dblT = ToJ2000(dblDate + dblTime)
            dblI = 28.075216 - 0.012998 * (dblT - 0.000004 * dblT)
            dblOmega = 169.50847 + 1.394681 * (dblT + 0.000412 * dblT)
            dblB = asinD(sinD(dblI) * cosD(udtHbody.EclDecl) * sinD(udtHbody.EclLong - dblOmega) - cosD(dblI) * sinD(udtHbody.EclDecl))
            dblA = 375.35 / 3600 / udtHbody.DistanceGeo * AU
            dblBB = dblA * sinD(Abs(dblB))
            dblL = udtSaturnSave.L - 0.01759 / udtSaturnSave.R
            dblBB = dblBB - 0.000764 * cosD(udtSaturnSave.L - 113.6655 - 0.8771 * dblT) / udtSaturnSave.R
            dblU1 = atn2D(sinD(dblI) * sinD(dblBB) + cosD(dblI) * cosD(dblBB) * sinD(dblL - dblOmega), cosD(dblBB) * cosD(dblL - dblOmega))
            dblU2 = atn2D(sinD(dblI) * sinD(udtHbody.EclDecl) + cosD(dblI) * cosD(udtHbody.EclDecl) * sinD(udtHbody.EclLong - dblOmega), cosD(udtHbody.EclDecl) * cosD(udtHbody.EclLong - dblOmega))
            dblDU = Abs(dblU1 - dblU2)
            Magnitude = -8.68 + 5 * Log10(dblRD) + 0.044 * Abs(dblDU) - 2.6 * sinD(Abs(dblB)) + 1.25 * Square(sinD(dblB))
        End Select
    Case Else
        intI = 0
        While intI < intNStars - 1 And strHBody <> udtStar(intI).strName
            intI = intI + 1
        Wend
        If strHBody <> udtStar(intI).strName Then
            MsgBox ("Error in Magnitude: Invalud strHBody")
            End
        End If
        Magnitude = udtStar(intI).dblMag + 5 * Log10(udtHbody.DistanceGeo / udtStar(intI).dblDist / 30856800000000#)
    End Select
End Function
Function El2(dblX As Double, dblQQC As Double, dblAA As Double, dblBB As Double) As Double
    Const CA = 0.0003
    Const CB = 1000000000#
    Dim dblA As Double
    Dim dblB As Double
    Dim dblC As Double
    Dim dblD As Double
    Dim dblE As Double
    Dim dblF As Double
    Dim dblG As Double
    Dim dblEM As Double
    Dim dblEye As Double
    Dim dblP As Double
    Dim dblQC As Double
    Dim dblY As Double
    Dim dblZ As Double
    Dim dblL As Integer
    Dim blnDone As Boolean
    
    If dblX = 0 Then
        El2 = 0
    ElseIf dblQQC <> 0 Then
        dblQC = dblQQC
        dblA = dblAA
        dblB = dblBB
        dblC = dblX * dblX
        dblD = 1 + dblC
        dblP = Sqr((1 + dblC * dblQC * dblQC) / dblD)
        dblD = dblX / dblD
        dblC = dblD / (dblP + dblP)
        dblEye = dblA
        dblZ = dblEye - dblB
        dblA = 0.5 * (dblB + dblA)
        dblY = Abs(1 / dblX)
        dblF = 0
        dblL = 0
        dblEM = 1
        dblQC = Abs(dblQC)
        blnDone = False
        While Not blnDone
            dblB = dblB + dblEye * dblQC
            dblE = dblEM * dblQC
            dblG = dblE / dblP
            dblD = dblD + dblF * dblG
            dblF = dblC
            dblEye = dblA
            dblP = dblP + dblG
            dblC = 0.5 * (dblD / dblP + dblC)
            dblG = dblEM
            dblEM = dblEM + dblQC
            dblA = 0.5 * (dblB / dblEM + dblA)
            dblY = dblY - dblE / dblY
            If dblY = 0 Then dblY = Sqr(dblE) * CB
            If Abs(dblG - dblQC) <= CA * dblG Then
                blnDone = True
            Else
                dblQC = Sqr(dblE) * 2
                dblL = dblL * 2
                If dblY < 0 Then dblL = dblL + 1
            End If
        Wend
        If dblY < 0 Then dblL = dblL + 1
        dblE = (Atn(dblEM / dblY) + PI * dblL) * dblA / dblEM
        If dblX < 0 Then dblE = -dblE
        El2 = dblE + dblC * dblZ
    Else
        MsgBox ("Bad dblQQC in El2.")
    End If
End Function
Friend Function EclipticCoordinates(strHBody As String) As String
'Return coordinates as string
    Dim udtHbody As HBody
    Dim udtDms As DMS
    Dim cDMS As New clsDMS
    
    Call TrueHBody(strHBody, dblDate + dblTime, udtHbody)
    Call cDMS.ToDMS(udtHbody.EclLong, udtDms)
    EclipticCoordinates = strHBody & "'s geocentric ecliptic coordinates" & vbCrLf & "Longitude " & udtDms.intDegreesHours & "" & udtDms.intMinutes & "'" & Format(udtDms.dblSeconds, strFormat(lngPrecision)) & """" & vbCrLf
    Call cDMS.ToDMS(udtHbody.EclDecl, udtDms)
    EclipticCoordinates = EclipticCoordinates & "Declination "
    If Not udtDms.blnSign Then EclipticCoordinates = EclipticCoordinates & "-"
    EclipticCoordinates = EclipticCoordinates & udtDms.intDegreesHours & "" & udtDms.intMinutes & "'" & Format(udtDms.dblSeconds, strFormat(lngPrecision)) & """"
End Function
Friend Function EquatorialCoordinates(strHBody As String) As String
'Return coordinates as string
    Dim udtHbody As HBody
    Dim udtDms As DMS
    Dim cDMS As New clsDMS
    
    Call TrueHBody(strHBody, dblDate + dblTime, udtHbody)
    Call cDMS.ToDMS(udtHbody.RAGeo, udtDms)
    EquatorialCoordinates = strHBody & "'s geocentric equatorial coordinates" & vbCrLf & "Right ascension " & udtDms.intDegreesHours & "" & udtDms.intMinutes & "'" & Format(udtDms.dblSeconds, strFormat(lngPrecision)) & """" & vbCrLf
    Call cDMS.ToDMS(udtHbody.RAGeo / 15, udtDms)
    EquatorialCoordinates = EquatorialCoordinates & "              = " & udtDms.intDegreesHours & "h" & udtDms.intMinutes & "m" & Format(udtDms.dblSeconds, strFormat(lngPrecision + 1)) & "s" & vbCrLf
    Call cDMS.ToDMS(udtHbody.DeclGeo, udtDms)
    EquatorialCoordinates = EquatorialCoordinates & "Declination "
    If Not udtDms.blnSign Then EquatorialCoordinates = EquatorialCoordinates & "-"
    EquatorialCoordinates = EquatorialCoordinates & udtDms.intDegreesHours & "" & udtDms.intMinutes & "'" & Format(udtDms.dblSeconds, strFormat(lngPrecision)) & """" & vbCrLf
    Call cDMS.ToDMS(udtHbody.RATopo, udtDms)
    EquatorialCoordinates = EquatorialCoordinates & strHBody & "'s topocentric equatorial coordinates" & vbCrLf & "Right ascension " & udtDms.intDegreesHours & "" & udtDms.intMinutes & "'" & Format(udtDms.dblSeconds, strFormat(lngPrecision)) & """" & vbCrLf
    Call cDMS.ToDMS(udtHbody.RATopo / 15, udtDms)
    EquatorialCoordinates = EquatorialCoordinates & "              = " & udtDms.intDegreesHours & "h" & udtDms.intMinutes & "m" & Format(udtDms.dblSeconds, strFormat(lngPrecision + 1)) & "s" & vbCrLf
    Call cDMS.ToDMS(udtHbody.DeclTopo, udtDms)
    EquatorialCoordinates = EquatorialCoordinates & "Declination "
    If Not udtDms.blnSign Then EquatorialCoordinates = EquatorialCoordinates & "-"
    EquatorialCoordinates = EquatorialCoordinates & udtDms.intDegreesHours & "" & udtDms.intMinutes & "'" & Format(udtDms.dblSeconds, strFormat(lngPrecision)) & """"
End Function
Friend Function HorizonCoordinates(strHBody As String) As String
'Return coordinates as string
    Dim udtHbody As HBody
    Dim udtDms As DMS
    Dim cDMS As New clsDMS
    
    Call TrueHBody(strHBody, dblDate + dblTime, udtHbody)
    Call cDMS.ToDMS(udtHbody.AzGeo, udtDms)
    HorizonCoordinates = strHBody & "'s geocentric horizon coordinates" & vbCrLf & "Azimuth " & udtDms.intDegreesHours & "" & udtDms.intMinutes & "'" & Format(udtDms.dblSeconds, strFormat(lngPrecision)) & """" & vbCrLf
    Call cDMS.ToDMS(udtHbody.AltGeo, udtDms)
    HorizonCoordinates = HorizonCoordinates & "Altitude "
    If Not udtDms.blnSign Then HorizonCoordinates = HorizonCoordinates & "-"
    HorizonCoordinates = HorizonCoordinates & udtDms.intDegreesHours & "" & udtDms.intMinutes & "'" & Format(udtDms.dblSeconds, strFormat(lngPrecision)) & """" & vbCrLf
    Call cDMS.ToDMS(udtHbody.AzTopo, udtDms)
    HorizonCoordinates = HorizonCoordinates & strHBody & "'s topocentric horizon coordinates" & vbCrLf & "Azimuth " & udtDms.intDegreesHours & "" & udtDms.intMinutes & "'" & Format(udtDms.dblSeconds, strFormat(lngPrecision)) & """" & vbCrLf
    Call cDMS.ToDMS(udtHbody.AltTopo, udtDms)
    HorizonCoordinates = HorizonCoordinates & "Altitude "
    If Not udtDms.blnSign Then HorizonCoordinates = HorizonCoordinates & "-"
    HorizonCoordinates = HorizonCoordinates & udtDms.intDegreesHours & "" & udtDms.intMinutes & "'" & Format(udtDms.dblSeconds, strFormat(lngPrecision)) & """" & vbCrLf
    If udtHbody.RefrValid Then
        Call cDMS.ToDMS(udtHbody.AltRefr, udtDms)
        HorizonCoordinates = HorizonCoordinates & "After correction for refraction" & vbCrLf & "Altitude "
        If Not udtDms.blnSign Then HorizonCoordinates = HorizonCoordinates & "-"
        HorizonCoordinates = HorizonCoordinates & udtDms.intDegreesHours & "" & udtDms.intMinutes & "'"
        If udtHbody.AltRefr >= 1 Then
            HorizonCoordinates = HorizonCoordinates & Format(udtDms.dblSeconds, strFormat(lngPrecision)) & """"
        ElseIf lngPrecision > 0 Then
            HorizonCoordinates = HorizonCoordinates & Format(udtDms.dblSeconds, strFormat(lngPrecision - 1)) & """"
        End If
    Else
        HorizonCoordinates = HorizonCoordinates & "The " & strHBody & " is well below the horizon so refraction cannot be calculated."
    End If
End Function
Friend Function Rise(strHBody As String) As String
'Return object rise for that day
    Dim dblRiseSetTime As Double
    Dim blnNeverSets As Boolean
    Dim blnNeverRises As Boolean
    Dim intDays As Integer
    Dim udtDms As DMS
    Dim lngFix As Long
    Dim cDMS As New clsDMS
    Dim cMoon As New clsMoon
    Dim udtDateOut As MyDate
    Dim udtTimeOut As Mytime
    Dim blnValid As Boolean
    Dim strOldDate As String
    Dim strDate As String
    
    strOldDate = ""
    blnValid = True
    lngFix = frmDate.ToLngDate(dblDate + dblTime)
    Call RiseSet(strHBody, lngFix, False, dblRiseSetTime, False, blnNeverRises, blnNeverSets)
    If blnNeverSets Then
        Rise = "No geometric " & strHBody & "set" & vbCrLf & "Minimum altitude at "
    ElseIf blnNeverRises Then
        Rise = "No geometric " & strHBody & "rise" & vbCrLf & "Maximum altitude at "
    Else
        Rise = "Geometric " & strHBody & "rise "
    End If
    Call frmMain.ToDateTime(CorrectTime(dblRiseSetTime, lngPrecision), udtDateOut, udtDate.enmDateType, udtTimeOut, udtTime.enmTimeType, blnValid)
    Rise = Rise & frmDate.WriteDateTime(udtDateOut, udtTimeOut, strOldDate, CInt(lngPrecision))
    If Not blnNeverSets Then
        Call RiseSet(strHBody, lngFix, False, dblRiseSetTime, True, blnNeverRises, blnNeverSets)
        If blnNeverSets Then
            Rise = Rise & vbCrLf & "No apparent " & strHBody & "set over flat horizon" & vbCrLf & "Minimum altitude at "
        ElseIf blnNeverRises Then
            Rise = Rise & vbCrLf & "No apparent " & strHBody & "rise over flat horizon" & vbCrLf & "Maximum altitude at "
        Else
            Rise = Rise & vbCrLf & "Apparent " & strHBody & "rise over flat horizon "
        End If
        Call frmMain.ToDateTime(CorrectTime(dblRiseSetTime, lngPrecision - 1), udtDateOut, udtDate.enmDateType, udtTimeOut, udtTime.enmTimeType, blnValid)
        Rise = Rise & frmDate.WriteDateTime(udtDateOut, udtTimeOut, strOldDate, lngPrecision - 1)
        If Not blnNeverSets Then
            Call RiseSet(strHBody, lngFix, False, dblRiseSetTime, True, blnNeverRises, blnNeverSets, 0, True)
            If blnNeverSets Then
                Rise = Rise & vbCrLf & "No apparent " & strHBody & "set over sea level horizon" & vbCrLf & "Minimum altitude at "
            ElseIf blnNeverRises Then
                Rise = Rise & vbCrLf & "No apparent " & strHBody & "rise over sea level horizon" & vbCrLf & "Maximum altitude at "
            Else
                Rise = Rise & vbCrLf & "Apparent " & strHBody & "rise over sea level horizon "
            End If
            Call frmMain.ToDateTime(CorrectTime(dblRiseSetTime, lngPrecision - 1), udtDateOut, udtDate.enmDateType, udtTimeOut, udtTime.enmTimeType, blnValid)
            Rise = Rise & frmDate.WriteDateTime(udtDateOut, udtTimeOut, strOldDate, lngPrecision - 1)
        End If
    End If
End Function
Friend Function HBSet(strHBody As String) As String
'Return object set for that day
    Dim dblRiseSetTime As Double
    Dim blnNeverSets As Boolean
    Dim blnNeverRises As Boolean
    Dim intDays As Integer
    Dim udtDms As DMS
    Dim lngFix As Long
    Dim cDMS As New clsDMS
    Dim cMoon As New clsMoon
    Dim udtDateOut As MyDate
    Dim udtTimeOut As Mytime
    Dim blnValid As Boolean
    Dim strOldDate As String
    
    strOldDate = ""
    blnValid = True
    lngFix = frmDate.ToLngDate(dblDate + dblTime)
    Call RiseSet(strHBody, lngFix, True, dblRiseSetTime, False, blnNeverRises, blnNeverSets)
    If blnNeverSets Then
        HBSet = "No geometric " & strHBody & "set" & vbCrLf & "Minimum altitude at "
    ElseIf blnNeverRises Then
        HBSet = "No geometric " & strHBody & "rise" & vbCrLf & "Maximum altitude at "
    Else
        HBSet = "Geometric " & strHBody & "set "
    End If
    Call frmMain.ToDateTime(CorrectTime(dblRiseSetTime, lngPrecision), udtDateOut, udtDate.enmDateType, udtTimeOut, udtTime.enmTimeType, blnValid)
    HBSet = HBSet & frmDate.WriteDateTime(udtDateOut, udtTimeOut, strOldDate, CInt(lngPrecision))
    If Not blnNeverSets Then
        Call RiseSet(strHBody, lngFix, True, dblRiseSetTime, True, blnNeverRises, blnNeverSets)
        If blnNeverSets Then
            HBSet = HBSet & vbCrLf & "No apparent " & strHBody & "set over flat horizon" & vbCrLf & "Minimum altitude at "
        ElseIf blnNeverRises Then
            HBSet = HBSet & vbCrLf & "No apparent " & strHBody & "rise over flat horizon" & vbCrLf & "Maximum altitude at "
        Else
            HBSet = HBSet & vbCrLf & "Apparent " & strHBody & "set over flat horizon"
        End If
        Call frmMain.ToDateTime(CorrectTime(dblRiseSetTime, lngPrecision - 1), udtDateOut, udtDate.enmDateType, udtTimeOut, udtTime.enmTimeType, blnValid)
        HBSet = HBSet & frmDate.WriteDateTime(udtDateOut, udtTimeOut, strOldDate, lngPrecision - 1)
        If Not blnNeverSets And udtLocation.dblHeight >= 0 Then
        Call RiseSet(strHBody, lngFix, True, dblRiseSetTime, True, blnNeverRises, blnNeverSets, 0, True)
            If blnNeverSets Then
                HBSet = HBSet & vbCrLf & "No apparent " & strHBody & "set over sea level horizon" & vbCrLf & "Minimum altitude at "
            ElseIf blnNeverRises Then
                HBSet = HBSet & vbCrLf & "No apparent " & strHBody & "rise over sea level horizon" & vbCrLf & "Maximum altitude at "
            Else
                HBSet = HBSet & vbCrLf & "Apparent " & strHBody & "set over sea level horizon"
            End If
            Call frmMain.ToDateTime(CorrectTime(dblRiseSetTime, lngPrecision - 1), udtDateOut, udtDate.enmDateType, udtTimeOut, udtTime.enmTimeType, blnValid)
            HBSet = HBSet & frmDate.WriteDateTime(udtDateOut, udtTimeOut, strOldDate, lngPrecision - 1)
        End If
    End If
End Function
Friend Sub Visibility(strHBody As String, lngFix As Long, blnEvening As Boolean, dblQ As Double, dblT() As Double, blnEasy As Boolean, blnNotVisible As Boolean, dblProbVis As Double, Optional blnTopo As Boolean = False, Optional blnPhotometric As Boolean = False, Optional blnNeverRises As Boolean)
'Calculates when the Moon is first and last visible
'The result is returned in array dblT
'dblT(0) = time of first possible visibility of New Moon
'dblt(1) = time of first definate visibility of New Moon
'dblT(2) = time of last definate visibility of New Moon
'dblt(3) = time of last possible visibility of New Moon
'dblT(4) = time of rising
'dblT(5) = time of setting
'For our purposes: Possible = 2.5% probability; Definate = 97.5% probability

    Dim dblAltitude As Double
    Dim blnNeverSets As Boolean
    Dim cSun As New clsSun
    Dim dblBestTime As Double
    Dim dblARCV As Double
    Dim dblWp As Double
    Dim dblLowH As Double 'Average altitude where the Moon disappears
    Dim intI As Integer
    Dim udtSun(1) As HBody
    Dim dblP(4) As Double
    Dim dblRise As Double
    Dim dblSet As Double
    Dim intadd As Integer
    Dim intHBody As Integer
    Dim dblLim As Double
    Dim cMoon As New clsMoon
    Dim dblMeridianTime As Double
    
    blnCancel = False
    Select Case intNIntegrals
    Case 16
        dblLim = 0.02
    Case 32
        dblLim = 0.01
    Case 64
        dblLim = 0.005
    Case Else
        dblLim = 0.001
    End Select
    Select Case strHBody
        Case "Moon"
            intHBody = 0
        Case "Sun"
            intHBody = 1
        Case "Mercury"
            intHBody = 2
        Case "Venus"
            intHBody = 3
        Case "Mars"
            intHBody = 4
        Case "Jupiter"
            intHBody = 5
        Case "Saturn"
            intHBody = 6
    End Select
    If udtVisibilitySave(intHBody).blnUpdated And blnTopo = udtVisibilitySave(intHBody).blnTopo And blnPhotometric = udtVisibilitySave(intHBody).blnPhotometric Then
        For intI = 0 To 5
            dblT(intI) = udtVisibilitySave(intHBody).dblT(intI)
        Next
        dblQ = udtVisibilitySave(intHBody).dblQ
        blnEasy = udtVisibilitySave(intHBody).blnEasy
        blnNotVisible = udtVisibilitySave(intHBody).blnNotVisible
        dblProbVis = udtVisibilitySave(intHBody).dblProbVis
        blnEvening = udtVisibilitySave(intHBody).blnNew
        blnPhotometric = udtVisibilitySave(intHBody).blnPhotometric
        blnNeverRises = udtVisibilitySave(intHBody).blnNeverRises
    Else
        udtVisibilitySave(intHBody).blnUpdated = True
        blnChangedInput = False
        Call Meridian(strHBody, lngFix, True, dblMeridianTime)
        intadd = Int(lngFix - udtLocation.dblLongitude / 360 - dblMeridianTime) + 1
        Call RiseSet(strHBody, lngFix + intadd, False, dblRise, True, blnNeverRises, blnNeverSets, True, 0)
        Call RiseSet(strHBody, lngFix + intadd, True, dblSet, True, blnNeverRises, blnNeverSets, True, 0)
        If dblSet <= dblRise And (dblRise + dblSet) / 2 > dblMeridianTime Then
            intadd = intadd - 1
            Call RiseSet(strHBody, lngFix + intadd, False, dblRise, True, blnNeverRises, blnNeverSets, True, 0)
            If dblSet - dblRise > 1.8 Then 'Unusual case where a day is skipped when the object does not set
                Call RiseSet(strHBody, lngFix + intadd, True, dblRise, True, blnNeverRises, blnNeverSets, True, 0)
            End If
        ElseIf dblSet <= dblRise And (dblRise + dblSet) / 2 <= dblMeridianTime Then
            intadd = intadd + 1
            Call RiseSet(strHBody, lngFix + intadd, True, dblSet, True, blnNeverRises, blnNeverSets, True, 0)
            If dblSet - dblRise > 1.8 Then 'Unusual case where a day is skipped when the object does not set
                Call RiseSet(strHBody, lngFix + intadd, False, dblRise, True, blnNeverRises, blnNeverSets, True, 0)
            End If
        End If
'Debug.Print dblRise - dblMeridianTime, dblSet - dblMeridianTime
        If blnNeverRises Then
            blnNotVisible = True
            blnEasy = False
            dblProbVis = 0
        Else
        End If
        If Not blnNeverRises And Not blnPhotometric And strHBody = "Moon" Then
            If blnTopo Then
                Call cMoon.QT(lngFix, dblQ, blnEvening, dblBestTime, dblARCV, dblWp)
            Else
                Call cMoon.YallopQ(lngFix, dblQ, blnEvening, dblBestTime, dblARCV, dblWp)
            End If
            If Not blnEvening Then dblAltitude = dblAltitude + 0.8528
            blnNotVisible = dblQ < -1 Or dblQ < -0.1 And Not blnTopo
            blnEasy = dblQ > 30 Or dblQ > 3 And Not blnTopo
            If blnNotVisible Then
                dblT(0) = dblBestTime
                dblT(1) = dblBestTime
                dblT(2) = dblBestTime
                dblT(3) = dblBestTime
                dblProbVis = 0
            ElseIf blnEasy Then
                dblProbVis = 1
            Else
                If blnTopo Then
                    'dblAltitude = -6.444 + dblQ * (0.7039 - dblQ * (0.02572 - dblQ * 0.0004311)) + 0.713 - 0.9268 * dblWp
                    dblAltitude = -5.2003 + dblQ * 0.3302
                    dblLowH = 2.8 * Exp(-0.4 * dblQ) + 1.5
                Else
                    'dblAltitude = -5.9102 + dblQ * (5.7094 - dblQ * (1.4788 - dblQ * 0.1813)) + 0.8609 - 0.9835 * dblWp
                    dblAltitude = -5.2058 + dblQ * 3.3852
                    dblLowH = 2.8 * Exp(-4 * dblQ) + 1.5
                End If
                Call RiseSet("Sun", lngFix, blnEvening, dblT(0), False, blnNeverRises, blnNeverSets, dblAltitude + 2.538, False)
                If blnNeverRises Then
                    Call RiseSet("Moon", lngFix, Not blnEvening, dblT(0), False, blnNeverRises, blnNeverSets, dblLowH - 1.645, False)
                End If
                Call RiseSet("Sun", lngFix, blnEvening, dblT(1), False, blnNeverRises, blnNeverSets, dblAltitude - 2.538, False)
                If blnNeverRises Then
                    Call RiseSet("Moon", lngFix, Not blnEvening, dblT(1), False, blnNeverRises, blnNeverSets, dblLowH + 1.645, False)
                End If
                Call RiseSet("Moon", lngFix, blnEvening, dblT(2), False, blnNeverRises, blnNeverSets, dblLowH + 1.645, False)
                Call RiseSet("Moon", lngFix, blnEvening, dblT(3), False, blnNeverRises, blnNeverSets, dblLowH - 1.645, False)
                Call TrueHBody("Sun", (dblT(2) + dblT(3)) / 2, udtSun(1))
                dblProbVis = Prob((dblAltitude - udtSun(1).AltTopo) / 1.52)
                If dblT(0) < dblT(3) And Not blnEvening Or dblT(0) > dblT(3) And blnEvening Then
                    dblT(0) = dblBestTime
                    blnNotVisible = True
                End If
                If Not blnEvening Then 'reverse first and last visibility
                    dblT(4) = dblT(0) 'Use dblT(4) as workspace
                    dblT(0) = dblT(3)
                    dblT(3) = dblT(4)
                    dblT(4) = dblT(1)
                    dblT(1) = dblT(2)
                    dblT(2) = dblT(4)
                End If
            End If
            dblT(4) = dblRise
            dblT(5) = dblSet
        Else
            blnEasy = False
            If strHBody = "Sun" Then
                blnEvening = True
            Else
                blnEvening = EveningSight(strHBody, lngFix)
            End If
            If strHBody = "Moon" Then Call cMoon.YallopQ(lngFix, dblQ, blnEvening, dblBestTime, dblARCV, dblWp)
            blnEasy = False
            If Not blnNeverRises Then
                frmProgress.Show
                frmProgress.lblMessage = "Calculating " & strHBody & " 0%"
                frmProgress.Refresh
                frmProgress.SetFocus
                dblP(2) = FindP(strHBody, dblRise, dblSet, 1.1, dblLim, dblT(2)) 'Highest probability                    frmProgress.lblMessage = "Calculating " & strHBody & " 20%"
                frmProgress.lblMessage = "Calculating " & strHBody & " 20%"
                frmProgress.Refresh
                frmProgress.SetFocus
                dblProbVis = dblP(2)
                If dblP(2) < 0.05 Then
                    dblP(0) = dblP(2)
                    dblT(0) = dblT(2)
                    dblP(1) = dblP(2)
                    dblT(1) = dblT(2)
                    dblP(3) = dblP(2)
                    dblT(3) = dblT(2)
                    dblP(4) = dblP(2)
                    dblT(4) = dblT(2)
                    blnNotVisible = True
                Else
                    dblP(0) = HBProbVis(strHBody, dblRise)
                    If dblP(0) < 0.05 Then
                        dblP(0) = FindP(strHBody, dblRise, dblT(2), 0.05, dblLim, dblT(0)) 'First chance of seeing
                    Else
                        dblT(0) = dblRise
                    End If
                    frmProgress.lblMessage = "Calculating " & strHBody & " 40%"
                    frmProgress.Refresh
                    frmProgress.SetFocus
                    dblP(4) = HBProbVis(strHBody, dblSet)
                    If dblP(4) < 0.05 Then
                        dblP(4) = FindP(strHBody, dblT(2), dblSet, 0.05, dblLim, dblT(4)) 'First chance of seeing
                    Else
                        dblT(4) = dblSet
                    End If
                    frmProgress.lblMessage = "Calculating " & strHBody & " 60%"
                    frmProgress.Refresh
                    frmProgress.SetFocus
                    If dblP(2) < 0.95 Then
                        dblP(1) = dblP(2)
                        dblT(1) = dblT(2)
                        dblP(3) = dblP(2)
                        dblT(3) = dblT(2)
                    Else
                        dblP(1) = HBProbVis(strHBody, dblRise)
                        If dblP(1) > 0.95 Then
                            dblT(1) = dblRise
                        Else
                            dblP(1) = FindP(strHBody, dblT(0), dblT(2), 0.95, dblLim, dblT(1)) 'First chance of seeing
                        End If
                        frmProgress.lblMessage = "Calculating " & strHBody & " 80%"
                        frmProgress.Refresh
                        frmProgress.SetFocus
                        dblP(3) = HBProbVis(strHBody, dblSet)
                        If dblP(3) > 0.95 Then
                            dblT(3) = dblSet
                        Else
                            dblP(3) = FindP(strHBody, dblT(2), dblT(4), 0.95, dblLim, dblT(3)) 'First chance of seeing
                        End If
                        frmProgress.lblMessage = "Calculating " & strHBody & " 100%"
                        frmProgress.Refresh
                        frmProgress.SetFocus
                    End If
                    dblT(2) = dblT(3)
                    dblT(3) = dblT(4)
                End If
                dblT(4) = dblRise
                dblT(5) = dblSet
                frmProgress.Hide
            End If
        End If
        udtVisibilitySave(intHBody).lngFix = lngFix
        udtVisibilitySave(intHBody).blnTopo = blnTopo
        For intI = 0 To 5
            udtVisibilitySave(intHBody).dblT(intI) = dblT(intI)
        Next
        udtVisibilitySave(intHBody).dblQ = dblQ
        udtVisibilitySave(intHBody).blnEasy = blnEasy
        udtVisibilitySave(intHBody).blnNotVisible = blnNotVisible
        udtVisibilitySave(intHBody).dblProbVis = dblProbVis
        udtVisibilitySave(intHBody).blnNew = blnEvening
        udtVisibilitySave(intHBody).blnPhotometric = blnPhotometric
        udtVisibilitySave(intHBody).blnNeverRises = blnNeverRises
    End If
End Sub
Function FindP(strHBody As String, dblTMin As Double, dblTMax As Double, dblPTarget As Double, Optional dblLim As Double = 0.001, Optional dblFindT As Double) As Double
    Dim dblP(4) As Double
    Dim dblT(4) As Double
    Dim intI As Integer
    Dim blnDone As Boolean
    Dim blnOneSide As Boolean
    Dim intStart As Integer
    Dim intEnd As Integer
    Dim intIter As Integer
    Dim intNPoints As Integer
    Dim intLess As Integer '-1 less, 1 more
    Dim blnEvening As Boolean
    Dim dblSunRiseSet As Double
    Dim intadd As Integer
    Dim lngFix As Long
    Dim udtHbody As HBody
    Dim blnNeverRises As Boolean
    Dim blnNeverSets As Boolean
    
    lngFix = frmDate.ToLngDate((dblTMin + dblTMax) / 2)
    If dblPTarget > 1 Then 'find maximum
        dblT(0) = dblTMin 'Rise
        dblT(4) = dblTMax 'Set
        If strHBody = "Sun" Then 'Set the mid point to midday
            dblT(2) = (dblTMax + dblTMin) / 2
        Else
            blnEvening = EveningSight(strHBody, lngFix)
            Call RiseSet("Sun", lngFix, blnEvening, dblSunRiseSet, False, blnNeverRises, blnNeverSets)
            'calculate Sunrise or Sunset
            'If it is the wrong day, select the correct day
            intadd = 0
            While dblSunRiseSet > (dblTMin + dblTMax) / 2 + 1
                intadd = intadd - 1
                Call RiseSet("Sun", lngFix + intadd, blnEvening, dblSunRiseSet, False, blnNeverRises, blnNeverSets)
            Wend
            While dblSunRiseSet < (dblTMin + dblTMax) / 2 - 1
                intadd = intadd + 1
                Call RiseSet("Sun", lngFix + intadd, blnEvening, dblSunRiseSet, False, blnNeverRises, blnNeverSets)
            Wend
            If blnEvening Then 'Set 4/9 from Sunset to object set
                dblT(2) = (4 * dblSunRiseSet + 5 * dblTMax) / 9
            Else 'Set 5/9 from object rise to Sunrise
                dblT(2) = (4 * dblSunRiseSet + 5 * dblTMin) / 9
            End If
            Call TrueHBody(strHBody, dblT(2), udtHbody) 'Find the position at trial optimum time
            If udtHbody.AltTopo < 3 Then 'If it is too low on the horizon
                Call RiseSet(strHBody, lngFix + intadd, blnEvening, dblT(2), False, blnNeverRises, blnNeverSets, 3)
                'Find out when it is high enough
                'If not on the correct day, find the correct day
                While dblT(2) > dblTMax
                    intadd = intadd - 1
                    Call RiseSet(strHBody, lngFix + intadd, blnEvening, dblT(2), False, blnNeverRises, blnNeverSets, 3)
                Wend
                While dblT(2) < dblTMin
                    intadd = intadd + 1
                    Call RiseSet(strHBody, lngFix + intadd, blnEvening, dblT(2), False, blnNeverRises, blnNeverSets, 3)
                Wend
                'If the trial optimum is outside the time period then put it in the middle of the period
                If dblT(2) > dblTMax Then
                    dblT(2) = (dblTMin + dblTMax) / 2
                End If
            End If
        End If
        'Calculate the probabilities
        dblP(0) = HBProbVis(strHBody, dblT(0))
        dblP(2) = HBProbVis(strHBody, dblT(2))
'Debug.Print "Find maximum"
'If dblP(2) - dblP(0) > dblP(2) - dblP(4) Then
'Debug.Print dblP(2) * 100, dblP(2) - dblP(0)
'Else
'Debug.Print dblP(2) * 100, dblP(2) - dblP(4)
'End If
        dblP(4) = HBProbVis(strHBody, dblT(4))
        While dblP(2) - dblP(0) > dblLim Or dblP(2) - dblP(4) > dblLim 'Till no significant change
            'Calculate the mid times between 0 and 2, 2 and 4
            dblT(1) = (dblT(0) + dblT(2)) / 2
            dblP(1) = HBProbVis(strHBody, dblT(1))
            dblT(3) = (dblT(2) + dblT(4)) / 2
            dblP(3) = HBProbVis(strHBody, dblT(3))
            If dblP(2) > dblP(0) And dblP(2) > dblP(1) And dblP(2) > dblP(3) And dblP(2) > dblP(4) Then
                'dblp(3) largest
                dblT(0) = dblT(1)
                dblP(0) = dblP(1)
                dblT(4) = dblT(3)
                dblP(4) = dblP(3)
            ElseIf dblP(1) > dblP(0) And dblP(1) > dblP(2) And dblP(1) > dblP(3) And dblP(1) > dblP(4) Then
                'dblp(1) largest
                dblT(4) = dblT(2)
                dblP(4) = dblP(2)
                dblT(2) = dblT(1)
                dblP(2) = dblP(1)
            ElseIf dblP(3) > dblP(0) And dblP(3) > dblP(1) And dblP(3) > dblP(2) And dblP(3) > dblP(4) Then
                'dblp(3) largest
                dblT(0) = dblT(2)
                dblP(0) = dblP(2)
                dblT(2) = dblT(3)
                dblP(2) = dblP(3)
            ElseIf dblP(0) > dblP(1) And dblP(0) > dblP(2) And dblP(0) > dblP(3) And dblP(0) > dblP(4) Then
                'dblp(0) largest
                dblT(4) = dblT(2)
                dblP(4) = dblP(2)
                dblT(2) = dblT(1)
                dblP(2) = dblP(1)
            Else
                'dblp(4) largest
                dblT(0) = dblT(2)
                dblP(0) = dblP(2)
                dblT(2) = dblT(3)
                dblP(2) = dblP(3)
            End If
'If dblP(2) - dblP(0) > dblP(2) - dblP(4) Then
'Debug.Print dblP(2) * 100, dblP(2) - dblP(0)
'Else
'Debug.Print dblP(2) * 100, dblP(2) - dblP(4)
'End If
        Wend
        FindP = dblP(2)
        dblFindT = dblT(2)
    Else 'Find a crossing point
        'Evaluate extremes
        dblT(0) = dblTMin
        dblT(2) = dblTMax
        dblP(0) = HBProbVis(strHBody, dblT(0))
        dblP(2) = HBProbVis(strHBody, dblT(2))
        'Check if there is a crossing point
'Debug.Print "Find crossing point"
        If dblP(0) > dblPTarget And dblP(2) > dblPTarget Then
            If dblP(0) > dblP(2) Then
                FindP = dblP(2)
                dblFindT = dblT(2)
            Else
                FindP = dblP(0)
                dblFindT = dblT(0)
            End If
'Debug.Print "not found"
        ElseIf dblP(0) < dblPTarget And dblP(2) < dblPTarget Then
            If dblP(0) > dblP(2) Then
                FindP = dblP(0)
                dblFindT = dblT(0)
            Else
                FindP = dblP(2)
                dblFindT = dblT(2)
            End If
'Debug.Print "not found"
        Else 'There is a crossing point
            dblT(1) = (dblTMin + dblTMax) / 2
            dblP(1) = HBProbVis(strHBody, dblT(1))
'Debug.Print dblP(1) * 100, Abs(dblP(1) - dblPTarget)
            While Abs(dblP(1) - dblPTarget) > dblLim
                If dblP(1) >= dblPTarget And dblP(0) < dblPTarget Or dblP(1) <= dblPTarget And dblP(0) > dblPTarget Then
                    dblT(2) = dblT(1)
                    dblP(2) = dblP(1)
                Else
                    dblT(0) = dblT(1)
                    dblP(0) = dblP(1)
                End If
                dblT(1) = (dblT(0) + dblT(2)) / 2
                dblP(1) = HBProbVis(strHBody, dblT(1))
'Debug.Print dblP(1) * 100, Abs(dblP(1) - dblPTarget)
            Wend
            FindP = dblP(1)
            dblFindT = dblT(1)
        End If
    End If
'    intNPoints = 5
'    For intI = 0 To intNPoints - 1
'        dblT(intI) = dblTMin + (dblTMax - dblTMin) * intI / (intNPoints - 1)
'        dblP(intI) = HBProbVis(strHBody, dblT(intI))
'    Next
'    blnDone = False
'    intIter = 0
'    While Not blnDone
'        'If all one side of target then search for max/min
'        intI = 1
'        blnOneSide = True
'        If dblP(0) < dblPTarget Then
'            intLess = -1
'        Else
'            intLess = 1
'        End If
'        'Determine if the target probability occurs within the selected range
'        While intI < intNPoints And blnOneSide
'            If (dblPTarget - dblP(intI)) * intLess >= 0 Then
'                blnOneSide = False
'            Else
'                intI = intI + 1
'            End If
'        Wend
'        'Get turning point
'        If blnOneSide Then
'            intStart = 0
'            For intI = 1 To intNPoints - 1
'                If (dblP(intStart) - dblP(intI)) * intLess > 0 Then intStart = intI
'            Next
'            If intStart = 0 Then
'                intEnd = intStart + 1
'            ElseIf intStart = intNPoints - 1 Then
'                intEnd = intStart
'                intStart = intStart - 1
'            Else
'                'If (dblP(intStart - 1) - dblP(intStart + 1)) * intLess >= 0 Then
'                    intEnd = intStart + 1
'                    intStart = intStart - 1
'                'Else
'                '    intEnd = intStart
'                '    intStart = intStart - 1
'                'End If
'            End If
'            blnDone = (Abs(dblP(intStart) - dblP(intEnd)) <= dblLim Or dblP(intStart) = 1 Or dblP(intEnd) = 1) And intIter > 2
'        End If
'        intIter = intIter + 1
'        If Not blnOneSide Then 'Search for target value
'            If dblP(0) < dblPTarget Then
'                intLess = -1
'            Else
'                intLess = 1
'            End If
'            intEnd = 1
'            While (dblPTarget - dblP(intEnd)) * intLess <= 0
'                intEnd = intEnd + 1
'            Wend
'            intStart = intEnd - 1
'            'Minimum time or minimum probability difference. Minimum time is required for when the
'            'probability difference changes faster than the digital resolution of the time
'            blnDone = Abs(dblPTarget - dblP(intStart)) < dblLim Or dblT(intEnd) - dblT(intStart) < 0.000001
'        End If
'        If Not blnDone Then
'            dblT(0) = dblT(intStart)
'            dblT(intNPoints - 1) = dblT(intEnd)
'            dblP(0) = dblP(intStart)
'            dblP(intNPoints - 1) = dblP(intEnd)
'            If Not blnOneSide And intNPoints = 5 Then
'                If intEnd - intStart = 2 Then
'                    dblT(1) = dblT(intStart + 1)
'                    dblP(1) = dblP(intStart + 1)
'                Else
'                    dblT(1) = (dblT(intStart) + dblT(intEnd)) / 2
'                    dblP(1) = HBProbVis(strHBody, dblT(1))
'                End If
'                dblT(2) = dblT(intNPoints - 1)
'                dblP(2) = dblP(intNPoints - 1)
'                intNPoints = 3
'            ElseIf intEnd - intStart = 2 Then
'                dblT(2) = dblT(intStart + 1)
'                dblP(2) = dblP(intStart + 1)
'                For intI = 1 To intNPoints - 2 Step 2
'                    dblT(intI) = dblT(0) + (dblT(intNPoints - 1) - dblT(0)) * intI / (intNPoints - 1)
'                    dblP(intI) = HBProbVis(strHBody, dblT(intI))
'                Next
'            ElseIf intNPoints = 5 Then
'                For intI = 1 To intNPoints - 2
'                    dblT(intI) = dblT(0) + (dblT(intNPoints - 1) - dblT(0)) * intI / (intNPoints - 1)
'                    dblP(intI) = HBProbVis(strHBody, dblT(intI))
'                Next
'            Else
'                dblT(1) = (dblT(intStart) + dblT(intEnd)) / 2
'                dblP(1) = HBProbVis(strHBody, dblT(1))
'            End If
'        End If
'    Wend
'    If Abs(dblPTarget - dblP(intStart)) < Abs(dblPTarget - dblP(intEnd)) Then
'        FindP = dblP(intStart)
'        dblFindT = dblT(intStart)
'    Else
'        FindP = dblP(intEnd)
'        dblFindT = dblT(intEnd)
'    End If
'    'Debug.Print FindP, (dblFindT - Int(dblFindT)) * 24
End Function



