VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsIslamic"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'(C)Roy E. Hoffman 2000
'See Main.bas for terms and conditions of use
'Most of the algorithms in this module are from
'E. M. Reingold and N. Dershowitz "Calendrical Calculations: The Millenium Edition", Cambridge Univ. Press, Cambridge, UK, 1999.

Const IslamicEpoch = 227015
Function IslamicLeapYear(intYear As Integer) As Boolean
'Is it a leap year
    IslamicLeapYear = MyMod((intYear * 11# + 14), 30) < 11
End Function
Friend Function Islamic_Fixed(udtDate As MyDate) As Long
'Convert an Islamic arithmetic date to fixed radix
    Islamic_Fixed = udtDate.intDateOfMonth + 29 * (udtDate.intMonth - 1) + Int((6 * udtDate.intMonth - 1) / 11) + CLng(udtDate.intYear - 1) * 354 + Int((3 + 11 * CLng(udtDate.intYear)) / 30) + IslamicEpoch - 1
End Function
Friend Sub Fixed_Islamic(lngDate As Long, udtDateOut As MyDate, blnValid As Boolean)
'Convert fixed radix to an Islamic arithmetic date
    Dim intPriorDays As Integer
    Dim lngYear As Long
    Static lastDate As Long
    Static lastDateOut As MyDate
    
    udtDateOut.enmDateType = Islamic
    If lastDate = lngDate And dblDate <> 0 Then
        udtDateOut.intDateOfMonth = lastDateOut.intDateOfMonth
        udtDateOut.intMonth = lastDateOut.intMonth
        udtDateOut.intYear = lastDateOut.intYear
    Else
        lngYear = Int((30 * (lngDate - IslamicEpoch) + 10646) / 10631)
        If Abs(lngYear) > 32765 Then
            blnValid = False
        Else
            udtDateOut.intYear = lngYear
            udtDateOut.intMonth = 1
            udtDateOut.intDateOfMonth = 1
            intPriorDays = Int(lngDate) - Islamic_Fixed(udtDateOut)
            udtDateOut.intMonth = Int((11 * intPriorDays + 330) / 325)
            udtDateOut.intDateOfMonth = Int(lngDate) - Islamic_Fixed(udtDateOut) + 1
            lastDate = lngDate
            lastDateOut.intDateOfMonth = udtDateOut.intDateOfMonth
            lastDateOut.intMonth = udtDateOut.intMonth
            lastDateOut.intYear = udtDateOut.intYear
        End If
    End If
End Sub
Friend Function MonthName(intMonth As Integer) As String
'Return the name of the Islamic month
    Static lastMonth As Integer
    Static lastResult As String
    If lastMonth = intMonth Then
        MonthName = lastResult
    Else
        Select Case intMonth
        Case 1
            MonthName = "Muharram"
        Case 2
            MonthName = "Safar"
        Case 3
            MonthName = "Rabi' I"
        Case 4
            MonthName = "Rabi' II"
        Case 5
            MonthName = "Jamada I"
        Case 6
            MonthName = "Jamada II"
        Case 7
            MonthName = "Rajab"
        Case 8
            MonthName = "Sha'ban"
        Case 9
            MonthName = "Ramadan"
        Case 10
            MonthName = "Shawwal"
        Case 11
            MonthName = "Dhu-al-Qu'da"
        Case 12
            MonthName = "Dhu-al-Hijja"
        Case Else
            MonthName = CStr(intMonth)
        End Select
        lastMonth = intMonth
        lastResult = MonthName
    End If
End Function

