VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsJulian"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'(C)Roy E. Hoffman 2000
'See Main.bas for terms and conditions of use
'Most of the algorithms in this module are from
'E. M. Reingold and N. Dershowitz "Calendrical Calculations: The Millenium Edition", Cambridge Univ. Press, Cambridge, UK, 1999.

Const JulianEpoch = -1
Function JulianLeapYear(intYear As Integer, blnCE As Boolean) As Boolean
'Is it a Julian leap year?
    JulianLeapYear = MyMod(intYear, 4) = 0 And blnCE Or MyMod(intYear, 4) = 1 And Not blnCE
End Function
Friend Function julian_fixed(udtDate As MyDate) As Long
'Convert Julian calendar to fixed radix
    Dim intY As Integer
    Static lastDate As MyDate
    Static lastResult As Double
    
    If udtDate.intDateOfMonth = lastDate.intDateOfMonth And udtDate.intMonth = lastDate.intMonth And udtDate.intYear = lastDate.intYear And udtDate.blnCE = lastDate.blnCE Then
        julian_fixed = lastResult
    Else
        If udtDate.blnCE Then
            intY = udtDate.intYear
        Else
            intY = -udtDate.intYear + 1
        End If
        julian_fixed = JulianEpoch - 1 + 365 * (CLng(intY) - 1) + Int((intY - 1) / 4) + Int((367# * udtDate.intMonth - 362) / 12) + udtDate.intDateOfMonth
        If udtDate.intMonth > 2 And JulianLeapYear(udtDate.intYear, udtDate.blnCE) Then
            julian_fixed = julian_fixed - 1
        ElseIf udtDate.intMonth > 2 Then
            julian_fixed = julian_fixed - 2
        End If
        lastDate.blnCE = udtDate.blnCE
        lastDate.intDateOfMonth = udtDate.intDateOfMonth
        lastDate.intMonth = udtDate.intMonth
        lastDate.intYear = udtDate.intYear
        lastResult = julian_fixed
    End If
End Function
Friend Sub fixed_julian(lngDate As Long, udtDateOut As MyDate, blnValid As Boolean)
'Convert fixed radix to the Julian calendar
    Dim intY As Integer
    Dim lngPriorDays As Long
    Dim intCorrection As Integer
    Dim lngYear As Long
    Static lastDate As Long
    Static lastDateOut As MyDate
    
    udtDateOut.enmDateType = Julian
    If lastDate = lngDate And dblDate <> 0 Then
        udtDateOut.intDateOfMonth = lastDateOut.intDateOfMonth
        udtDateOut.intMonth = lastDateOut.intMonth
        udtDateOut.intYear = lastDateOut.intYear
        udtDateOut.blnCE = lastDateOut.blnCE
    Else
        lngYear = Int((4 * (lngDate - JulianEpoch) + 1464) / 1461)
        If Abs(lngYear) > 32765 Then
            blnValid = False
        Else
            intY = lngYear
            udtDateOut.blnCE = intY > 0
            If intY <= 0 Then
                udtDateOut.intYear = -intY + 1
            Else
                udtDateOut.intYear = intY
            End If
            udtDateOut.intMonth = 1
            udtDateOut.intDateOfMonth = 1
            lngPriorDays = lngDate - julian_fixed(udtDateOut)
            udtDateOut.intMonth = 3
            If lngDate >= julian_fixed(udtDateOut) Then
                If JulianLeapYear(udtDateOut.intYear, udtDateOut.blnCE) Then
                    intCorrection = 1
                Else
                    intCorrection = 2
                End If
            Else
                intCorrection = 0
            End If
            udtDateOut.intMonth = Int((12 * (lngPriorDays + intCorrection) + 373) / 367)
            udtDateOut.intDateOfMonth = Int(lngDate - julian_fixed(udtDateOut) + 1)
            lastDate = lngDate
            'udtDateOut.blnCE = True
            If intY < 0 Then
                udtDateOut.blnCE = False
            End If
            lastDateOut.intDateOfMonth = udtDateOut.intDateOfMonth
            lastDateOut.intMonth = udtDateOut.intMonth
            lastDateOut.intYear = udtDateOut.intYear
            lastDateOut.blnCE = udtDateOut.blnCE
        End If
    End If
End Sub

