VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsLocalTime"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'(C)Roy E. Hoffman 2000
'See Main.bas for terms and conditions of use

Friend Function GetTZ(dblFix As Double, blnValid As Boolean) As Double
    Dim intSpring As Integer
    Dim intFall As Integer
    Dim intI As Integer
    Dim cGregorian As New clsGregorian
    Dim cDMS As New clsDMS
    
    'Determine time zone
    blnValid = True
    If Not udtLocation.blnDSTAuto Then
        If udtLocation.blnDST Then
            GetTZ = udtLocation.dblTZ + 1
        Else
            GetTZ = udtLocation.dblTZ
        End If
    Else
        intI = 0
        While udtLocation.udtTZ(intI).blnLast And udtLocation.udtTZ(intI).dblLast < dblFix And intI < udtLocation.intNTZ - 1
            intI = intI + 1
        Wend
        If Not udtLocation.udtTZ(intI).blnDST Then
            GetTZ = udtLocation.udtTZ(intI).dblTZ
        Else
            With udtLocation.udtTZ(intI).udtDSTStart
                intSpring = cGregorian.BeforeOnAfter(.intDayOfWeek, .intDate, .intWeekNo, .intMonthNo, dblFix)
            End With
            With udtLocation.udtTZ(intI).udtDSTEnd
                intFall = cGregorian.BeforeOnAfter(.intDayOfWeek, .intDate, .intWeekNo, .intMonthNo, dblFix)
            End With
            If intSpring = 0 Then
                GetTZ = cDMS.FromDMS(udtTime.udtDms)
                If GetTZ < udtLocation.udtTZ(intI).udtDSTStart.intHour Then
                    GetTZ = udtLocation.udtTZ(intI).dblTZ
                ElseIf GetTZ > udtLocation.udtTZ(intI).udtDSTStart.intHour + 1 Then
                    GetTZ = udtLocation.udtTZ(intI).dblTZ + 1
                Else
                    If udtLocation.blnDST Then
                        GetTZ = udtLocation.udtTZ(intI).dblTZ + 1
                    Else
                        GetTZ = udtLocation.udtTZ(intI).dblTZ
                    End If
                    'blnValid = False 'Within the hour skipped on changing time
                End If
            ElseIf intFall = 0 Then
                GetTZ = cDMS.FromDMS(udtTime.udtDms)
                If GetTZ > udtLocation.udtTZ(intI).udtDSTEnd.intHour - 1 Then
                    GetTZ = udtLocation.udtTZ(intI).dblTZ
                ElseIf GetTZ < udtLocation.udtTZ(intI).udtDSTEnd.intHour Then
                    GetTZ = udtLocation.udtTZ(intI).dblTZ + 1
                Else 'Within the hour that occurs twice
                    If udtLocation.blnDST Then
                        GetTZ = udtLocation.udtTZ(intI).dblTZ + 1
                    Else
                        GetTZ = udtLocation.udtTZ(intI).dblTZ
                    End If
                End If
            ElseIf udtLocation.udtTZ(intI).udtDSTStart.intMonthNo < udtLocation.udtTZ(intI).udtDSTEnd.intMonthNo Then 'Northern hemisphere
                If intSpring = -1 Or intFall = 1 Then
                    GetTZ = udtLocation.udtTZ(intI).dblTZ
                Else
                    GetTZ = udtLocation.udtTZ(intI).dblTZ + 1
                End If
            Else 'Southern hemisphere
                If intFall = -1 Or intSpring = 1 Then
                    GetTZ = udtLocation.udtTZ(intI).dblTZ + 1
                Else
                    GetTZ = udtLocation.udtTZ(intI).dblTZ
                End If
            End If
        End If
    End If
End Function
Friend Function FromLocal(udtTime As Mytime, blnValid As Boolean, enmType As DateType) As Double
    Dim cDMS As New clsDMS
    Dim cSun As New clsSun
    Dim dblSet As Double
    Dim dblTZ As Double
    Dim intDST As Integer '0 No, 1 Yes, 2 undefined
    Dim blnNeverRises As Boolean
    Dim blnNeverSets As Boolean
    Dim cHebrew As New clsHebrew
    'Convert to fraction of day since last UTC midnight
    
    blnValid = True
    'Determine time zone
    dblTZ = GetTZ(dblDate, blnValid)
    'Convert time
    FromLocal = (frmTime.FromAMPM(udtTime) - dblTZ) / 24
    'If udtTime.blnSecondTime Then FromLocal = FromLocal + 1
    If enmType = Hebrew Or enmType = Islamic Then
        Call cHebrew.AdjustTime(frmDate.ToLngDate(dblDate), FromLocal, blnValid, udtTime.blnSecondTime)
    ElseIf udtTime.blnSecondTime Then
        blnValid = False
    End If
End Function
Friend Sub ToLocal(dblFix As Double, udtTimeIn As Mytime)
    Dim dblTZ As Double
    Dim blnValid As Boolean
    Dim cDMS As New clsDMS
    'Convert to local time
    
    udtTimeIn.enmTimeType = localt
    dblTZ = GetTZ(dblFix, blnValid)
    Call cDMS.ToDMS(dblMod((dblFix - Int(dblFix)) * 24 + dblTZ, 24), udtTimeIn.udtDms)
    Call frmTime.ToAMPM(udtTimeIn)
End Sub
Friend Sub StartEndOfDay(dblFix As Double, enmDateType As DateType, dblStart As Double, dblEnd As Double, intDayShift As Integer)
'Get the start and end of the day according to Local time
    Dim cHebrew As New clsHebrew
    Dim dblTZ As Double
    Dim blnValid As Boolean
    
    intDayShift = 0
    If enmDateType < Hebrew Then
        dblTZ = GetTZ(dblFix, blnValid)
        dblTZ = GetTZ(Int(dblFix + dblTZ / 24) - dblTZ / 24, blnValid)
        dblStart = Int(dblFix + dblTZ / 24) - dblTZ / 24
        dblTZ = GetTZ(Int(dblFix + dblTZ / 24 + 1) - dblTZ / 24, blnValid)
        dblEnd = Int(dblFix + dblTZ / 24 + 1) - dblTZ / 24
        intDayShift = 0 ' Int(dblFix + dblTZ / 24) - Int(dblFix)
    Else 'Defined by sunset in the Hebrew and Islamic calendars
        Call cHebrew.StartEndDay(dblFix, dblStart, dblEnd, intDayShift)
    End If
End Sub
Friend Function ZeroTime(dblFix As Double) As Double
    Dim dblTZ As Double
    Dim blnValid As Boolean
    
    dblTZ = GetTZ(dblFix, blnValid)
    ZeroTime = -dblTZ / 24
End Function

