VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMeanSolar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'(C)Roy E. Hoffman 2000
'See Main.bas for terms and conditions of use

Friend Function FromMeanSolar(udtTime As Mytime, blnValid As Boolean, enmType As DateType) As Double
'Convert from mean solar time, result in days
    Dim cDMS As New clsDMS
    Dim cSun As New clsSun
    Dim dblSet As Double
    Dim blnNeverRises As Boolean
    Dim blnNeverSets As Boolean
    Dim cHebrew As New clsHebrew

    blnValid = True
    FromMeanSolar = (frmTime.FromAMPM(udtTime) - udtLocation.dblLongitude / 15) / 24
    If udtTime.blnSecondTime Then FromMeanSolar = FromMeanSolar + 1
    If enmType = Hebrew Or enmType = Islamic Then
        Call cHebrew.AdjustTime(Int(dblDate), FromMeanSolar, blnValid, udtTime.blnSecondTime)
    ElseIf frmTime.opt2 Then
        blnValid = False
    End If
End Function
Friend Sub ToMeanSolar(dblFix As Double, udtTimeIn As Mytime)
'Convert time in days UTC to mean solar time
    Dim cDMS As New clsDMS
    
    udtTimeIn.enmTimeType = meansolar
    Call cDMS.ToDMS(dblMod((dblFix - Int(dblFix)) * 24 + udtLocation.dblLongitude / 15, 24), udtTimeIn.udtDms)
    Call frmTime.ToAMPM(udtTimeIn)
End Sub
Friend Sub StartEndOfDay(dblFix As Double, enmDateType As DateType, dblStart As Double, dblEnd As Double, intDayShift As Integer)
'Get start and end of mean solar day
    Dim cHebrew As New clsHebrew
    
    intDayShift = 0
    If enmDateType < Hebrew Then
        dblStart = Int(dblFix + udtLocation.dblLongitude / 360) - udtLocation.dblLongitude / 360
        dblEnd = dblStart + 1
        intDayShift = 0 'Int(dblFix + udtLocation.dblLongitude / 360) - Int(dblFix)
    Else
        Call cHebrew.StartEndDay(dblFix, dblStart, dblEnd, intDayShift)
    End If
End Sub
Friend Function ZeroTime(dblFix As Double) As Double
     ZeroTime = -udtLocation.dblLongitude / 360
End Function

