VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMoon"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'(C)Roy E. Hoffman 2000
'See Main.bas for terms and conditions of use
Const AU = 149597870 'Astronomical unit in km
Const PI = 3.14159265358979
'Const NIntegrals = 32

Friend Function MeanMoon(dblFix As Double) As Double
    'Mean Lunar ecliptic longitude given a fixed radix date
    Dim dblT As Double
    Dim cHBody As New clsHBody
    
    dblT = cHBody.ToJ2000(dblFix)
'J. Meeus, "Astronomical Algorithms", 2nd Ed., William-Bell Inc., Richmond, VG, 1998, p. 338
        
    MeanMoon = dblT * (1 / 538841 - dblT / 65194000)
    MeanMoon = FracCirc(218.3164477 + dblT * (481267.88123421 - dblT * (0.0015786 - MeanMoon)))
End Function
Friend Sub QT(lngFix As Long, QT As Double, blnNew As Boolean, Optional dblBestTime As Double, Optional dblARCV As Double, Optional dblWp As Double)
    Dim cSun As New clsSun
    Dim udtMoon As HBody
    Dim udtSun As HBody
    Dim blnSet As Boolean
    Dim dblMoonRiseSetTime As Double
    Dim dblSunRiseSetTime As Double
    Dim blnSunNeverRises As Boolean
    Dim blnSunNeverSets As Boolean
    Dim blnMoonNeverRises As Boolean
    Dim blnMoonNeverSets As Boolean
    Dim cHBody As New clsHBody
    
    blnSet = cHBody.EveningSight("Moon", lngFix)
    Call cHBody.RiseSet("Sun", lngFix, blnSet, dblSunRiseSetTime, False, blnSunNeverRises, blnSunNeverSets)
    Call cHBody.RiseSet("Moon", lngFix, blnSet, dblMoonRiseSetTime, False, blnMoonNeverRises, blnMoonNeverSets)
    If dblMoonRiseSetTime < dblSunRiseSetTime - 0.2 And blnSet Then
        Call cHBody.RiseSet("Moon", lngFix + 1, blnSet, dblMoonRiseSetTime, False, blnMoonNeverRises, blnMoonNeverSets)
    ElseIf dblMoonRiseSetTime > dblSunRiseSetTime + 0.2 And Not blnSet Then
        Call cHBody.RiseSet("Moon", lngFix - 1, blnSet, dblMoonRiseSetTime, False, blnMoonNeverRises, blnMoonNeverSets)
    End If
    dblBestTime = (5 * dblSunRiseSetTime + 4 * dblMoonRiseSetTime) / 9
    Call cHBody.TrueHBody("Sun", dblBestTime, udtSun)
    Call cHBody.TrueHBody("Moon", dblBestTime, udtMoon)
    dblARCV = udtMoon.AltTopo - udtSun.AltTopo
    dblWp = udtMoon.Phase * udtMoon.Radius * 120
    QT = dblARCV - 10.8865 + dblWp * (7.1012 - dblWp * (0.7319 - dblWp * 0.1018))
    blnNew = blnSet
End Sub
Friend Function QTText() As String
    Dim dblQT As Double
    Dim blnNew As Boolean
    Dim dblBestTime As Double
    Dim dblARCV As Double
    Dim dblWp As Double
    Dim udtDateOut As MyDate
    Dim udtTimeOut As Mytime
    Dim blnValid As Boolean
    Dim strOldDate As String
    
    strOldDate = ""
    blnValid = True
    Call QT(frmDate.ToLngDate(dblDate + dblTime), dblQT, blnNew, dblBestTime, dblARCV, dblWp)
    QTText = "qt factor for "
    If blnNew Then
        QTText = QTText & "new"
    Else
        QTText = QTText & "old"
    End If
    Call frmMain.ToDateTime(CorrectTime(dblBestTime, lngPrecision), udtDateOut, udtDate.enmDateType, udtTimeOut, udtTime.enmTimeType, blnValid)
    QTText = QTText & " Moon" & vbCrLf & frmDate.WriteDateTime(udtDateOut, udtTimeOut, strOldDate, CInt(lngPrecision))
    QTText = QTText & "Topocentric altitude difference " & strAngle(dblARCV, CInt(lngPrecision)) & vbCrLf
    QTText = QTText & "Topocentric crescent width " & Format(dblWp, strFormat(lngPrecision + 2)) & "'" & vbCrLf
    QTText = QTText & "qt value " & Format(dblQT, strFormat(lngPrecision + 1))
End Function
Friend Sub YallopQ(lngFix As Long, dblYallopQ As Double, blnNew As Boolean, Optional dblBestTime As Double, Optional dblARCV As Double, Optional dblWp As Double)
    Dim cSun As New clsSun
    Dim udtMoon As HBody
    Dim udtSun As HBody
    Dim blnSet As Boolean
    Dim dblMoonRiseSetTime As Double
    Dim dblSunRiseSetTime As Double
    Dim blnSunNeverRises As Boolean
    Dim blnSunNeverSets As Boolean
    Dim blnMoonNeverRises As Boolean
    Dim blnMoonNeverSets As Boolean
    Dim cHBody As New clsHBody
    
    blnSet = cHBody.EveningSight("Moon", lngFix)
    Call cHBody.RiseSet("Sun", lngFix, blnSet, dblSunRiseSetTime, False, blnSunNeverRises, blnSunNeverSets)
    Call cHBody.RiseSet("Moon", lngFix, blnSet, dblMoonRiseSetTime, False, blnMoonNeverRises, blnMoonNeverSets)
    If dblMoonRiseSetTime < dblSunRiseSetTime - 0.2 And blnSet Then
        Call cHBody.RiseSet("Moon", lngFix + 1, blnSet, dblMoonRiseSetTime, False, blnMoonNeverRises, blnMoonNeverSets)
    ElseIf dblMoonRiseSetTime > dblSunRiseSetTime + 0.2 And Not blnSet Then
        Call cHBody.RiseSet("Moon", lngFix - 1, blnSet, dblMoonRiseSetTime, False, blnMoonNeverRises, blnMoonNeverSets)
    End If
    dblBestTime = (5 * dblSunRiseSetTime + 4 * dblMoonRiseSetTime) / 9
    Call cHBody.TrueHBody("Sun", dblBestTime, udtSun)
    Call cHBody.TrueHBody("Moon", dblBestTime, udtMoon)
    dblARCV = udtMoon.AltGeo - udtSun.AltGeo
    dblWp = ((1 - cosD(udtMoon.ElongationGeo)) * udtMoon.Radius) * 60
    dblYallopQ = (dblARCV - 11.8371 + dblWp * (6.3226 - dblWp * (0.7319 - dblWp * 0.1018))) / 10
    blnNew = blnSet
End Sub
Friend Function YallopQText() As String
    Dim dblYallopQ As Double
    Dim blnNew As Boolean
    Dim dblBestTime As Double
    Dim dblARCV As Double
    Dim dblWp As Double
    Dim udtDateOut As MyDate
    Dim udtTimeOut As Mytime
    Dim blnValid As Boolean
    Dim strOldDate As String
    
    strOldDate = ""
    blnValid = True
    Call YallopQ(frmDate.ToLngDate(dblDate + dblTime), dblYallopQ, blnNew, dblBestTime, dblARCV, dblWp)
    YallopQText = "Yallop's q factor for "
    If blnNew Then
        YallopQText = YallopQText & "new"
    Else
        YallopQText = YallopQText & "old"
    End If
    Call frmMain.ToDateTime(CorrectTime(dblBestTime, lngPrecision), udtDateOut, udtDate.enmDateType, udtTimeOut, udtTime.enmTimeType, blnValid)
    YallopQText = YallopQText & " Moon" & vbCrLf & frmDate.WriteDateTime(udtDateOut, udtTimeOut, strOldDate, CInt(lngPrecision))
    YallopQText = YallopQText & "Geocentric altitude difference " & strAngle(dblARCV, CInt(lngPrecision)) & vbCrLf
    YallopQText = YallopQText & "Geocentric crescent width " & Format(dblWp, strFormat(lngPrecision + 2)) & "'" & vbCrLf
    YallopQText = YallopQText & "Yallop's q value " & Format(dblYallopQ, strFormat(lngPrecision + 2))
    If dblYallopQ < -0.232 Then
        YallopQText = YallopQText & vbCrLf & "The Moon is not visible even with a telescope."
    ElseIf dblYallopQ < -0.05 Then
        YallopQText = YallopQText & vbCrLf & "The Moon might be visible with bincoulars or a telescope."
    ElseIf dblYallopQ < 0.2 Then
        YallopQText = YallopQText & vbCrLf & "The Moon might be visible to the naked eye."
    Else
        YallopQText = YallopQText & vbCrLf & "The Moon is definately visible to the naked eye."
    End If

End Function
Friend Sub Rambam(dblFix As Double, dblOrechRishon As Double, dblKeshetReiya As Double, blnNew As Boolean, Optional dblBestTime As Double)
    Dim dblSunRiseSetTime As Double
    Dim dblMoonRiseSetTime As Double
    Dim blnSunNeverRises As Boolean
    Dim blnSunNeverSets As Boolean
    Dim blnMoonNeverRises As Boolean
    Dim blnMoonNeverSets As Boolean
    Dim lngFix As Long
    Dim udtMoon As HBody
    Dim udtSun As HBody
    Dim intFactor As Integer
    Dim cSun As New clsSun
    Dim cHBody As New clsHBody

    lngFix = frmDate.ToLngDate(dblFix)
    blnNew = cHBody.EveningSight("Moon", lngFix)
    Call cHBody.RiseSet("Sun", lngFix, blnNew, dblSunRiseSetTime, False, blnSunNeverRises, blnSunNeverSets)
    Call cHBody.RiseSet("Moon", lngFix, blnNew, dblMoonRiseSetTime, False, blnSunNeverRises, blnSunNeverSets)
    If dblMoonRiseSetTime < dblSunRiseSetTime - 0.2 And blnNew Then
        Call cHBody.RiseSet("Moon", lngFix + 1, blnNew, dblMoonRiseSetTime, False, blnMoonNeverRises, blnMoonNeverSets)
        dblMoonRiseSetTime = dblMoonRiseSetTime + 1
    ElseIf dblMoonRiseSetTime > dblSunRiseSetTime + 0.2 And Not blnNew Then
        Call cHBody.RiseSet("Moon", lngFix - 1, blnNew, dblMoonRiseSetTime, False, blnMoonNeverRises, blnMoonNeverSets)
        dblMoonRiseSetTime = dblMoonRiseSetTime - 1
    End If
    If blnNew Then
        intFactor = 1
    Else
        intFactor = -1
    End If
    dblKeshetReiya = FracCirc(intFactor * 360 * (dblMoonRiseSetTime - dblSunRiseSetTime))
    dblBestTime = dblSunRiseSetTime + intFactor * 1.38888888888889E-02
    Call cHBody.TrueHBody("Moon", dblBestTime, udtMoon)
    Call cHBody.TrueHBody("Sun", dblBestTime, udtSun)
    dblOrechRishon = FracCirc(intFactor * (udtMoon.EclLong - udtSun.EclLong))
End Sub
Friend Function RambamText() As String
    Dim blnNew As Boolean
    Dim dblBestTime As Double
    Dim dblOR As Double
    Dim dblKR As Double
    Dim udtDateOut As MyDate
    Dim udtTimeOut As Mytime
    Dim blnValid As Boolean
    Dim strOldDate As String
    
    strOldDate = ""
    blnValid = True
    Call Rambam(dblDate + dblTime, dblOR, dblKR, blnNew, dblBestTime)
    RambamText = "Rambam's paramters for "
    If blnNew Then
        RambamText = RambamText & "new"
    Else
        RambamText = RambamText & "old"
    End If
    Call frmMain.ToDateTime(CorrectTime(dblBestTime, lngPrecision), udtDateOut, udtDate.enmDateType, udtTimeOut, udtTime.enmTimeType, blnValid)
    RambamText = RambamText & " Moon" & vbCrLf & frmDate.WriteDateTime(udtDateOut, udtTimeOut, strOldDate, CInt(lngPrecision))
    RambamText = RambamText & "Orech Rishon (Geocentric ecliptic longitude difference) " & strAngle(dblOR, CInt(lngPrecision)) & vbCrLf
    RambamText = RambamText & "Keshet Reiya (proportional to Geometric lag) " & strAngle(dblKR, CInt(lngPrecision)) & vbCrLf
    RambamText = RambamText & "Sum (OR + KR) " & strAngle(dblOR + dblKR, CInt(lngPrecision))
    If udtLocation.dblLatitude < 29 Or udtLocation.dblLatitude > 35 Then
        RambamText = RambamText & "Rambam's criterion is not valid for this latitude."
    ElseIf dblOR <= 9 Or dblKR <= 9 Or dblOR + dblKR < 22 Then
        RambamText = RambamText & vbCrLf & "The Moon is definately not visible to the naked eye."
    Else
        RambamText = RambamText & vbCrLf & "The Moon may be visible to the naked eye."
    End If
End Function
Friend Sub LagPhaseDistance(dblFix As Double, blnNew As Boolean, dblLag As Double, dblPhase As Double, dblGPhase As Double, dblDistance As Double, Optional dblSunset As Double)
    Dim dblSunRiseSetTime As Double
    Dim dblMoonRiseSetTime As Double
    Dim blnSunNeverRises As Boolean
    Dim blnSunNeverSets As Boolean
    Dim blnMoonNeverRises As Boolean
    Dim blnMoonNeverSets As Boolean
    Dim lngFix As Long
    Dim udtMoon As HBody
    Dim udtSun As HBody
    Dim intFactor As Integer
    Dim cSun As New clsSun
    Dim cHBody As New clsHBody

    lngFix = frmDate.ToLngDate(dblFix)
    blnNew = cHBody.EveningSight("Moon", lngFix)
    Call cHBody.RiseSet("Sun", lngFix, blnNew, dblSunRiseSetTime, True, blnSunNeverRises, blnSunNeverSets, 0, True)
    Call cHBody.RiseSet("Moon", lngFix, blnNew, dblMoonRiseSetTime, True, blnSunNeverRises, blnSunNeverSets, True)
    If dblMoonRiseSetTime < dblSunRiseSetTime - 0.2 And blnNew Then
        Call cHBody.RiseSet("Moon", lngFix + 1, blnNew, dblMoonRiseSetTime, False, blnMoonNeverRises, blnMoonNeverSets)
    ElseIf dblMoonRiseSetTime > dblSunRiseSetTime + 0.2 And Not blnNew Then
        Call cHBody.RiseSet("Moon", lngFix - 1, blnNew, dblMoonRiseSetTime, False, blnMoonNeverRises, blnMoonNeverSets)
    End If
    If blnNew Then
        intFactor = 1
    Else
        intFactor = -1
    End If
    dblLag = intFactor * 1440 * (dblMoonRiseSetTime - dblSunRiseSetTime)
    dblSunset = dblSunRiseSetTime
    Call cHBody.TrueHBody("Moon", dblSunset, udtMoon)
    dblPhase = udtMoon.Phase * 100
    dblGPhase = (1 - cosD(udtMoon.ElongationGeo)) * 50
    dblDistance = udtMoon.DistanceTopo
End Sub
Friend Function LagPhaseDistanceText() As String
    Dim dblLag As Double
    Dim dblPhase As Double
    Dim dblGPhase As Double
    Dim dblDistance As Double
    Dim dblSunset As Double
    Dim dblAngle As Double
    Dim dblSubtend As Double
    Dim dblAltitude As Double
    Dim dblAzimuth As Double
    Dim blnNew As Boolean
    Dim udtDateOut As MyDate
    Dim udtTimeOut As Mytime
    Dim blnValid As Boolean
    Dim strOldDate As String
    
    strOldDate = ""
    blnValid = True
    Call LagPhaseDistance(dblDate + dblTime, blnNew, dblLag, dblPhase, dblGPhase, dblDistance, dblSunset)
    If blnNew Then
        LagPhaseDistanceText = "New "
    Else
        LagPhaseDistanceText = "Old "
    End If
    LagPhaseDistanceText = LagPhaseDistanceText & "Moon's Lag time, phase and distance" & vbCrLf
    If blnNew Then
        LagPhaseDistanceText = LagPhaseDistanceText & "Apparent sunset"
    Else
        LagPhaseDistanceText = LagPhaseDistanceText & "Apparent sunrise"
    End If
    Call frmMain.ToDateTime(CorrectTime(dblSunset, lngPrecision - 1), udtDateOut, udtDate.enmDateType, udtTimeOut, udtTime.enmTimeType, blnValid)
    LagPhaseDistanceText = LagPhaseDistanceText & " over sea level horizon " & vbCrLf & frmDate.WriteDateTime(udtDateOut, udtTimeOut, strOldDate, lngPrecision - 1)
    LagPhaseDistanceText = LagPhaseDistanceText & "Apparent lag time " & WriteDMSTime(dblLag / 60) & vbCrLf
    LagPhaseDistanceText = LagPhaseDistanceText & "Topocentric illumination " & Format(dblPhase, strFormat(lngPrecision + 2)) & "%" & vbCrLf
    LagPhaseDistanceText = LagPhaseDistanceText & "Simple geocentric illumination " & Format(dblGPhase, strFormat(lngPrecision + 2)) & "%" & vbCrLf
    LagPhaseDistanceText = LagPhaseDistanceText & "Topocentric distance (Earth's surface to Moon's center) " & Format(dblDistance, strFormat(lngPrecision)) & "km" & vbCrLf
    Call BrightLimb(dblSunset, dblAngle, dblSubtend, dblAltitude, dblAzimuth)
    LagPhaseDistanceText = LagPhaseDistanceText & "Zenith angle " & Format(dblAngle, strFormat(lngPrecision)) & "" & vbCrLf
    LagPhaseDistanceText = LagPhaseDistanceText & "Crescent subtends an angle of " & Format(dblSubtend, strFormat(lngPrecision)) & ""
End Function
Friend Function FirstVisible(dblFix As Double, blnTopo As Boolean, blnPhotometric As Boolean, Optional intMode As Integer = 0) As String
    Dim dblYallopQ As Double
    Dim blnNotVisible As Boolean
    Dim blnEasy As Boolean
    Dim blnNew As Boolean
    Dim dblAltitude As Double
    Dim blnNeverRises As Boolean
    Dim blnNeverSets As Boolean
    Dim cSun As New clsSun
    Dim dblBestTime As Double
    Dim udtSun(1) As HBody
    Dim udtMoon As HBody
    Dim dblProbVis As Double
    Dim strOldDate As String
    Dim lngFix As Long
    Dim dblRise As Double
    Dim dblSet As Double
    Dim intadd As Integer
    Dim intI As Integer
    Dim intStart1 As Integer
    Dim intStart2 As Integer
    Dim intEnd1 As Integer
    Dim intend2 As Integer
    Dim NTransitions As Integer
    Dim dblT(5) As Double
    'Dim P() As Double
    Dim dblP() As Double
    Dim intNPoints As Integer
    Dim cSky As New clsSky
    Dim cPlanet As New clsPlanet
    Dim cHBody As New clsHBody
    Dim udtPlanet As HBody
    Dim dblRiseSet As Double
    
    'intMode = 1
    Select Case intMode
    Case 0
        strOldDate = ""
        Call cHBody.Visibility("Moon", frmDate.ToLngDate(dblFix), blnNew, dblYallopQ, dblT, blnEasy, blnNotVisible, dblProbVis, blnTopo, blnPhotometric, blnNeverRises)
        If blnCancel Then
            FirstVisible = "Calculation aborted"
        Else
            If blnNew Then
                FirstVisible = "The new Moon "
            Else
                FirstVisible = "The old Moon "
            End If
            If blnNotVisible Then
                'Call cHBody.RiseSet("Moon", frmDate.ToLngDate(dblFix), blnNew, dblRiseSet, True, blnNeverRises, blnNeverSets, 0, True)
                FirstVisible = FirstVisible & "is not visible to the naked eye"
                If dblYallopQ > -0.23 And Not blnNeverRises Then
                    FirstVisible = FirstVisible & " but may be visible with a telescope" & vbCrLf & "Best visibility at " & strTime(dblT(0), strOldDate)
                Else
                    FirstVisible = FirstVisible & " or with a telescope"
                End If
            ElseIf blnEasy Then
                FirstVisible = FirstVisible & "is clearly visible for an extended period"
            Else
                If dblT(2) <= dblT(1) Then
                    FirstVisible = FirstVisible & "first appears between: " & strTime(dblT(0), strOldDate) & " and " & strTime(dblT(3), strOldDate)
                Else
                    FirstVisible = FirstVisible & "first appears between: " & strTime(dblT(0), strOldDate) & " and " & strTime(dblT(1), strOldDate) & vbCrLf
                    FirstVisible = FirstVisible & "and fades between: " & strTime(dblT(2), strOldDate) & " and " & strTime(dblT(3), strOldDate)
                End If
            If lngPlotMode = 1 Then
                Call cHBody.RiseSet("Sun", Int(dblT(0)), True, dblSet, True, blnNeverRises, blnNeverSets)
                Call cHBody.TrueHBody("Sun", dblSet, udtSun(0))
                Call cHBody.TrueHBody("Moon", dblT(0), udtMoon)
                If udtSun(0).AzTopo - udtMoon.AzTopo > 0 Then
                    FirstVisible = FirstVisible & vbCrLf & "The Moon appears " & Int(2 * (udtSun(0).AzTopo - udtMoon.AzTopo) + 0.5) / 2 & ", " & Fingers(udtSun(0).AzTopo - udtMoon.AzTopo) & " left of the Sunset" & vbCrLf
                Else
                    FirstVisible = FirstVisible & vbCrLf & "The Moon appears " & Int(2 * (udtMoon.AzTopo - udtSun(0).AzTopo) + 0.5) / 2 & ", " & Fingers(udtMoon.AzTopo - udtSun(0).AzTopo) & " right of the Sunset" & vbCrLf
                End If
                FirstVisible = FirstVisible & "and " & Int(2 * udtMoon.AltRefr + 0.5) / 2 & ", " & Fingers(udtMoon.AltRefr) & " high."
                If udtGraph.blnMercury Then
                    Call cHBody.TrueHBody("Mercury", dblT(0), udtPlanet)
                    If udtPlanet.AzTopo - udtMoon.AzTopo > 0 Then
                        FirstVisible = FirstVisible & vbCrLf & "The Moon appears " & Int(2 * (udtPlanet.AzTopo - udtMoon.AzTopo) + 0.5) / 2 & ", " & Fingers(udtPlanet.AzTopo - udtMoon.AzTopo) & " left of Mercury" & vbCrLf
                    Else
                        FirstVisible = FirstVisible & vbCrLf & "The Moon appears " & Int(2 * (udtMoon.AzTopo - udtPlanet.AzTopo) + 0.5) / 2 & ", " & Fingers(udtMoon.AzTopo - udtPlanet.AzTopo) & " right of Mercury" & vbCrLf
                    End If
                    If udtPlanet.AltRefr >= udtMoon.AltRefr Then
                        FirstVisible = FirstVisible & "and " & Int(2 * (udtPlanet.AltRefr - udtMoon.AltRefr) + 0.5) / 2 & ", " & Fingers(udtPlanet.AltRefr - udtMoon.AltRefr) & " below it."
                    Else
                        FirstVisible = FirstVisible & "and " & Int(2 * (udtMoon.AltRefr - udtPlanet.AltRefr) + 0.5) / 2 & ", " & Fingers(udtMoon.AltRefr - udtPlanet.AltRefr) & " above it."
                    End If
                End If
                If udtGraph.blnVenus Then
                    Call cHBody.TrueHBody("Venus", dblT(0), udtPlanet)
                    If udtPlanet.AzTopo - udtMoon.AzTopo > 0 Then
                        FirstVisible = FirstVisible & vbCrLf & "The Moon appears " & Int(2 * (udtPlanet.AzTopo - udtMoon.AzTopo) + 0.5) / 2 & ", " & Fingers(udtPlanet.AzTopo - udtMoon.AzTopo) & " left of Venus" & vbCrLf
                    Else
                        FirstVisible = FirstVisible & vbCrLf & "The Moon appears " & Int(2 * (udtMoon.AzTopo - udtPlanet.AzTopo) + 0.5) / 2 & ", " & Fingers(udtMoon.AzTopo - udtPlanet.AzTopo) & " right of Venus" & vbCrLf
                    End If
                    If udtPlanet.AltRefr >= udtMoon.AltRefr Then
                        FirstVisible = FirstVisible & "and " & Int(2 * (udtPlanet.AltRefr - udtMoon.AltRefr) + 0.5) / 2 & ", " & Fingers(udtPlanet.AltRefr - udtMoon.AltRefr) & " below it."
                    Else
                        FirstVisible = FirstVisible & "and " & Int(2 * (udtMoon.AltRefr - udtPlanet.AltRefr) + 0.5) / 2 & ", " & Fingers(udtMoon.AltRefr - udtPlanet.AltRefr) & " above it."
                    End If
                End If
                If udtGraph.blnJupiter Then
                    Call cHBody.TrueHBody("Jupiter", dblT(0), udtPlanet)
                    If udtPlanet.AzTopo - udtMoon.AzTopo > 0 Then
                        FirstVisible = FirstVisible & vbCrLf & "The Moon appears " & Int(2 * (udtPlanet.AzTopo - udtMoon.AzTopo) + 0.5) / 2 & ", " & Fingers(udtPlanet.AzTopo - udtMoon.AzTopo) & " left of Jupiter" & vbCrLf
                    Else
                        FirstVisible = FirstVisible & vbCrLf & "The Moon appears " & Int(2 * (udtMoon.AzTopo - udtPlanet.AzTopo) + 0.5) / 2 & ", " & Fingers(udtMoon.AzTopo - udtPlanet.AzTopo) & " right of Jupiter" & vbCrLf
                    End If
                    If udtPlanet.AltRefr >= udtMoon.AltRefr Then
                        FirstVisible = FirstVisible & "and " & Int(2 * (udtPlanet.AltRefr - udtMoon.AltRefr) + 0.5) / 2 & ", " & Fingers(udtPlanet.AltRefr - udtMoon.AltRefr) & " below it."
                    Else
                        FirstVisible = FirstVisible & "and " & Int(2 * (udtMoon.AltRefr - udtPlanet.AltRefr) + 0.5) / 2 & ", " & Fingers(udtMoon.AltRefr - udtPlanet.AltRefr) & " above it."
                    End If
                End If
                Open "Output.txt" For Output As #1
                Print #1, FirstVisible
                Close #1
            End If
        FirstVisible = FirstVisible & vbCrLf & "with 90% confidence provided that it is not cloudy" & vbCrLf
    End If
    If dblProbVis >= 0.01 And dblProbVis <= 0.99 Then
        FirstVisible = FirstVisible & " Probability of visibility if clear: " & Format(100 * dblProbVis, "##0") & "%"
    ElseIf dblProbVis >= 0.001 And dblProbVis <= 0.999 Then
        FirstVisible = FirstVisible & " Probability of visibility if clear: " & Format(100 * dblProbVis, "##0.0") & "%"
    Else
        FirstVisible = FirstVisible & " Probability of visibility if clear: " & Format(100 * dblProbVis, "##0.00") & "%"
    End If
    If Not blnEasy And (Not blnNotVisible Or dblYallopQ > -0.23) Then
        If Not frmGraph.Visible Then
            frmGraph.Show
        Else
            frmGraph.Form_Resize
        End If
    Else
        frmGraph.Hide
    End If
    End If
    Case 1
        lngFix = frmDate.ToLngDate(dblFix)
        Call ProbCurve(lngFix)
    Case 2
        Call cHBody.RiseSet("Moon", lngFix, False, dblRise, True, blnNeverRises, blnNeverSets, True, 0)
        Call cHBody.RiseSet("Moon", lngFix, True, dblSet, True, blnNeverRises, blnNeverSets, True, 0)
        intadd = 0
        While dblRise < lngFix - udtLocation.dblLongitude / 360 - 0.01752505
            intadd = intadd + 1
            Call cHBody.RiseSet("Moon", lngFix + intadd, False, dblRise, True, blnNeverRises, blnNeverSets, True, 0)
        Wend
        If blnNeverRises Then
            FirstVisible = "Moon never rises"
        Else
            If blnNeverSets Then
                dblRise = lngFix - udtLocation.dblLongitude / 360
                dblSet = lngFix - udtLocation.dblLongitude / 360 - 1
            Else
                intadd = 0
                If dblSet < dblRise Then
                    While dblSet < dblRise
                        intadd = intadd + 1
                        Call cHBody.RiseSet("Moon", lngFix + intadd, True, dblSet, True, blnNeverRises, blnNeverSets, True, 0)
                    Wend
                Else
                    While dblSet >= dblRise + 1.03505
                        intadd = intadd - 1
                        Call cHBody.RiseSet("Moon", lngFix + intadd, True, dblSet, True, blnNeverRises, blnNeverSets, True, 0)
                    Wend
                End If
            End If
            ReDim dblP(4)
            dblP(2) = cHBody.FindP("Moon", dblRise, dblSet, 1.1, 0.001, dblT(2)) 'Highest probability
            If dblP(2) < 0.025 Then
                dblP(0) = dblP(2)
                dblT(0) = dblT(2)
                dblP(1) = dblP(2)
                dblT(1) = dblT(2)
                dblP(3) = dblP(2)
                dblT(3) = dblT(2)
                dblP(4) = dblP(2)
                dblT(4) = dblT(2)
            Else
                intNPoints = 66
                dblP(0) = cHBody.FindP("Moon", dblRise, dblT(2), 0.025, 0.001, dblT(0)) 'First chance of seeing
                dblP(4) = cHBody.FindP("Moon", dblT(2), dblSet, 0.025, 0.001, dblT(4)) 'First chance of seeing
                If dblP(2) < 0.975 Then
                    dblP(1) = dblP(2)
                    dblT(1) = dblT(2)
                    dblP(3) = dblP(2)
                    dblT(3) = dblT(2)
                Else
                    dblP(1) = cHBody.FindP("Moon", dblT(0), dblT(2), 0.975, 0.001, dblT(1)) 'First chance of seeing
                    dblP(3) = cHBody.FindP("Moon", dblT(2), dblT(4), 0.975, 0.001, dblT(3)) 'First chance of seeing
                End If
            End If
            For intI = 0 To intNPoints
                Debug.Print dblT(intI) & ", " & dblP(intI)
            Next
        End If
    End Select
End Function
Friend Sub ProbCurve(lngFix As Long)
    Dim dblP() As Double
    Dim dblT() As Double
    Dim intNPoints As Integer
    Dim intadd As Integer
    Dim dblRise As Double
    Dim dblSet As Double
    Dim blnNeverRises As Boolean
    Dim blnNeverSets As Boolean
    Dim intI As Integer
    Dim cHBody As New clsHBody
    
    Call cHBody.RiseSet("Moon", lngFix, False, dblRise, True, blnNeverRises, blnNeverSets, 0, True)
    Call cHBody.RiseSet("Moon", lngFix, True, dblSet, True, blnNeverRises, blnNeverSets, 0, True)
    intadd = 0
    While dblRise < lngFix - udtLocation.dblLongitude / 360 - 0.01752505
        intadd = intadd + 1
        Call cHBody.RiseSet("Moon", lngFix + intadd, False, dblRise, True, blnNeverRises, blnNeverSets, 0, True)
    Wend
    If blnNeverRises Then
        intNPoints = 0 'Moon does not rise
    Else
        If blnNeverSets Then
            dblRise = lngFix - udtLocation.dblLongitude / 360
            dblSet = lngFix - udtLocation.dblLongitude / 360 - 1
        Else
            intadd = 0
            If dblSet < dblRise Then
                While dblSet < dblRise
                    intadd = intadd + 1
                    Call cHBody.RiseSet("Moon", lngFix + intadd, True, dblSet, True, blnNeverRises, blnNeverSets, 0, True)
                Wend
            Else
                While dblSet >= dblRise + 1.03505
                    intadd = intadd - 1
                    Call cHBody.RiseSet("Moon", lngFix + intadd, True, dblSet, True, blnNeverRises, blnNeverSets, 0, True)
                Wend
            End If
        End If
        ReDim dblP(4)
        ReDim dblT(4)
        dblP(2) = cHBody.FindP("Moon", dblRise, dblSet, 1.1, 0.001, dblT(2)) 'Highest probability
        If dblP(2) < 0.002 Then
            dblP(0) = dblP(2)
            dblT(0) = dblT(2)
            dblP(1) = dblP(2)
            dblT(1) = dblT(2)
            dblP(3) = dblP(2)
            dblT(3) = dblT(2)
            dblP(4) = dblP(2)
            dblT(4) = dblT(2)
            intNPoints = 4
        Else
            intNPoints = 66
            dblP(0) = cHBody.FindP("Moon", dblRise, dblT(2), 0.002, 0.001, dblT(0)) 'First chance of seeing
            dblP(4) = cHBody.FindP("Moon", dblT(2), dblSet, 0.002, 0.001, dblT(4)) 'First chance of seeing
            If dblP(2) < 0.998 Then
                dblP(1) = dblP(2)
                dblT(1) = dblT(2)
                dblP(3) = dblP(2)
                dblT(3) = dblT(2)
            Else
                dblP(1) = cHBody.FindP("Moon", dblT(0), dblT(2), 0.998, 0.001, dblT(1)) 'First chance of seeing
                dblP(3) = cHBody.FindP("Moon", dblT(2), dblT(4), 0.998, 0.001, dblT(3)) 'First chance of seeing
            End If
            ReDim Preserve dblP(66)
            ReDim Preserve dblT(66)
            dblP(66) = dblP(4)
            dblT(66) = dblT(4)
            dblP(34) = dblP(3)
            dblT(34) = dblT(3)
            dblP(33) = dblP(2)
            dblT(33) = dblT(2)
            dblP(32) = dblP(1)
            dblT(32) = dblT(1)
            For intI = 1 To 31
                dblT(intI) = dblT(0) + (dblT(32) - dblT(0)) * intI / 32
                dblP(intI) = cHBody.HBProbVis("Moon", dblT(intI))
                dblT(34 + intI) = dblT(34) + (dblT(66) - dblT(34)) * intI / 32
                dblP(34 + intI) = cHBody.HBProbVis("Moon", dblT(34 + intI))
            Next
        End If
        For intI = 0 To intNPoints
            Debug.Print dblT(intI) & ", " & dblP(intI)
        Next
    End If
End Sub
Friend Sub BrightLimb(dblFix As Double, dblAngle As Double, dblSubtend As Double, dblAltitude As Double, dblAzimuth As Double, Optional blnRefract As Boolean = True)
'Calculate the appearence of the bright limb of the Moon (corrected for refraction)
    Dim udtMoon As HBody
    Dim udtSun As HBody
    Dim dblOffset As Double
    Dim dblChi As Double 'Tilt of limb relative to Moon's pole
    Dim dblQ As Double 'Parallactic angle
    Dim udtWeatherNow As WeatherNow
    Dim cSun As New clsSun
    Dim cHBody As New clsHBody
    
    Call cHBody.TrueHBody("Moon", dblFix, udtMoon)
    Call cHBody.TrueHBody("Sun", dblFix, udtSun)
    dblChi = 360 - atn2D(cosD(udtSun.DeclTopo) * sinD(udtSun.RATopo - udtMoon.RATopo), sinD(udtSun.DeclTopo) * cosD(udtMoon.DeclTopo) - cosD(udtSun.DeclTopo) * sinD(udtMoon.DeclTopo) * cosD(udtSun.RATopo - udtMoon.RATopo))
    dblQ = atn2D(sinD(udtMoon.HourAngTopo), tanD(udtLocation.dblLatitude) * cosD(udtMoon.DeclTopo) - sinD(udtMoon.DeclTopo) * cosD(udtMoon.HourAngTopo))
    dblAngle = FracCirc(180 - dblChi - dblQ)
    If dblAngle > 180 Then dblAngle = dblAngle - 360
    dblOffset = udtMoon.Radius * (1 - udtMoon.Phase) 'Offset to middle of crescent (or other phase)
    dblSubtend = 185 - 1460000000# * (udtMoon.ElongationTopo + 25) ^ -4.702
    dblAltitude = udtMoon.AltTopo - dblOffset * cosD(dblAngle)
    Call frmWeather.GetWeatherNow(dblFix, 0, udtWeatherNow)
    If blnRefract Then dblAltitude = dblAltitude + cHBody.Refract(dblAltitude, True, udtWeatherNow, udtMoon.RefrValid)
    dblAzimuth = udtMoon.AzTopo + dblOffset * sinD(dblAngle)
End Sub
Friend Function WriteDMSTime(dblHours As Double) As String
    Dim udtDms As DMS
    Dim cDMS As New clsDMS
    
    Call cDMS.ToDMS(dblHours, udtDms)
    'Deal with negative times
    If Not udtDms.blnSign Then
        WriteDMSTime = "-"
    Else
        WriteDMSTime = ""
    End If
    If udtDms.intDegreesHours > 0 Then
        WriteDMSTime = WriteDMSTime & udtDms.intDegreesHours & "h" & Format(udtDms.intMinutes, "00") & "m" & Format(udtDms.dblSeconds, "00") & "s"
    ElseIf udtDms.intMinutes > 0 Then
        WriteDMSTime = WriteDMSTime & udtDms.intMinutes & "m" & Format(udtDms.dblSeconds, "00") & "s"
    Else
        WriteDMSTime = WriteDMSTime & Format(udtDms.dblSeconds, "#0") & "s"
    End If
End Function
Friend Function NextNewMoonText() As String
    Dim lngNext As Long
    Dim udtDateOut As MyDate
    Dim blnValid As Boolean
    
    lngNext = NextNewMoon(dblDate + dblTime)
    Call frmDate.ToDate(lngNext, udtDate.enmDateType, udtDateOut, blnValid)
    NextNewMoonText = frmDate.WriteDate(udtDateOut)
End Function
Friend Function NextNewMoon(dblDate As Double) As Long
    Dim lngDate As Long
    Dim blnNew As Boolean
    Dim blnNew2 As Boolean
    Dim udtMoon As HBody
    Dim dblYallopQ As Double
    Dim dblT(5) As Double
    Dim blnEasy As Boolean
    Dim blnNotVisible As Boolean
    Dim dblProbVis As Double
    Dim intDays As Integer
    Dim cHBody As New clsHBody
    Dim blnTopo As Boolean
    Dim blnPhotometric As Boolean
    
    blnTopo = (lngMoonCalcMode = 2)
    blnPhotometric = (lngMoonCalcMode = 0)
    lngDate = frmDate.ToLngDate(dblDate)
    blnNew = cHBody.EveningSight("Moon", lngDate)
    Call cHBody.TrueHBody("Moon", dblDate, udtMoon)
    If blnNew Then
        udtVisibilitySave(0).blnUpdated = False
        Call cHBody.Visibility("Moon", dblDate - 1, blnNew, dblYallopQ, dblT, blnEasy, blnNotVisible, dblProbVis, blnTopo, blnPhotometric)
        If dblProbVis < 0.05 Then
            intDays = -1
            While dblProbVis < 0.05
                intDays = intDays + 1
                udtVisibilitySave(0).blnUpdated = False
                Call cHBody.Visibility("Moon", dblDate + intDays, blnNew, dblYallopQ, dblT, blnEasy, blnNotVisible, dblProbVis, blnTopo, blnPhotometric)
            Wend
            NextNewMoon = lngDate + intDays
        Else
            intDays = (360 - udtMoon.ElongationTopo) / 360 * 28
            udtVisibilitySave(0).blnUpdated = False
            Call cHBody.Visibility("Moon", dblDate + intDays, blnNew, dblYallopQ, dblT, blnEasy, blnNotVisible, dblProbVis, blnTopo, blnPhotometric)
            While Not blnNew Or dblProbVis < 0.05
                intDays = intDays + 1
                udtVisibilitySave(0).blnUpdated = False
                Call cHBody.Visibility("Moon", dblDate + intDays, blnNew, dblYallopQ, dblT, blnEasy, blnNotVisible, dblProbVis, blnTopo, blnPhotometric)
            Wend
            NextNewMoon = lngDate + intDays
        End If
    Else
        If blnNew Then
            intDays = (360 - udtMoon.ElongationTopo) / 360 * 28
        Else
            intDays = udtMoon.ElongationTopo / 360 * 28
        End If
        udtVisibilitySave(0).blnUpdated = False
        Call cHBody.Visibility("Moon", lngDate + intDays, blnNew, dblYallopQ, dblT, blnEasy, blnNotVisible, dblProbVis, blnTopo, blnPhotometric)
        blnNew2 = blnNew
        While Not blnNew2 Or dblProbVis < 0.05
            intDays = intDays + 1
            udtVisibilitySave(0).blnUpdated = False
            Call cHBody.Visibility("Moon", lngDate + intDays, blnNew, dblYallopQ, dblT, blnEasy, blnNotVisible, dblProbVis, blnTopo, blnPhotometric)
            If Not blnNew2 And blnNew Then blnNew2 = True
        Wend
        NextNewMoon = lngDate + intDays
    End If
    udtVisibilitySave(0).blnUpdated = False
End Function
Friend Sub DaysAfterRC()
'Determine the number of days after Rosh Chodesh that the Moon appears
'Not in use
    Dim udtDate As MyDate
    Dim intDARC As Integer
    Dim intYear As Integer
    Dim intMonth As Integer
    Dim blnNewVis As Boolean
    Dim dblFix As Double
    Dim dblYallopQ As Double
    Dim blnNew As Boolean
    Dim dblAltitude As Double
    Dim dblT(3) As Double
    Dim blnNeverRises As Boolean
    Dim blnNeverSets As Boolean
    Dim udtSun(1) As HBody
    Dim strProb As String
    Dim blnValid As Boolean
    Dim dblProbVis As Double
    Dim cHebrew As New clsHebrew
    Dim cHBody As New clsHBody
    
    Open "Output.txt" For Output Access Write As 2
    udtDate.enmDateType = Hebrew
    For intYear = 1 To 6000
        For intMonth = 1 To cHebrew.MonthsInHebrewYear(udtDate.intYear)
            udtDate.intYear = intYear
            udtDate.intMonth = intMonth
            udtDate.intDateOfMonth = 4
            intDARC = 5
            blnNewVis = True
            While blnNewVis
                intDARC = intDARC - 1
                Call cHebrew.fixed_hebrew(cHebrew.hebrew_fixed(udtDate) - 1, udtDate, blnValid)
                dblFix = cHebrew.hebrew_fixed(udtDate) + 0.5
                Call YallopQ(Int(dblFix), dblYallopQ, blnNew)
                If Not blnNew Or dblYallopQ < -0.1 Then
                    blnNewVis = False
                ElseIf dblYallopQ < 1.85 Then
                    dblAltitude = -8.0581 + dblYallopQ * (14.151 - dblYallopQ * (10.804 - dblYallopQ * 3.4415))
                    Call cHBody.RiseSet("Sun", Int(dblFix), blnNew, dblT(0), False, blnNeverRises, blnNeverSets, dblAltitude + 2.62)
                    Call cHBody.RiseSet("Sun", Int(dblFix), blnNew, dblT(1), False, blnNeverRises, blnNeverSets, dblAltitude - 2.62)
                    Call cHBody.RiseSet("Moon", Int(dblFix), blnNew, dblT(2), False, blnNeverRises, blnNeverSets, 2.8 * Exp(-4 * dblYallopQ) + 3.3, False)
                    Call cHBody.RiseSet("Moon", Int(dblFix), blnNew, dblT(3), False, blnNeverRises, blnNeverSets, 2.8 * Exp(-4 * dblYallopQ) - 0.7, False)
                    Call cHBody.TrueHBody("Sun", Int(dblDate) + (dblT(0) + dblT(1)) / 2, udtSun(0))
                    Call cHBody.TrueHBody("Sun", Int(dblDate) + (dblT(2) + dblT(3)) / 2, udtSun(1))
                    dblProbVis = Prob((udtSun(0).AltTopo - udtSun(1).AltTopo) / 1.52)
                    If dblProbVis >= 0.01 And dblProbVis <= 0.99 Then
                        strProb = "P =" & Format(100 * dblProbVis, "##0") & "%"
                    ElseIf dblProbVis >= 0.001 And dblProbVis <= 0.999 Then
                        strProb = "P = " & Format(100 * dblProbVis, "##0.0") & "%"
                    ElseIf dblProbVis > 0.0001 Then
                        strProb = "P =" & Format(100 * dblProbVis, "##0.00") & "%"
                    Else
                        blnNewVis = False
                    End If
                Else
                    strProb = "P = 100.00"
                End If
            Wend
            If intDARC < 0 Then Print #2, cHebrew.MonthName(intMonth, intYear), intYear, intDARC; " days ", strProb
        Next
    Next
    Close 2
End Sub
Sub NewMoonTable()
    'Make table of new Moons
    Dim lngI As Long
    Dim cHBody As New clsHBody
    Dim dblYallopQ As Double
    Dim dblT(5) As Double
    Dim blnEasy As Boolean
    Dim blnNotVisible As Boolean
    Dim dblProbVis As Double
    Dim blnValid As Boolean
    Dim blnNew As Boolean
    Dim dblLastDate As Double
    
    Open "Output.txt" For Output Access Write As 2
    udtDate.intDateOfMonth = 31
    udtDate.intMonth = 12
    udtDate.intYear = 3001
    udtDate.blnCE = False
    udtDate.enmDateType = Julian
    For lngI = 1 To 62000
        dblDate = frmDate.EvaluateDate(udtDate) + 1
        dblLastDate = dblDate
        dblDate = NextNewMoon(dblDate)
        dblLastDate = dblDate - dblLastDate + 1
        Call frmDate.ToDate(CLng(dblDate), udtDate.enmDateType, udtDate, blnValid)
        Call cHBody.Visibility("Moon", Int(dblDate), blnNew, dblYallopQ, dblT, blnEasy, blnNotVisible, dblProbVis)
        Print #2, frmDate.WriteDate(udtDate), " Probability " & Format(dblProbVis * 100, "##.00") & "%", dblLastDate
    Next
    Close 2
End Sub
Friend Sub AnalyzeSightings()
    Const NColumns = 23 'Number of coulumns in sighting table
    Const MakeTable = False 'Just make a table for publication
    Const blnNewMoon = True 'True for New Moon, false for old Moon
    Const strSeen = "Y" 'Analyse positive (Y) or negative (N) sightings
    Const Verbose = False 'Include observer's name and date in output
    Const Topo = True 'Topocentric or geocentric ARCV and W'
    Const VsQ = True 'True if analysing time of first/last visiblity vs Q, false is analyzing visible yes/no
    Const vsWp = False
    Const photometric = False
    Dim intI As Integer
    Dim intRow As Integer
    Dim intNRows As Integer
    Dim intBase As Integer
    Dim strEntry() As String
    Dim blnValid As Boolean
    Dim dblQ As Double
    Dim dblP As Double 'Probability of visibility
    Dim blnNew As Boolean
    Dim strFName As String
    Dim intIndex As Integer
    Dim dblBestTime As Double
    Dim dblARCV As Double
    Dim dblWp As Double
    Dim blnAccept As Boolean
    Dim udtSun As HBody
    Dim udtMoon As HBody
    Dim cMoon As New clsMoon
    Dim cSun As New clsSun
    Dim cHBody As New clsHBody
    
    If blnNewMoon Then
        strFName = "Sightings.txt"
        intIndex = 16
    Else
        strFName = "Old_Sightings.txt"
        intIndex = 17
    End If
    Open strFName For Input Access Read As 2
    intRow = 0
    While Not EOF(2)
        ReDim Preserve strEntry(NColumns * (intRow + 1) - 1)
        For intI = 0 To NColumns - 1
             If Not EOF(2) Then Input #2, strEntry(intRow * NColumns + intI)
        Next
        intRow = intRow + 1
    Wend
    Close 2
    intNRows = intRow
    Open "Output.txt" For Output Access Write As 2
    For intRow = 0 To intNRows - 1
        intBase = intRow * NColumns
        If (VsQ Or vsWp) And Not MakeTable Then
            If blnNewMoon Then
                blnAccept = strEntry(intBase + 10) = "Y" And strEntry(intBase + 9) = "Y" And strEntry(intBase + 11) <> "" And strEntry(intBase + 12) = "Y" And strEntry(intBase + 13) = "N" And strEntry(intBase + 14) = "N"
            Else
                blnAccept = strEntry(intBase + 10) = "Y" And strEntry(intBase + 9) = "Y" And strEntry(intBase + 16) <> "" And strEntry(intBase + 17) = "Y" And strEntry(intBase + 18) = "N" And strEntry(intBase + 19) = "N"
            End If
        Else
            blnAccept = (strEntry(intBase + 10) = strSeen Or MakeTable) And strEntry(intBase + 9) = "Y" And (strEntry(intBase + 12) = "Y" And strEntry(intBase + 13) = "N" And strEntry(intBase + 14) = "N" And (strEntry(intBase + 15) = "N" Or blnNewMoon) Or strEntry(intBase + intIndex) = "Y" And strEntry(intBase + intIndex + 1) = "N" And strEntry(intBase + intIndex + 2) = "N" And (strEntry(intBase + intIndex + 3) = "N" Or Not blnNewMoon))
        End If
        If blnAccept Then
        'Accept those cases where it was the 1st appearence and was seen by an experienced observer without errors or interference from clouds
            Call frmLocation.GetPositionFromName(strEntry(intBase + 3), strEntry(intBase + 4), strEntry(intBase + 5), blnValid)
            If blnValid Then Call frmDate.DateFromString(strEntry(intBase + 7), blnValid)
            If (VsQ Or vsWp Or photometric) And Not MakeTable Then 'Read the time of sighting
                If blnNewMoon Then
                    Call frmTime.TimeFromString(strEntry(intBase + 11), strEntry(intBase + 8), blnValid)
                Else
                    Call frmTime.TimeFromString(strEntry(intBase + 16), strEntry(intBase + 8), blnValid)
                End If
            End If
            If blnValid Then
                dblDate = frmDate.EvaluateDate(udtDate)
                If VsQ Or vsWp Or photometric Then
                    Call frmTime.EvaluateTime(blnValid)
                Else
                    dblTime = 0.5 - udtLocation.dblLongitude / 360
                End If
                If photometric Then
                    Call frmLocation.EvaluateLoc
                    Call frmWeather.GetWeatherNow(dblDate, dblTime, udtWeatherNow)
                    dblP = cHBody.HBProbVis("Moon", dblDate + dblTime)
                    'Debug.Print "Position: " & udtLocation.dblLatitude & ", " & udtLocation.dblLongitude & ", " & udtLocation.dblHeight & "m"
                    'Debug.Print "Day number: " & dblDate + dblTime
                    'Debug.Print "Weather: " & udtWeatherNow.dblTemperature & "C, " & udtWeatherNow.dblPressure & "mbar, " & udtWeatherNow.dblHumidity & "%"
                    'MsgBox "OK"
                ElseIf Topo Then
                    Call cMoon.QT(Int(dblDate + dblTime + udtLocation.dblLongitude / 360), dblQ, blnNew, dblBestTime, dblARCV, dblWp)
                Else
                    Call cMoon.YallopQ(Int(dblDate + dblTime + udtLocation.dblLongitude / 360), dblQ, blnNew, dblBestTime, dblARCV, dblWp)
                End If
                If VsQ Or vsWp Then Call cHBody.TrueHBody("Sun", dblDate + dblTime, udtSun)
                If MakeTable Then
                    If blnNewMoon And strEntry(intBase + 16) = "Y" And strEntry(intBase + 17) = "N" And strEntry(intBase + 18) = "N" And strEntry(intBase + 19) = "N" Or Not blnNewMoon And strEntry(intBase + 12) = "Y" And strEntry(intBase + 13) = "N" And strEntry(intBase + 14) = "N" And strEntry(intBase + 15) = "N" Then
                        If blnNewMoon And strEntry(intBase + 12) = "Y" And strEntry(intBase + 13) = "N" And strEntry(intBase + 14) = "N" Or Not blnNewMoon And strEntry(intBase + 17) = "Y" And strEntry(intBase + 18) = "N" And strEntry(intBase + 14) = "N" And strEntry(intBase + 19) = "N" Then
                            If blnNewMoon Then
                                Print #2, strEntry(intBase) & "," & udtLocation.dblLatitude & "," & udtLocation.dblLongitude & "," & udtLocation.dblHeight & "," & strEntry(intBase + 7) & "," & strEntry(intBase + 8) & "," & strEntry(intBase + 10) & "," & strEntry(intBase + 11) & "," & strEntry(intBase + 15) & "," & strEntry(intBase + 20) & "," & strEntry(intBase + 21) & "," & strEntry(intBase + 22)
                            Else
                                Print #2, strEntry(intBase) & "," & udtLocation.dblLatitude & "," & udtLocation.dblLongitude & "," & udtLocation.dblHeight & "," & strEntry(intBase + 7) & "," & strEntry(intBase + 8) & "," & strEntry(intBase + 10) & "," & strEntry(intBase + 11) & "," & strEntry(intBase + 16) & "," & strEntry(intBase + 20) & "," & strEntry(intBase + 21) & "," & strEntry(intBase + 22)
                            End If
                        Else
                            If blnNewMoon Then
                                Print #2, strEntry(intBase) & "," & udtLocation.dblLatitude & "," & udtLocation.dblLongitude & "," & udtLocation.dblHeight & "," & strEntry(intBase + 7) & "," & strEntry(intBase + 8) & "," & strEntry(intBase + 10) & ",," & strEntry(intBase + 15) & "," & strEntry(intBase + 20) & "," & strEntry(intBase + 21) & "," & strEntry(intBase + 22)
                            Else
                                Print #2, strEntry(intBase) & "," & udtLocation.dblLatitude & "," & udtLocation.dblLongitude & "," & udtLocation.dblHeight & "," & strEntry(intBase + 7) & "," & strEntry(intBase + 8) & "," & strEntry(intBase + 10) & ",," & strEntry(intBase + 16) & "," & strEntry(intBase + 20) & "," & strEntry(intBase + 21) & "," & strEntry(intBase + 22)
                            End If
                        End If
                    Else
                        If blnNewMoon Then
                            Print #2, strEntry(intBase) & "," & udtLocation.dblLatitude & "," & udtLocation.dblLongitude & "," & udtLocation.dblHeight & "," & strEntry(intBase + 7) & "," & strEntry(intBase + 8) & "," & strEntry(intBase + 10) & "," & strEntry(intBase + 11) & ",," & strEntry(intBase + 20) & "," & strEntry(intBase + 21) & "," & strEntry(intBase + 22)
                        Else
                            Print #2, strEntry(intBase) & "," & udtLocation.dblLatitude & "," & udtLocation.dblLongitude & "," & udtLocation.dblHeight & "," & strEntry(intBase + 7) & "," & strEntry(intBase + 8) & "," & strEntry(intBase + 10) & ",," & strEntry(intBase + 16) & "," & strEntry(intBase + 20) & "," & strEntry(intBase + 21) & "," & strEntry(intBase + 22)
                        End If
                    End If
                Else
                If photometric Then
                    Call cHBody.TrueHBody("Moon", dblDate + dblTime, udtMoon)
                    If Verbose Then
                        Print #2, strEntry(intBase), strEntry(intBase + 7), udtMoon.Phase, dblP
                    Else
                        Print #2, udtMoon.Phase, dblP
                    End If
                ElseIf VsQ And Not vsWp Then
                    If Verbose Then
                        Print #2, strEntry(intBase), strEntry(intBase + 7), dblQ, udtSun.AltTopo
                    Else
                        Print #2, dblQ, udtSun.AltTopo
                    End If
                ElseIf vsWp Then
                    If Not Topo Then
                        dblQ = udtSun.AltTopo + 5.9102 - dblQ * (5.7094 - dblQ * (1.4788 - dblQ * 0.1813))
                    Else
                        dblQ = udtSun.AltTopo + 6.444 - dblQ * (0.7039 - dblQ * (0.02572 - dblQ * 0.0004311))
                        If Not blnNewMoon Then dblQ = dblQ - 0.853
                    End If
                    If Verbose Then
                        Print #2, strEntry(intBase), strEntry(intBase + 7), dblWp, dblQ
                    Else
                        Print #2, dblWp, dblQ
                    End If
                Else
                    If Verbose Then
                        Print #2, strEntry(intBase), strEntry(intBase + 7), dblWp, dblARCV
                    Else
                        Print #2, dblWp, dblARCV
                    End If
                End If
                End If
            End If
        End If
    Next
    Close 2
End Sub
Sub DrawMoon(sngSize As Single, curDisplay As Object, dblAngle As Double, dblSubtend As Double)
    Dim sngX As Single
    Dim sngY As Single
    Dim intI As Integer
    
    sngX = curDisplay.CurrentX
    sngY = curDisplay.CurrentY
    curDisplay.Circle Step(-sngSize * sinD(dblAngle) / 2, -sngSize * cosD(dblAngle) / 2), sngSize / 2, , FracCirc(270 + dblAngle - dblSubtend / 2) * PI / 180, FracCirc(270 + dblAngle + dblSubtend / 2) * PI / 180
End Sub
Function Fingers(dblA As Double) As String 'Convert angle in degrees to fingers
    If dblA < 0.5 Then
        Fingers = "0"
    ElseIf dblA < 1.5 Then
        Fingers = " a finger"
    ElseIf dblA < 2.475 Then
        Fingers = "1 finger"
    ElseIf dblA < 3.425 Then
        Fingers = "1 fingers"
    ElseIf dblA < 4.4 Then
        Fingers = "2 fingers"
    ElseIf dblA < 5.4 Then
        Fingers = "2 fingers"
    ElseIf dblA < 6.475 Then
        Fingers = "3 fingers"
    ElseIf dblA < 7.625 Then
        Fingers = "3 fingers"
    ElseIf dblA < 8.65 Then
        Fingers = "4 fingers"
    ElseIf dblA < 11.25 Then
        Fingers = "1 fist"
    ElseIf dblA < 13.75 Then
        Fingers = "1 fists"
    ElseIf dblA < 16.25 Then
        Fingers = "1 fists"
    ElseIf dblA < 18.75 Then
        Fingers = "1 fists"
    ElseIf dblA < 25.2 Then
        Fingers = "1 span"
    ElseIf dblA < 30.8 Then
        Fingers = "1 spans"
    ElseIf dblA < 36.4 Then
        Fingers = "1 spans"
    ElseIf dblA < 42 Then
        Fingers = "1 spans"
    ElseIf dblA < 47.6 Then
        Fingers = "2 spans"
    Else
        Fingers = "more than 2 spans"
    End If
End Function
