VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSeasonal"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'(C)Roy E. Hoffman 2000
'See Main.bas for terms and conditions of use

'Seasonal time
'0-12: Apparent Sunset to Apparent Sunrise
'12-24: Apparent Sunrise to Apparent Sunset
Friend Function FixToSeasonal(dblFix As Double) As Double
'Convert UTC time in days to seasonal time
    Dim cHBody As New clsHBody
    Dim dblRiseTime As Double
    Dim dblSetTime As Double
    Dim intDayShift As Integer
    Dim blnNeverRises As Boolean
    Dim blnNeverSets As Boolean
    
    intDayShift = 0
    Call cHBody.RiseSet("Sun", Int(dblFix), False, dblRiseTime, True, blnNeverRises, blnNeverSets)
    Call cHBody.RiseSet("Sun", Int(dblFix), True, dblSetTime, True, blnNeverRises, blnNeverSets)
    While dblFix < dblRiseTime And dblFix < dblSetTime
        Call cHBody.RiseSet("Sun", Int(dblFix) + intDayShift - 1, True, dblSetTime, True, blnNeverRises, blnNeverSets)
        If dblFix < dblSetTime Then
            intDayShift = intDayShift - 1
            Call cHBody.RiseSet("Sun", Int(dblFix) + intDayShift, False, dblRiseTime, True, blnNeverRises, blnNeverSets)
        End If
    Wend
    While dblFix > dblSetTime And dblFix > dblRiseTime
        Call cHBody.RiseSet("Sun", Int(dblFix) + intDayShift + 1, False, dblRiseTime, True, blnNeverRises, blnNeverSets)
        If dblFix > dblRiseTime Then
            intDayShift = intDayShift + 1
            Call cHBody.RiseSet("Sun", Int(dblFix) + intDayShift, True, dblSetTime, True, blnNeverRises, blnNeverSets)
        End If
    Wend
    If dblRiseTime > dblSetTime Then
        FixToSeasonal = (dblFix - dblSetTime) / (dblRiseTime - dblSetTime) / 2
    Else
        FixToSeasonal = (dblFix - dblRiseTime) / (dblSetTime - dblRiseTime) / 2 + 0.5
    End If
End Function
Friend Function ToSeasonal(dblFix As Double, udtTimeIn As Mytime)
'Convert to the time format
    Dim dblTimeIn As Double
    Dim cDMS As New clsDMS
    
    dblTimeIn = FixToSeasonal(dblFix)
    udtTimeIn.bln24Hr = False
    udtTimeIn.blnPM = dblTimeIn >= 0.5
    udtTimeIn.enmTimeType = seasonal
    Call cDMS.ToDMS(dblTimeIn * 24, udtTimeIn.udtDms)
    Call frmTime.ToAMPM(udtTimeIn)
End Function
Friend Function FromSeasonal(udtTime As Mytime, blnValid As Boolean, enmType As DateType) As Double
'Convert seasonal time to UTC time in days
    Dim cHBody As New clsHBody
    Dim cDMS As New clsDMS
    Dim dblRiseTime As Double
    Dim dblSetTime As Double
    Dim blnNeverRises As Boolean
    Dim blnNeverSets As Boolean
    
    blnValid = True
    If frmTime.FromAMPM(udtTime) < 12 Then
        If udtTime.blnSecondTime Then
            Call cHBody.RiseSet("Sun", Int(dblDate), True, dblSetTime, True, blnNeverRises, blnNeverSets)
            Call cHBody.RiseSet("Sun", Int(dblDate + 1), False, dblRiseTime, True, blnNeverRises, blnNeverSets)
            FromSeasonal = frmTime.FromAMPM(udtTime) / 12 * (dblRiseTime - dblSetTime) + dblSetTime
        Else
            Call cHBody.RiseSet("Sun", Int(dblDate - 1), True, dblSetTime, True, blnNeverRises, blnNeverSets)
            Call cHBody.RiseSet("Sun", Int(dblDate), False, dblRiseTime, True, blnNeverRises, blnNeverSets)
            FromSeasonal = frmTime.FromAMPM(udtTime) / 12 * (dblRiseTime - dblSetTime) + dblSetTime
        End If
    Else
        Call cHBody.RiseSet("Sun", Int(dblDate), True, dblSetTime, True, blnNeverRises, blnNeverSets)
        Call cHBody.RiseSet("Sun", Int(dblDate), False, dblRiseTime, True, blnNeverRises, blnNeverSets)
        FromSeasonal = (frmTime.FromAMPM(udtTime) - 12) / 12 * (dblSetTime - dblRiseTime) + dblRiseTime
    End If
    FromSeasonal = FromSeasonal - Int(dblDate)
End Function
