VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsTrueSolar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'(C)Roy E. Hoffman 2000
'See Main.bas for terms and conditions of use

Friend Function FromTrueSolar(udtTime As Mytime, blnValid As Boolean, enmType As DateType) As Double
'Convert to UTC time in days from true solar time
    Dim cDMS As New clsDMS
    Dim udtSun As HBody
    Dim cSun As New clsSun
    Dim udtTimeIn As Mytime
    Dim udtTimeOut As Mytime
    Dim cMeanSolar As New clsMeanSolar
    Dim dblDiff As Double
    Dim dblTime As Double
    Dim dblSet As Double
    Dim blnNeverRises As Boolean
    Dim blnNeverSets As Boolean
    Dim cHebrew As New clsHebrew
    Dim dblOldDiff As Double

    blnValid = True
    udtTimeIn.enmTimeType = meansolar
    udtTimeIn.bln24Hr = udtTime.bln24Hr
    udtTimeIn.blnPM = udtTime.blnPM
    udtTimeIn.blnSecondTime = udtTime.blnSecondTime
    udtTimeIn.udtDms.blnSign = True
    udtTimeIn.udtDms.dblSeconds = udtTime.udtDms.dblSeconds
    udtTimeIn.udtDms.intMinutes = udtTime.udtDms.intMinutes
    udtTimeIn.udtDms.intDegreesHours = udtTime.udtDms.intDegreesHours
    udtTimeOut.enmTimeType = truesolar
    dblOldDiff = 1
    dblDiff = 0
    While Abs(dblDiff - dblOldDiff) > 1 / 72000
        dblTime = Frac((frmTime.FromAMPM(udtTimeIn) - udtLocation.dblLongitude / 15) / 24)
        If udtTimeIn.blnSecondTime Then dblTime = dblTime + 1
        Call ToTrueSolar(dblDate + dblTime, udtTimeOut)
        dblOldDiff = dblDiff
        dblDiff = frmTime.FromAMPM(udtTime) - frmTime.FromAMPM(udtTimeOut)
        If dblDiff >= 12 Then
            dblDiff = dblDiff - 24
        ElseIf dblDiff < -12 Then
            dblDiff = dblDiff + 24
        End If
        Call cDMS.ToDMS(frmTime.FromAMPM(udtTimeIn) + dblDiff, udtTimeOut.udtDms)
        Call frmTime.ToAMPM(udtTimeOut)
    Wend
    FromTrueSolar = Frac((frmTime.FromAMPM(udtTimeIn) - udtLocation.dblLongitude / 15) / 24)
    If enmType = Hebrew Or enmType = Islamic Then
        Call cHebrew.AdjustTime(Int(dblDate), FromTrueSolar, blnValid, udtTime.blnSecondTime)
    ElseIf frmTime.opt2 Then
        blnValid = False
    End If
End Function
Friend Function ToTrueSolar(dblFix As Double, udtTimeIn As Mytime) As Double
'Convert UTC time in days to true solar time
    Dim udtSun As HBody
    Dim cHBody As New clsHBody
    Dim cDMS As New clsDMS
    Dim dblTimeIn As Double
    
    udtTimeIn.enmTimeType = truesolar
    udtTimeIn.bln24Hr = udtTime.bln24Hr
    udtTimeIn.blnPM = udtTime.blnPM
    Call cHBody.TrueHBody("Sun", dblFix, udtSun)
    dblTimeIn = udtSun.HourAngTopo / 360 + 0.5
    If dblTimeIn >= 1 Then
        dblTimeIn = dblTimeIn - 1
    ElseIf dblTimeIn < 0 Then
        dblTimeIn = dblTimeIn + 1
    End If
    Call cDMS.ToDMS(dblTimeIn * 24, udtTimeIn.udtDms)
    Call frmTime.ToAMPM(udtTimeIn)
End Function
Friend Sub StartEndOfDay(dblFix As Double, enmDateType As DateType, dblStart As Double, dblEnd As Double, intDayShift As Integer)
'Get start and end of true solar day (true midnight unless Hebrew or Islamic calendar)
    Dim cHebrew As New clsHebrew
    Dim cHBody As New clsHBody
    
    intDayShift = 0
    If enmDateType < Hebrew Then
        Call cHBody.Meridian("Sun", Int(dblFix), False, dblStart)
        Call cHBody.Meridian("Sun", Int(dblFix) + 1, False, dblEnd)
        While dblStart + intDayShift > dblFix
            intDayShift = intDayShift - 1
            dblEnd = dblStart
            Call cHBody.Meridian("Sun", Int(dblFix) + intDayShift, False, dblStart)
        Wend
        While dblEnd + 1 + intDayShift < dblFix
            intDayShift = intDayShift + 1
            dblStart = dblEnd
            Call cHBody.Meridian("Sun", Int(dblFix) + 1 + intDayShift, False, dblEnd)
        Wend
    Else
        Call cHebrew.StartEndDay(dblFix, dblStart, dblEnd, intDayShift)
    End If
End Sub
Friend Function ZeroTime(dblFix As Double) As Double
    Dim cHBody As New clsHBody
    Dim intDayShift As Integer
    Dim dblEnd As Double
    
    intDayShift = 0
    Call cHBody.Meridian("Sun", Int(dblFix), False, ZeroTime)
    dblEnd = ZeroTime
    While ZeroTime + intDayShift > dblFix
        intDayShift = intDayShift - 1
        dblEnd = ZeroTime
        Call cHBody.Meridian("Sun", Int(dblFix) + intDayShift, False, ZeroTime)
    Wend
    While dblEnd + 1 + intDayShift < dblFix
        intDayShift = intDayShift + 1
        ZeroTime = dblEnd
        Call cHBody.Meridian("Sun", Int(dblFix) + 1 + intDayShift, False, dblEnd)
    Wend
    ZeroTime = ZeroTime - Int(dblFix + udtLocation.dblLongitude / 360)
End Function
