VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSun"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'(C)Roy E. Hoffman 2000
'See Main.bas for terms and conditions of use
'Some of the algorithms from
'J. Meeus, "Astronomical Algorithms", 2nd Ed., William-Bell Inc., Richmond, VG, 1998, p. 87

Const TPI = 6.28318530717959
Const PI = 3.14159265358979
Const RADCON = 0.01745329252
Const AU = 149597870 'Astronomical unit in km
Friend Function MeanSun(dblFix As Double) As Double 'Longitude in degrees
    Dim cHBody As New clsHBody
    Dim dblT As Double
    
    dblT = cHBody.ToJ2000(dblFix)
    MeanSun = FracCirc(280.46646 + dblT * (36000.76983 + 0.0003032 * dblT))
End Function
Sub DrawHalfSun(sngSize As Single, curDisplay As Object)
    Dim sngX As Single
    Dim sngY As Single
    Dim intI As Integer
    
    sngX = curDisplay.CurrentX
    sngY = curDisplay.CurrentY
    curDisplay.Circle Step(0, 0), sngSize / 4, , 0, PI
    For intI = 0 To 6
        curDisplay.Line (sngX + sngSize / 2 * Cos(intI * PI / 6), sngY - sngSize / 2 * Sin(intI * PI / 6))-(sngX + sngSize * 0.35 * Cos(intI * PI / 6), sngY - sngSize * 0.35 * Sin(intI * PI / 6))
    Next
End Sub

