VERSION 5.00
Begin VB.Form frmGraph 
   Caption         =   "Location of the Moon"
   ClientHeight    =   4500
   ClientLeft      =   60
   ClientTop       =   348
   ClientWidth     =   6708
   Icon            =   "frmGraph.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   4500
   ScaleWidth      =   6708
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox pctGraph 
      AutoRedraw      =   -1  'True
      BackColor       =   &H8000000E&
      DrawWidth       =   2
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.4
         Charset         =   177
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   4095
      Left            =   120
      ScaleHeight     =   4044
      ScaleWidth      =   6324
      TabIndex        =   0
      Top             =   120
      Width           =   6375
   End
   Begin VB.Label lblGraph 
      Caption         =   "Dotted Red - not visible, Dashed Blue - May be visible, Solid Black - Definately visible"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   4200
      Width           =   6375
   End
End
Attribute VB_Name = "frmGraph"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'(C)Roy E. Hoffman 2000
'See Main.bas for terms and conditions of use
Const ThinLine = 0.0035 'relative to root display area
Const VThinLine = 0.00175
Const ThickLine = 0.007
Const ObjSize = 0.1
Const StarSize = ObjSize / 5

Dim curDisp As Object
Const intEarly = 30 'Minutes before first possible visibility
Private Type MyArray
    intN As Integer
    dblT(5) As Double
    MAZ() As Double
    MAL() As Double
End Type

Friend Sub DrawProb(curDisplay As Object, Optional blnClear As Boolean = True, Optional dblYPosMin As Double = 0)
    Dim lngFix As Long
    Dim udtObj(5) As MyArray
    Dim dblAppMag As Double
    Dim dblBSky As Double
    Dim dblLogB As Double
    Dim cHBody As New clsHBody
    Dim cLocal As New clsLocalTime
    Dim blnNew As Boolean
    Dim dblYallopQ As Double
    Dim blnEasy As Boolean
    Dim blnNotVisible As Boolean
    Dim dblProbVis As Double
    Dim dblRiseSetTime As Double
    Dim blnNeverRises As Boolean
    Dim blnNeverSets As Boolean
    Dim intI As Integer
    Dim dblTM As Double
    Dim dblX() As Double
    Dim dblY() As Double
    Dim udtTimeIn As Mytime
    Dim udtMoon As HBody
    Dim cSky As New clsSky
    Dim dblXMin As Double
    Dim dblXMax As Double
    Dim dblYMin As Double
    Dim dblYMax As Double
    Dim intX As Integer
    Dim intY As Integer
    Dim intTickLength As Integer
    Dim dblXRangeMin As Double
    Dim dblXRangeMax As Double
    Dim dblYRangeMin As Double
    Dim dblYRangeMax As Double
    Dim intadd As Integer
    Dim intStep As Integer
    
    
    'Set the font size
    curDisplay.ScaleMode = vbPoints
    curDisplay.FontSize = curDisplay.ScaleWidth / 32
    curDisplay.ScaleMode = vbPixels
    If blnClear Then curDisplay.Cls
    lblGraph = "Probability versus time"
    lngFix = frmDate.ToLngDate(dblDate + dblTime)
    Call cHBody.Visibility("Moon", lngFix, blnNew, dblYallopQ, udtObj(0).dblT, blnEasy, blnNotVisible, dblProbVis, udtVisibilitySave(0).blnTopo, udtVisibilitySave(0).blnPhotometric)
    Call CalcCurve(curDisplay, "Moon", lngFix, udtObj, 0, blnNew, intStep)
    dblYMin = MyMin(udtObj(0).MAL, udtObj(0).intN)
    dblYMax = MyMax(udtObj(0).MAL, udtObj(0).intN)
    dblXMin = MyMin(udtObj(0).MAZ, udtObj(0).intN)
    dblXMax = MyMax(udtObj(0).MAZ, udtObj(0).intN)
    'Find out the space required for the scale
    Call ScaleTextSize(dblXMin, dblXMax, intX, intY, "Time", pctGraph)
    intTickLength = intY / 2
    dblYRangeMin = 0
    dblYRangeMax = pctGraph.ScaleHeight - (intY + intTickLength)
    'Repeat for the Y-Scale
    Call ScaleTextSize(dblYMin, dblYMax, intX, intY, "P", pctGraph)
    intTickLength = intY / 2
    dblXRangeMin = (intX + intTickLength)
    dblXRangeMax = pctGraph.ScaleWidth
    pctGraph.ForeColor = vbBlack
    pctGraph.DrawWidth = 1
    'Draw the Y-Scale
    Call DrawScale(dblYMin, dblYMax, dblXRangeMin, dblYRangeMax, dblXRangeMin, 0, intTickLength, "P", pctGraph, 0)
    'Draw the X-Scale
    Call DrawScale(dblXMin, dblXMax, dblXRangeMin, dblYRangeMax, CSng(pctGraph.ScaleWidth), dblYRangeMax, intTickLength, "Time", pctGraph, 0, False, False)
    Call DrawLine(udtObj(0).MAZ, udtObj(0).MAL, dblXMin, dblXMax, dblYMin, dblYMax, dblXRangeMin, dblXRangeMax, dblYRangeMin, dblYRangeMax, udtObj(0).intN, udtObj(0).MAZ, "", blnNew, intTickLength, pctGraph, 1)
End Sub
Friend Sub LightCurve(curDisplay As Object)
    Dim lngFix As Long
    Dim udtObj(5) As MyArray
    Dim dblAppMag As Double
    Dim dblBSky As Double
    Dim dblLogB As Double
    Dim cHBody As New clsHBody
    Dim cLocal As New clsLocalTime
    Dim blnNew As Boolean
    Dim dblYallopQ As Double
    Dim blnEasy As Boolean
    Dim blnNotVisible As Boolean
    Dim dblProbVis As Double
    Dim dblRiseSetTime As Double
    Dim blnNeverRises As Boolean
    Dim blnNeverSets As Boolean
    Dim intI As Integer
    Dim dblTM As Double
    Dim dblX() As Double
    Dim dblY() As Double
    Dim udtTimeIn As Mytime
    Dim udtMoon As HBody
    Dim cSky As New clsSky
    Dim dblXMin As Double
    Dim dblXMax As Double
    Dim dblYMin As Double
    Dim dblYMax As Double
    Dim intX As Integer
    Dim intY As Integer
    Dim intTickLength As Integer
    Dim intStep As Integer
    Dim dblXRangeMin As Double
    Dim dblXRangeMax As Double
    Dim dblYRangeMin As Double
    Dim dblYRangeMax As Double
    Dim intadd As Integer
    
    
    pctGraph.Cls
    curDisplay.ScaleMode = vbPoints
    curDisplay.FontSize = curDisplay.ScaleWidth / 32
    curDisplay.ScaleMode = vbPixels
    lblGraph = "Dotted Red - not visible, Dashed Blue - May be visible, Solid Black - Definately visible"
    lngFix = frmDate.ToLngDate(dblDate + dblTime)
    Call CalcCurve(curDisplay, "Moon", lngFix, udtObj, 0, blnNew, intStep)
    dblYMin = MyMin(udtObj(0).MAL, udtObj(0).intN)
    dblYMax = MyMax(udtObj(0).MAL, udtObj(0).intN)
    dblXMin = MyMin(udtObj(0).MAZ, udtObj(0).intN)
    dblXMax = MyMax(udtObj(0).MAZ, udtObj(0).intN)
    'Find out the space required for the scale
    Call ScaleTextSize(dblXMin, dblXMax, intX, intY, "Log(B)", pctGraph)
    intTickLength = intY / 2
    dblYRangeMin = 0
    dblYRangeMax = pctGraph.ScaleHeight - (intY + intTickLength)
    'Repeat for the Y-Scale
    Call ScaleTextSize(dblYMin, dblYMax, intX, intY, "Mag", pctGraph)
    intTickLength = intY / 2
    dblXRangeMin = (intX + intTickLength)
    dblXRangeMax = pctGraph.ScaleWidth
    pctGraph.ForeColor = vbBlack
    pctGraph.DrawWidth = 1
    'Draw the Y-Scale
    Call DrawScale(dblYMin, dblYMax, dblXRangeMin, dblYRangeMax, dblXRangeMin, 0, intTickLength, "Mag", pctGraph, 0)
    'Draw the X-Scale
    Call DrawScale(dblXMin, dblXMax, dblXRangeMin, dblYRangeMax, CSng(pctGraph.ScaleWidth), dblYRangeMax, intTickLength, "lg(B)", pctGraph, 0)
    Call DrawLine(udtObj(0).MAZ, udtObj(0).MAL, dblXMin, dblXMax, dblYMin, dblYMax, dblXRangeMin, dblXRangeMax, dblYRangeMin, dblYRangeMax, udtObj(0).intN, udtObj(0).dblT, "", blnNew, intTickLength, pctGraph, intStep)
End Sub
Friend Sub DrawGraph(curDisplay As Object, Optional blnClear As Boolean = True, Optional dblYPosMin As Double = 0)
'Draw graph of appearence of the Moon
'   CurDisplay window or printer
'   blnClear clear the object first
'   dblYPosMin set to 0 for screen ar to allow for text on printer
    
    Dim cMoon As New clsMoon
    'Azimuths and altitudes in degrees
    '   0   Sun
    '   1   Moon
    '   2   Mercury
    '   3   Venus
    '   5   Jupiter
    Dim dblMAZ() As Double
    Dim dblMAL() As Double
    'Interpolated azimuths and altitudes
    Dim dblMAZ2() As Double
    Dim dblMAL2() As Double
    Dim dblMT() As Double 'Times
    Dim blnNew As Boolean 'New (evening) or old (morning) Moon
    Dim dblYallopQ As Double 'Yallop's ease of visibility
    '0 Moon, 1 Sun, 2 Mercury, 3 Venus, 5 Jupiter
    Dim dblExpand(3) As Double 'Expand the frame as necessary
    '0 Up, 1 Right, 2 Down, 3 Left - used to accommodate objects at edge
    Dim udtObj(5) As MyArray 'Array of object's parameters
    Dim blnEasy As Boolean 'Easy to see
    Dim blnNotVisible As Boolean 'Invisible
    Dim dblProbVis As Double 'Probability of visibility
    Dim dblTM As Double
    Dim dblTM2 As Double
    Dim udtMoon As HBody
    Dim intI As Integer
    Dim intJ As Integer
    Dim dblYMin As Double
    Dim dblYMax As Double
    Dim dblXMin As Double
    Dim dblXMax As Double
    Dim sngX0 As Double
    Dim sngX1 As Double
    Dim sngY0 As Double
    Dim sngY1 As Double
    Dim dblXRangeMin As Double
    Dim dblXRangeMax As Double
    Dim dblYRangeMin As Double
    Dim dblYRangeMax As Double
    Dim intX As Integer
    Dim intY As Integer
    Dim intTickLength As Integer
    Dim dblAngle As Double
    Dim dblSubtend As Double
    Dim dblLength As Double
    Dim strLabel As String
    Dim lngFix As Long
    Dim cSun As New clsSun
    Dim udtBody As HBody
    Dim dblRiseSetTime As Double
    Dim blnRefrValid As Boolean
    Dim intadd As Integer 'Days to add for rising and setting
    Dim dblDisplaySize As Double
    Dim cPlanet As New clsPlanet
    Dim cSky As New clsSky
    Dim intStep As Integer
    Dim intInterp As Integer
    Dim dblTemp As Double
    Dim dblRise As Double
    Dim dblSet As Double
    Dim blnNeverRises(1) As Boolean
    Dim blnNeverSets(1) As Boolean
    Dim cHBody As New clsHBody
    
    'Set the font size
    curDisplay.ScaleMode = vbPoints
    curDisplay.FontSize = curDisplay.ScaleWidth / 32
    curDisplay.ScaleMode = vbPixels 'Set the scale mode for calculating line width
    If lngGraphType <> 1 Then
        udtGraph.blnMode = True 'Detailed graph
    Else
        udtGraph.blnMode = False 'Sketch
    End If
    lblGraph = "Dotted Red - not visible, Dashed Blue - May be visible, Solid Black - Definately visible"
    If Not udtGraph.blnMode Then curDisplay.FontSize = 24
    If blnClear Then curDisplay.Cls 'Clear the display
    lngFix = frmDate.ToLngDate(dblDate + dblTime)
    blnNew = cHBody.EveningSight("Moon", lngFix)
    'Moon
    Call CalcCurve(curDisplay, "Moon", lngFix, udtObj, 0, blnNew, intStep)
    If udtObj(0).intN > -1 Then
        'Sun
        Call CalcCurve(curDisplay, "Sun", lngFix, udtObj, 0, blnNew, intStep)
        'Mercury
        With udtObj(2)
            intI = 0
            dblTM = Int((udtObj(0).dblT(4)) * 1440 + 1) / 1440
            Call cHBody.TrueHBody("Mercury", dblTM, udtBody)
            'Moon appers before Mercury if it is above it or phase > 2.5%
            If udtObj(0).intN < 0 Then
                .intN = -1
            ElseIf sinD(udtObj(0).MAL(intI)) * sinD(udtBody.AltRefr) + cosD(udtObj(0).MAL(intI)) * cosD(udtBody.AltRefr) * cosD(udtObj(0).MAZ(intI) - udtBody.AzTopo) < 0.766 Or udtBody.AltRefr <= udtObj(0).MAL(intI) Then
                .intN = -1
            Else
                Call cHBody.TrueHBody("Moon", dblTM, udtBody)
                If udtBody.Phase > 0.025 Then
                    .intN = -1
                Else
                    Call CalcCurve(curDisplay, "Mercury", lngFix, udtObj, 0, blnNew, intStep)
                End If
            End If
        End With
        'Venus
        With udtObj(3)
            intI = 0
            dblTM = Int((udtObj(0).dblT(4)) * 1440 + 1) / 1440
            Call cHBody.TrueHBody("Venus", dblTM, udtBody)
            'Moon appers before Venus if it is above or not far below it or phase > 5%
            If udtObj(0).intN < 0 Then
                .intN = -1
            ElseIf sinD(udtObj(0).MAL(intI)) * sinD(udtBody.AltRefr) + cosD(udtObj(0).MAL(intI)) * cosD(udtBody.AltRefr) * cosD(udtObj(0).MAZ(intI) - udtBody.AzTopo) < 0.766 Or udtBody.AltRefr <= udtObj(0).MAL(intI) - 5 Then
                .intN = -1
            Else
                Call cHBody.TrueHBody("Moon", dblTM, udtBody)
                If udtBody.Phase > 0.05 Then
                    .intN = -1
                Else
                    Call CalcCurve(curDisplay, "Venus", lngFix, udtObj, 0, blnNew, intStep)
                End If
            End If
        End With
        udtObj(4).intN = -1
        'Jupiter
        With udtObj(5)
            intI = 0
            dblTM = Int((udtObj(0).dblT(4)) * 1440 + 1) / 1440
            Call cHBody.TrueHBody("Jupiter", dblTM, udtBody)
            'Moon appers before Juptier if it is above it or phase > 3.5%
            If udtObj(0).intN < 0 Then
                .intN = -1
            ElseIf sinD(udtObj(0).MAL(intI)) * sinD(udtBody.AltRefr) + cosD(udtObj(0).MAL(intI)) * cosD(udtBody.AltRefr) * cosD(udtObj(0).MAZ(intI) - udtBody.AzTopo) < 0.766 Or udtBody.AltRefr <= udtObj(0).MAL(intI) Then
                .intN = -1
            Else
                Call cHBody.TrueHBody("Moon", dblTM, udtBody)
                If udtBody.Phase > 0.035 Then
                    .intN = -1
                Else
                    Call CalcCurve(curDisplay, "Jupiter", lngFix, udtObj, 0, blnNew, intStep)
                End If
            End If
        End With
        With udtObj(0)
            dblYMin = MyMin(.MAL, .intN)
            dblYMax = MyMax(.MAL, .intN)
            dblXMin = MyMin(.MAZ, .intN)
            dblXMax = MyMax(.MAZ, .intN)
        End With
        For intI = 0 To 3
            dblExpand(intI) = 0
        Next
        curDisplay.ScaleMode = vbPixels
        dblDisplaySize = Sqr(curDisplay.ScaleWidth * curDisplay.ScaleHeight)
        For intI = 0 To 5 'Find the limits of the lines
            With udtObj(intI)
                If .intN > -1 Then
                    dblTM = MyMin(.MAL, .intN)
                    If dblTM < dblYMin Then
                        dblYMin = dblTM
                    End If
                    dblTM = MyMax(.MAL, .intN)
                    If dblTM > dblYMax Then
                        dblYMax = dblTM
                        dblExpand(0) = ThinLine * dblDisplaySize / 2
                    End If
                    dblTM = MyMin(.MAZ, .intN)
                    If dblTM < dblXMin Then
                        dblXMin = dblTM
                        dblExpand(3) = ThinLine * dblDisplaySize / 2
                    End If
                    dblTM = MyMax(.MAZ, .intN)
                    If dblTM > dblXMax Then
                        dblXMax = dblTM
                        dblExpand(1) = ThinLine * dblDisplaySize / 2
                    End If
                ElseIf .intN = 0 Then
                    If .MAL(0) < dblYMin Then dblYMin = .MAL(0)
                    If .MAL(0) > dblYMax Then
                        dblYMax = .MAL(0)
                        If intI = 1 Then
                            dblExpand(0) = ObjSize * dblDisplaySize / 2
                        Else
                            dblExpand(0) = StarSize * dblDisplaySize / 2
                        End If
                    End If
                    If .MAZ(0) < dblXMin Then
                        dblXMin = .MAZ(0)
                        If intI = 1 Then
                            dblExpand(3) = ObjSize * dblDisplaySize / 2
                        Else
                            dblExpand(3) = StarSize * dblDisplaySize / 2
                        End If
                    End If
                    If .MAZ(0) > dblXMax Then
                        dblXMax = .MAZ(0)
                        If intI = 1 Then
                            dblExpand(1) = ObjSize * dblDisplaySize / 2
                        Else
                            dblExpand(1) = StarSize * dblDisplaySize / 2
                        End If
                    End If
                End If
            End With
        Next
        dblXMin = dblXMin - dblExpand(3) * (dblXMax - dblXMin + (dblExpand(1) + dblExpand(3)) / curDisplay.ScaleWidth) / curDisplay.ScaleWidth
        dblXMax = dblXMax + dblExpand(1) * (dblXMax - dblXMin + (dblExpand(1) + dblExpand(3)) / curDisplay.ScaleWidth) / curDisplay.ScaleWidth
        If lngPlotMode = 2 Then 'Proportional axes
            If (dblXMax - dblXMin) / curDisplay.ScaleWidth < (dblYMax - dblYMin) / curDisplay.ScaleHeight Then
                dblTM = ((dblYMax - dblYMin) * curDisplay.ScaleWidth / curDisplay.ScaleHeight - (dblXMax - dblXMin)) / 2
                dblXMax = dblXMax + dblTM
                dblXMin = dblXMin - dblTM
            Else
                dblTM = ((dblXMax - dblXMin) * curDisplay.ScaleHeight / curDisplay.ScaleWidth - (dblYMax - dblYMin)) / 2
                'Find apparent sea-level horizon
                dblTM2 = cHBody.Refract(cSky.SeaLevelHorizon(udtWeatherNow), True, udtWeatherNow, True)
                'Don't draw below the apparent horizon or the lowest point whichever is lowest
                If dblYMin < dblTM2 Then
                    dblYMax = dblYMax + 2 * dblTM
                ElseIf dblYMin - dblTM < dblTM2 Then
                    dblYMax = dblYMax + 2 * dblTM - dblYMin + dblTM2
                    dblYMin = dblTM2
                Else
                    dblYMax = dblYMax + dblTM
                    dblYMin = dblYMin - dblTM
                End If
            End If
        End If
        If curDisplay.ScaleHeight > 0 Then dblYMax = dblYMax + dblExpand(0) * (dblYMax - dblYMin + (dblExpand(0) + dblExpand(2)) / curDisplay.ScaleHeight) / curDisplay.ScaleHeight
        'Find out the space required for the scale
        Call ScaleTextSize(dblXMin, dblXMax, intX, intY, "Azimuth", curDisplay)
        intTickLength = intY / 2
        dblYRangeMin = dblYPosMin
        dblYRangeMax = curDisplay.ScaleHeight - (intY + intTickLength)
        'Repeat for the Y-Scale
        If udtGraph.blnMode Then
            Call ScaleTextSize(dblYMin, dblYMax, intX, intY, "Alt", curDisplay)
            intTickLength = intY / 2
            dblXRangeMin = (intX + intTickLength)
        Else
            dblXRangeMin = 0
        End If
        dblXRangeMax = curDisplay.ScaleWidth
        curDisplay.ForeColor = vbBlack
        curDisplay.DrawWidth = 1
        'Draw the Y-Scale in detailed mode only
        If udtGraph.blnMode Then Call DrawScale(dblYMin, dblYMax, dblXRangeMin, dblYRangeMax, dblXRangeMin, dblYRangeMin, intTickLength, "Alt", curDisplay, dblYPosMin)
        'Draw the X-Scale
        If Not udtGraph.blnMode Then 'use fixed scale
            dblXMin = dblXMin - 4
            dblXMax = dblXMax + 4
            If blnNew Then
                If dblXMin > 270 Then dblXMin = 270
                If dblXMax < 270 Then dblXMax = 270
            Else
                If dblXMin > 90 Then dblXMin = 90
                If dblXMax < 90 Then dblXMax = 90
            End If
            dblXRangeMin = 30
            dblXRangeMax = 30 + (dblXMax - dblXMin) * 15
            dblYRangeMin = 30
            dblYRangeMax = 30 + (dblYMax - dblYMin) * 15
        End If
        Call DrawScale(dblXMin, dblXMax, dblXRangeMin, dblYRangeMax, dblXRangeMax, dblYRangeMax, intTickLength, "Azimuth", curDisplay, dblYPosMin, Not udtGraph.blnMode, True)
        Call DrawLine(udtObj(0).MAZ, udtObj(0).MAL, dblXMin, dblXMax, dblYMin, dblYMax, dblXRangeMin, dblXRangeMax, dblYRangeMin, dblYRangeMax, udtObj(0).intN, udtObj(0).dblT, "Moon", blnNew, intTickLength, curDisplay, intStep)
        If udtObj(1).intN >= 0 Then Call DrawLine(udtObj(1).MAZ, udtObj(1).MAL, dblXMin, dblXMax, dblYMin, dblYMax, dblXRangeMin, dblXRangeMax, dblYRangeMin, dblYRangeMax, udtObj(1).intN, udtObj(1).dblT, "Sun", blnNew, intTickLength, curDisplay, intStep)
        If udtObj(2).intN >= 0 Then Call DrawLine(udtObj(2).MAZ, udtObj(2).MAL, dblXMin, dblXMax, dblYMin, dblYMax, dblXRangeMin, dblXRangeMax, dblYRangeMin, dblYRangeMax, udtObj(2).intN, udtObj(2).dblT, "Mercury", blnNew, intTickLength, curDisplay, intStep)
        If udtObj(3).intN >= 0 Then Call DrawLine(udtObj(3).MAZ, udtObj(3).MAL, dblXMin, dblXMax, dblYMin, dblYMax, dblXRangeMin, dblXRangeMax, dblYRangeMin, dblYRangeMax, udtObj(3).intN, udtObj(3).dblT, "Venus", blnNew, intTickLength, curDisplay, intStep)
        If udtObj(5).intN >= 0 Then Call DrawLine(udtObj(5).MAZ, udtObj(5).MAL, dblXMin, dblXMax, dblYMin, dblYMax, dblXRangeMin, dblXRangeMax, dblYRangeMin, dblYRangeMax, udtObj(5).intN, udtObj(5).dblT, "Jupiter", blnNew, intTickLength, curDisplay, intStep)
        udtGraph.blnMercury = udtObj(2).intN >= 0
        udtGraph.blnVenus = udtObj(3).intN >= 0
        udtGraph.blnJupiter = udtObj(4).intN >= 0
    End If
End Sub
Private Sub DrawLine(dblX() As Double, dblY() As Double, dblXMin As Double, dblXMax As Double, dblYMin As Double, dblYMax As Double, dblXRangeMin As Double, dblXRangeMax As Double, dblYRangeMin As Double, dblYRangeMax As Double, intN As Integer, dblT() As Double, strLabel As String, blnNew As Boolean, intTickLength As Integer, curDisplay As Object, intStep As Integer)
    Dim intI As Integer
    Dim dblTM As Double
    Dim sngX0 As Single
    Dim sngX1 As Single
    Dim sngY0 As Single
    Dim sngY1 As Single
    Dim dblLength As Double
    Dim strTime As String
    Dim intJ As Integer
    Dim cLocalT As New clsLocalTime
    Dim udtTimeIn As Mytime
    Dim dblDisplaySize As Double
    Dim cSun As New clsSun
    Dim cPlanet As New clsPlanet
    Dim cMoon As New clsMoon
    Dim intDrawWidth As Integer
    Dim dblAngle As Double
    Dim dblSubtend As Double
    Dim dblAltitude As Double
    Dim dblAzimuth As Double
    
    'curDisplay.ScaleMode = vbPoints
    'curDisplay.FontSize = curDisplay.ScaleWidth / 32
    'curDisplay.ScaleMode = vbPixels
    dblDisplaySize = Sqr(curDisplay.ScaleWidth * curDisplay.ScaleHeight)
    If intN = 0 Or Not udtGraph.blnMode And strLabel = "Moon" And intN >= 0 Then
        dblDisplaySize = 450
        If strLabel = "Sun" Then
            curDisplay.CurrentX = (dblX(0) - dblXMin) / (dblXMax - dblXMin) * (dblXRangeMax - dblXRangeMin) + dblXRangeMin
            If dblYMax = dblYMin Then
                curDisplay.CurrentY = dblYRangeMax
            Else
                curDisplay.CurrentY = (1 - (dblY(0) - dblYMin) / (dblYMax - dblYMin)) * (dblYRangeMax - dblYRangeMin) + dblYRangeMin
            End If
            Call cSun.DrawHalfSun(CSng(75), curDisplay)
        ElseIf strLabel <> "Moon" Then
            curDisplay.CurrentX = (dblX(0) - dblXMin) / (dblXMax - dblXMin) * (dblXRangeMax - dblXRangeMin) + dblXRangeMin
            curDisplay.CurrentY = (1 - (dblY(0) - dblYMin) / (dblYMax - dblYMin)) * (dblYRangeMax - dblYRangeMin) + dblYRangeMin
            Call cPlanet.DrawStar(CSng(15), curDisplay)
        Else
            If blnNew Then 'draw at start of line
                curDisplay.CurrentX = (dblX(0) - dblXMin) / (dblXMax - dblXMin) * (dblXRangeMax - dblXRangeMin) + dblXRangeMin
                curDisplay.CurrentY = (1 - (dblY(0) - dblYMin) / (dblYMax - dblYMin)) * (dblYRangeMax - dblYRangeMin) + dblYRangeMin
                Call cMoon.BrightLimb(dblT(4), dblAngle, dblSubtend, dblAltitude, dblAzimuth, True)
                Call cMoon.DrawMoon(CSng(37.5), curDisplay, dblAngle, dblSubtend)
            Else 'draw at end of line
                curDisplay.CurrentX = (dblX(intN) - dblXMin) / (dblXMax - dblXMin) * (dblXRangeMax - dblXRangeMin) + dblXRangeMin
                curDisplay.CurrentY = (1 - (dblY(intN) - dblYMin) / (dblYMax - dblYMin)) * (dblYRangeMax - dblYRangeMin) + dblYRangeMin
                Call cMoon.BrightLimb(dblT(5), dblAngle, dblSubtend, dblAltitude, dblAzimuth, True)
                Call cMoon.DrawMoon(CSng(37.5), curDisplay, dblAngle, dblSubtend)
            End If
        End If
    End If
    If intN > 0 Then
    For intI = 1 To intN
        dblTM = (Int(dblT(4) * 1440 / intStep) * intStep + (intI + 1) * intStep) / 1440
        If udtGraph.blnMode Or (dblTM > dblT(0) And dblTM < dblT(3)) Then
            curDisplay.ForeColor = vbBlack
            If (dblTM < dblT(0) Or dblTM > dblT(3)) Then
                If lngGraphType = 0 Or lngGraphType = 2 Or lngGraphType = 4 Then curDisplay.ForeColor = vbRed
                intDrawWidth = ThickLine * dblDisplaySize
                If intDrawWidth < 1 Then intDrawWidth = 1
                curDisplay.DrawWidth = intDrawWidth
            ElseIf (dblTM < dblT(1) Or dblTM > dblT(2)) Then
                If udtGraph.blnMode Then
                    If lngGraphType = 0 Or lngGraphType = 2 Or lngGraphType = 4 Then curDisplay.ForeColor = vbBlue
                    intDrawWidth = ThickLine * dblDisplaySize
                    If intDrawWidth < 1 Then intDrawWidth = 1
                    curDisplay.DrawWidth = intDrawWidth
                Else
                    'curDisplay.ForeColor = vbBlack
                    intDrawWidth = ThickLine * dblDisplaySize
                    If intDrawWidth < 1 Then intDrawWidth = 1
                    curDisplay.DrawWidth = intDrawWidth
                End If
            Else
                curDisplay.ForeColor = vbBlack
                intDrawWidth = ThickLine * dblDisplaySize
                If intDrawWidth < 1 Then intDrawWidth = 1
                curDisplay.DrawWidth = intDrawWidth
            End If
            sngX0 = (dblX(intI - 1) - dblXMin) / (dblXMax - dblXMin) * (dblXRangeMax - dblXRangeMin) + dblXRangeMin
            sngY0 = (1 - (dblY(intI - 1) - dblYMin) / (dblYMax - dblYMin)) * (dblYRangeMax - dblYRangeMin) + dblYRangeMin
            sngX1 = (dblX(intI) - dblXMin) / (dblXMax - dblXMin) * (dblXRangeMax - dblXRangeMin) + dblXRangeMin
            sngY1 = (1 - (dblY(intI) - dblYMin) / (dblYMax - dblYMin)) * (dblYRangeMax - dblYRangeMin) + dblYRangeMin
            If lngGraphType = 3 Or (intI Mod 2 = 0 And dblTM >= dblT(0) And dblTM <= dblT(3) Or dblTM > dblT(1) And dblTM < dblT(2)) Then
                curDisplay.Line (sngX0, sngY0)-(sngX1, sngY1)
            ElseIf dblTM < dblT(0) Or dblTM > dblT(3) Then
                curDisplay.PSet (sngX0, sngY0)
            End If
            If MyMod(dblTM * 1440, 10 * intStep) = 0 And udtGraph.blnMode And lngGraphType <> 3 Then 'labels only every 10 mins and not in simple mode
                dblLength = Sqr(Square(sngX1 - sngX0) + Square(sngY1 - sngY0))
                If udtLocation.dblLatitude >= 0 Then
                    curDisplay.Line (sngX0, sngY0)-(sngX0 + (sngY1 - sngY0) * intTickLength / dblLength, sngY0 - (sngX1 - sngX0) * intTickLength / dblLength)
                Else
                    curDisplay.Line (sngX0, sngY0)-(sngX0 - (sngY1 - sngY0) * intTickLength / dblLength, sngY0 + (sngX1 - sngX0) * intTickLength / dblLength)
                End If
                If udtGraph.blnMode Then 'No labels in simple mode
                    Call cLocalT.ToLocal(dblTM + 0.00048, udtTimeIn)
                    strTime = udtTimeIn.udtDms.intDegreesHours & ":" & Format(udtTimeIn.udtDms.intMinutes, "00")
                    curDisplay.CurrentY = curDisplay.CurrentY - curDisplay.TextHeight(strLabel)
                    If Not blnNew And udtLocation.dblLatitude >= 0 Or blnNew And udtLocation.dblLatitude < 0 Then curDisplay.CurrentX = curDisplay.CurrentX - curDisplay.TextWidth(strLabel)
                    curDisplay.Print strTime
                End If
            End If
        End If
    Next
    'Put a label under the line
    curDisplay.ForeColor = vbBlack
    intDrawWidth = ThinLine * dblDisplaySize
    If intDrawWidth < 1 Then intDrawWidth = 1
    curDisplay.DrawWidth = intDrawWidth
    If udtGraph.blnMode Then
        For intI = 1 To Len(strLabel)
            intJ = intN * intI / (Len(strLabel) + 1) - 1
            curDisplay.CurrentX = (dblX(intJ) - dblXMin) / (dblXMax - dblXMin) * (dblXRangeMax - dblXRangeMin) + dblXRangeMin
            If blnNew Then curDisplay.CurrentX = curDisplay.CurrentX - curDisplay.TextWidth(Mid(strLabel, intI, 1))
            curDisplay.CurrentY = (1 - (dblY(intJ) - dblYMin) / (dblYMax - dblYMin)) * (dblYRangeMax - dblYRangeMin) + dblYRangeMin
            If udtLocation.dblLatitude >= 0 Then
                curDisplay.Print Mid(strLabel, intI, 1)
            Else 'Reverse for Southern Hemisphere
                curDisplay.Print Mid(strLabel, Len(strLabel) - intI + 1, 1)
            End If
        Next
    End If
    End If
End Sub
Private Sub DrawScale(dblMin As Double, dblMax As Double, sngXmin As Double, sngYMin As Double, sngXMax As Double, sngYMax As Double, intTickLength As Integer, strLabel As String, curDisplay As Object, dblYPosMin As Double, Optional blnFixStep As Boolean = False, Optional blnFracCirC As Boolean)
    'Draw a scale
    'Checked 23.11.99
    'dblMin and dblMax are the values at the ends of the scale
    '(sngXmin, sngYmin) and (sngXMax, sngYMax) are the ends of the scale in pixels
    'intTickLength is the tick length in pixels
    'strLabel is the label, usually the units
    Dim blnVertical As Boolean 'True if scale closer to vertical than horizontal
    Dim dblRange As Double 'difference in values at ends of the scale
    Dim dblMantissa As Double 'Mantissa part of step in label values before rounding
    Dim dblStep As Double 'Step in label values
    Dim dblTick As Double
    Dim intExponent As Integer 'Exponent part of step in label values
    Dim intMantissa As Integer 'Mantissa part of step in label values
    Dim intSgn As Integer 'Direction of scale: -1 high to low, 1 low to high
    Dim lngTick As Long 'Label number
    Dim sngXEnd As Single
    Dim sngXStart As Single
    Dim sngYEnd As Single
    Dim sngYStart As Single
    
    curDisplay.DrawWidth = 2
    blnVertical = Abs(sngYMax - sngYMin) > Abs(sngXMax - sngXmin) 'True if scale closer to vertical than horizontal
    dblRange = dblMax - dblMin 'Determine the range of values
    If dblRange >= 0 Then 'Determine the direction of the scale
        intSgn = 1
    Else
        intSgn = -1
    End If
    'Determine the step size
    If blnFixStep Then
        dblStep = 10
    Else
        If dblRange = 0 Then
            intExponent = 0
            intMantissa = 1
        Else
            intExponent = Int(Log10(intSgn * dblRange / 2.5))
            dblMantissa = dblRange / 2.5 / 10 ^ intExponent
            If Abs(dblMantissa) < 2 Then
                intMantissa = 1
            ElseIf Abs(dblMantissa) < 5 Then
                intMantissa = 2
            Else
                intMantissa = 5
            End If
        End If
        dblStep = intSgn * intMantissa * 10 ^ intExponent
    End If
    curDisplay.Line (sngXmin, sngYMin)-(sngXMax, sngYMax) 'Draw the scale line
    For lngTick = Int(dblMin / dblStep + 1) To Int(dblMax / dblStep) 'For each step
        dblTick = lngTick * dblStep 'Calculate the value
        'Determine position of tick
        sngXStart = (dblTick - dblMin) * (sngXMax - sngXmin) / (dblMax - dblMin) + sngXmin
        sngYStart = (dblTick - dblMin) * (sngYMax - sngYMin) / (dblMax - dblMin) + sngYMin
        If blnVertical Then
            sngXEnd = sngXStart - intTickLength
            sngYEnd = sngYStart
        Else
            sngXEnd = sngXStart
            sngYEnd = sngYStart + intTickLength
        End If
        curDisplay.Line (sngXStart, sngYStart)-(sngXEnd, sngYEnd) 'Draw the tick mark
        'Determine starting position of text
        If blnVertical Then
            curDisplay.CurrentX = sngXEnd - curDisplay.TextWidth(dblTick)
            curDisplay.CurrentY = sngYEnd - curDisplay.TextHeight(dblTick) / 2
        Else
            curDisplay.CurrentX = sngXEnd - curDisplay.TextWidth(dblTick) / 2
            curDisplay.CurrentY = sngYEnd
        End If
        If blnVertical Then 'If there is room to print the value do so
            If curDisplay.CurrentY < curDisplay.ScaleHeight - curDisplay.TextHeight(dblTick) And curDisplay.CurrentY >= curDisplay.TextHeight(strLabel) Then
                curDisplay.Print dblTick
            End If
        Else
            If curDisplay.CurrentX > curDisplay.TextWidth(strLabel) + sngXmin And curDisplay.CurrentX < curDisplay.ScaleWidth - curDisplay.TextWidth(dblTick) Then
                If blnFracCirC Then
                    curDisplay.Print FracCirc(dblTick)
                Else
                    curDisplay.Print dblTick
                End If
            End If
        End If
    Next
    If blnVertical Then 'Print the text label
        curDisplay.CurrentX = 0
        curDisplay.CurrentY = dblYPosMin
        curDisplay.Print strLabel
    Else
        curDisplay.CurrentX = sngXmin
        curDisplay.CurrentY = sngYMin + intTickLength
        curDisplay.Print strLabel
    End If
    'Draw grid if detailed
    If udtGraph.blnMode Then
        For lngTick = Int(dblMin + 1) To Int(dblMax)
            sngXStart = (lngTick - dblMin) * (sngXMax - sngXmin) / (dblMax - dblMin) + sngXmin
            sngYStart = (lngTick - dblMin) * (sngYMax - sngYMin) / (dblMax - dblMin) + sngYMin
            If blnVertical Then
                sngXEnd = curDisplay.ScaleWidth
                sngYEnd = sngYStart
            Else
                sngXEnd = sngXStart
                sngYEnd = dblYPosMin
            End If
            curDisplay.DrawWidth = 1
            If MyMod(lngTick, 5) = 0 Then
                curDisplay.DrawStyle = 1
            Else
                curDisplay.DrawStyle = 2
            End If
            curDisplay.ForeColor = &HAAAAAA 'Light grey grid suggested by Michael Isaacs
            curDisplay.Line (sngXStart, sngYStart)-(sngXEnd, sngYEnd) 'Draw the tick mark
            curDisplay.DrawStyle = 0
            curDisplay.ForeColor = vbBlack
            curDisplay.DrawWidth = 2
        Next
    End If
End Sub
Private Sub ScaleTextSize(dblMin As Double, dblMax As Double, intXText As Integer, intYText As Integer, strLabel As String, curDisplay As Object)
    Dim dblRange As Double
    Dim intSgn As Integer
    Dim intExponent As Integer
    Dim dblMantissa As Double
    Dim intMantissa As Double
    Dim dblTick As Double
    Dim lngTick As Long
    Dim dblStep As Double
    'Finds the maximum width and height of the numbers on the scale
    'Checked 2.12.99
    
    intXText = curDisplay.TextWidth(strLabel)
    intYText = curDisplay.TextHeight(strLabel)
    dblRange = dblMax - dblMin
    If dblRange = 0 Then dblRange = 0.0001
    If dblRange >= 0 Then
        intSgn = 1
    Else
        intSgn = -1
    End If
    intExponent = Int(Log10(intSgn * dblRange / 2.5))
    dblMantissa = dblRange / 2.5 / 10 ^ intExponent
    If Abs(dblMantissa) < 2 Then
        intMantissa = 1
    ElseIf Abs(dblMantissa) < 5 Then
        intMantissa = 2
    Else
        intMantissa = 5
    End If
    dblStep = intSgn * intMantissa * 10 ^ intExponent
    For lngTick = Int(dblMin / dblStep + 1) To Int(dblMax / dblStep)
        dblTick = lngTick * dblStep
        If curDisplay.TextWidth(dblTick) > intXText Then
            intXText = curDisplay.TextWidth(dblTick)
        End If
        If curDisplay.TextHeight(dblTick) > intYText Then
            intYText = curDisplay.TextHeight(dblTick)
        End If
    Next
End Sub
Function MyMax(dblArray() As Double, intN As Integer) As Double
    Dim intI As Integer
    
    If intN < 0 Then
        MyMax = 0
    Else
        MyMax = dblArray(0)
        For intI = 1 To intN
            If MyMax < dblArray(intI) Then MyMax = dblArray(intI)
        Next
    End If
End Function
Function MyMin(dblArray() As Double, intN As Integer) As Double
    Dim intI As Integer
    
    If intN < 0 Then
        MyMin = 0
    Else
        MyMin = dblArray(0)
        For intI = 1 To intN
            If MyMin > dblArray(intI) Then MyMin = dblArray(intI)
        Next
    End If
End Function

Private Sub Form_Load()
    'Draw graph only if the form is visible
    If frmGraph.Visible Then Call Form_Resize
End Sub

Friend Sub Form_Resize()
    If frmGraph.Width > 270 And frmGraph.Height > 900 Then
        pctGraph.Width = frmGraph.Width - 240
        pctGraph.Height = frmGraph.Height - 850
        lblGraph.Top = frmGraph.ScaleHeight - 300
        Select Case lngGraphType
        Case 0, 1, 2
            Call DrawGraph(pctGraph)
        Case 3
            Call DrawProb(pctGraph)
        Case Else
            Call LightCurve(pctGraph)
        End Select
    End If
End Sub
Private Sub CalcCurve(curDisplay As Object, strHBody As String, lngFix As Long, udtObj() As MyArray, intPrimary As Integer, blnEvening As Boolean, intStep As Integer)
    Dim intHBody As Integer
    Dim intInterp As Integer
    Dim intI As Integer
    Dim intJ As Integer
    Dim dblYallopQ As Double
    Dim dblTM As Double
    Dim dblMT() As Double
    Dim dblAngle As Double
    Dim dblSubtend As Double
    Dim dblMAL() As Double
    Dim dblMAZ() As Double
    Dim dblMAL2() As Double
    Dim dblMAZ2() As Double
    Dim blnEasy As Boolean
    Dim blnNotVisible As Boolean
    Dim blnRefrValid As Boolean
    Dim dblProbVis As Double
    Dim dblRise As Double
    Dim dblSet As Double
    Dim blnNeverRises As Boolean
    Dim blnNeverSets As Boolean
    Dim blnNew As Boolean
    Dim udtHbody As HBody
    Dim udtTimeIn As Mytime
    Dim dblBSky As Double
    Dim udtMoon As HBody
    Dim cMoon As New clsMoon
    Dim cHBody As New clsHBody
    Dim cSky As New clsSky
    Dim cLocal As New clsLocalTime
    Dim dblQ As Double
    Dim dblBestTime As Double
    Dim dblARCV As Double
    Dim dblWp As Double
    Dim udtSun As HBody
    
    Select Case strHBody
        Case "Moon"
            intHBody = 0
        Case "Sun"
            intHBody = 1
        Case "Mercury"
            intHBody = 2
        Case "Venus"
            intHBody = 3
        Case "Mars"
            intHBody = 4
        Case "Jupiter"
            intHBody = 5
        Case "Saturn"
            intHBody = 6
    End Select
    If intPrimary = 0 Then
        Call cHBody.Visibility(strHBody, lngFix, blnNew, dblYallopQ, udtObj(intHBody).dblT, blnEasy, blnNotVisible, dblProbVis, udtVisibilitySave(intHBody).blnTopo, udtVisibilitySave(intHBody).blnPhotometric, blnNeverRises)
    Else
        Call cHBody.Visibility(strHBody, lngFix, blnNew, dblYallopQ, udtObj(intHBody).dblT, blnEasy, blnNotVisible, dblProbVis, True, True, blnNeverRises)
    End If
    If intHBody = intPrimary Then
        blnEvening = blnNew
    End If
    If blnEasy And strHBody = "Moon" And intPrimary = 0 Then 'if using a nonphotometric method for the Moon and the result is out of range
        If blnEvening Then
            curDisplay.Print "The new Moon is visible for an extended period."
        Else
            curDisplay.Print "The old Moon is visible for an extended period."
        End If
    ElseIf blnNotVisible And dblYallopQ <= -0.23 And strHBody = "Moon" And intPrimary = 0 Then 'if using a nonphotometric method for the Moon and the result is out of range
        If blnEvening Then
            curDisplay.Print "The new Moon is not visible even with a telescope."
        Else
            curDisplay.Print "The old Moon is not visible even with a telescope."
        End If
    Else 'Use the photometric method
        'Call cHBody.RiseSet(strHBody, lngFix, False, dblRise, True, blnNeverRises, blnNeverSets, 0, True)
        'Find out if it rises at all
        If blnNeverRises And intHBody = intPrimary Then 'If it does not rise and is primary then say so
            If strHBody = "Moon" Then
                If blnEvening Then
                    curDisplay.Print "The new Moon does not rise."
                Else
                    curDisplay.Print "The old Moon does not rise."
                End If
            ElseIf strHBody = "Sun" Then
                    curDisplay.Print "The Sun does not rise."
            Else
                curDisplay.Print strHBody & " does not rise."
            End If
            udtObj(intHBody).intN = -1
        ElseIf Not blnNeverRises And (intHBody = intPrimary Or udtObj(intPrimary).intN > -1) Then
            With udtObj(intHBody)
                dblRise = .dblT(4)
                dblSet = .dblT(5)
                'set the time limit for the graph
                If blnEvening Then
                    'half an hour before first visibility till Moonset
                    If udtGraph.blnMode Or lngGraphType > 2 Then
                    'half hour before first possible sighting
                        .dblT(4) = udtObj(intPrimary).dblT(0) - intEarly / 1440
                        If .dblT(4) > dblSet - intEarly / 1440 Then .dblT(4) = dblSet - intEarly / 1440
                        If .dblT(4) < dblRise Then .dblT(4) = dblRise
                        If intHBody > 0 And intHBody <> intPrimary Then
                            .dblT(5) = udtObj(intPrimary).dblT(5)
                            If .dblT(5) > dblSet Then .dblT(5) = dblSet
                        End If
                    Else 'Simplified display of only the time that the Moon is visible
                        If intHBody = intPrimary Then
                            .dblT(4) = .dblT(0)
                            'For simplified display do not show after the Moon fades
                            If .dblT(5) > .dblT(3) Then .dblT(5) = .dblT(3)
                        ElseIf intHBody = 1 Then 'Plot the Sunset
                            .dblT(4) = dblSet
                            .dblT(5) = dblSet
                        Else 'Plot the point where it first appears
                            .dblT(4) = udtObj(intPrimary).dblT(0)
                            .dblT(5) = udtObj(intPrimary).dblT(0)
                        End If
                    End If
                Else 'old Moon
                    If udtGraph.blnMode Or lngGraphType > 2 Then
                        'half hour after last possible sighting
                        .dblT(5) = udtObj(intPrimary).dblT(3) + intEarly / 1440
                        If .dblT(5) < dblRise + intEarly / 1440 Then .dblT(5) = dblRise + intEarly / 1440
                        If .dblT(5) > dblSet Then .dblT(5) = dblSet
                        If intHBody > 1 And intHBody <> intPrimary Then
                            .dblT(4) = udtObj(intPrimary).dblT(4)
                            If .dblT(4) < dblRise Then .dblT(4) = dblRise
                        End If
                    Else 'Simplified display end at last possible sighting
                        If intHBody = intPrimary Then
                            .dblT(5) = .dblT(3)
                            .dblT(4) = .dblT(0)
                        ElseIf intHBody = 1 Then 'Plot the Sunrise
                            .dblT(4) = dblRise
                            .dblT(5) = dblRise
                        Else 'Plot the point where the primary last appears
                            .dblT(4) = udtObj(intPrimary).dblT(3)
                            .dblT(5) = udtObj(intPrimary).dblT(3)
                        End If
                    End If
                End If
            'End If
            .intN = Int((.dblT(5)) * 1440) - Int((.dblT(4)) * 1440 + 1)
            If .dblT(4) = .dblT(5) And (cHBody.HBProbVis(strHBody, .dblT(4)) >= 0.05 Or intHBody < 2) Then
                .intN = 0
                ReDim .MAL(0)
                ReDim .MAZ(0)
                If intHBody = 0 Then 'Moon
                    Call cMoon.BrightLimb(.dblT(4), dblAngle, dblSubtend, .MAL(0), .MAZ(0), False)
                Else
                    Call cHBody.TrueHBody(strHBody, .dblT(4), udtHbody)
                    .MAL(0) = udtHbody.AltTopo
                    .MAZ(0) = udtHbody.AzTopo
                End If
            ElseIf .intN > -1 Then
                If intHBody = intPrimary Then 'If primary then set reasonable steps
                    If udtGraph.blnMode Then
                        intStep = .intN \ 100 + 1
                        Select Case intStep
                            Case 4
                                intStep = 3
                            Case 5, 7
                                intStep = 6
                            Case 8, 10
                                intStep = 9
                            Case 11, 13, 14, 15
                                intStep = 12
                        End Select
                        If intStep > 6 Then intStep = 6
                    Else
                        intStep = 3
                    End If
                End If
                If intStep = 0 Then intStep = 1
                .intN = .intN \ intStep
                ReDim .MAZ(.intN + 1)
                ReDim .MAL(.intN + 1)
                If .intN < 20 Or lngGraphType = 3 Or intNIntegrals = 128 Then
                    intInterp = 1
                Else
                    intInterp = 10
                End If
                ReDim dblMAZ((.intN + 1) \ intInterp)
                ReDim dblMAL((.intN + 1) \ intInterp)
                ReDim dblMAZ2((.intN + 1) \ intInterp)
                ReDim dblMAL2((.intN + 1) \ intInterp)
                ReDim dblMT((.intN + 1) \ intInterp)
                If lngMoonCalcMode = 2 Then
                    Call cMoon.QT(lngFix, dblQ, blnEvening, dblBestTime, dblARCV, dblWp)
                    If dblQ > 30 Or dblQ < -1 Then .intN = -1
                ElseIf lngMoonCalcMode = 1 Then
                    Call cMoon.YallopQ(lngFix, dblQ, blnEvening, dblBestTime, dblARCV, dblWp)
                    If dblQ > 3 Or dblQ < -0.1 Then .intN = -1
                End If
                For intI = 0 To (.intN + 1) \ intInterp 'for each step calculate the value
                    dblTM = (Int(.dblT(4) * 1440 / intStep) * intStep + (intI * intInterp + 1) * intStep) / 1440
                    dblMT(intI) = dblTM
                    Select Case lngGraphType
                    Case 0, 1, 2
                        If intHBody = 0 Then 'Moon
                            Call cMoon.BrightLimb(dblTM, dblAngle, dblSubtend, dblMAL(intI), dblMAZ(intI), False)
                        Else
                            Call cHBody.TrueHBody(strHBody, dblTM, udtHbody)
                            dblMAL(intI) = udtHbody.AltTopo
                            dblMAZ(intI) = udtHbody.AzTopo
                        End If
                    Case 3
                        Call cLocal.ToLocal(dblTM + 0.00048, udtTimeIn)
                        dblMAZ(intI) = udtTimeIn.udtDms.intDegreesHours + udtTimeIn.udtDms.intMinutes / 60
                        If intHBody > 0 Or lngMoonCalcMode = 0 Then 'Photometric
                            dblMAL(intI) = cHBody.HBProbVis("Moon", dblTM) * 100
                        ElseIf lngMoonCalcMode = 1 Then 'Geocentric
                            Call cHBody.TrueHBody(strHBody, dblTM, udtMoon)
                            Call cHBody.TrueHBody("Sun", dblTM, udtSun)
                            dblMAL(intI) = 100 * Norm((-5.2058 + 3.3852 * dblQ - udtSun.AltTopo) / 1.543) * Norm(udtMoon.AltTopo - 2.8 * Exp(-0.4 * dblQ) - 1.5)
                        Else
                            Call cHBody.TrueHBody(strHBody, dblTM, udtMoon)
                            Call cHBody.TrueHBody("Sun", dblTM, udtSun)
                            dblMAL(intI) = 100 * Norm((-5.2003 + 0.3302 * dblQ - udtSun.AltTopo) / 1.543) * Norm(udtMoon.AltTopo - 2.8 * Exp(-4 * dblQ) - 1.5)
                        End If
                    Case 4
                        Call cHBody.TrueHBody("Moon", dblTM, udtMoon)
                        dblMAL(intI) = cHBody.Magnitude("Moon", udtMoon) + cSky.DeltaM(dblTM, udtMoon.AltRefr, udtMoon.AzTopo, 2)
                        dblBSky = cSky.BSky(dblTM, udtMoon.AltRefr, udtMoon.AzTopo, 2)
                        dblMAZ(intI) = Log10(dblBSky)
                    End Select
                Next
                If lngGraphType < 3 Then 'Correct for breaks in the circle
                    For intI = 1 To (.intN + 1) \ intInterp
                        If dblMAZ(intI) - dblMAZ(intI - 1) > 180 Then
                            For intJ = intI To (.intN + 1) \ intInterp
                                dblMAZ(intJ) = dblMAZ(intJ) - 360
                            Next
                        ElseIf dblMAZ(intI - 1) - dblMAZ(intI) > 180 Then
                            For intJ = intI To (.intN + 1) \ intInterp
                                dblMAZ(intJ) = dblMAZ(intJ) + 360
                            Next
                        End If
                    Next
                End If
                Call cSky.spline(dblMT, dblMAZ, dblMAZ2, (.intN + 1) \ intInterp + 1)
                Call cSky.spline(dblMT, dblMAL, dblMAL2, (.intN + 1) \ intInterp + 1)
                'For each minute find the position of the center of the crescent
                For intI = 0 To .intN
                    dblTM = (Int(.dblT(4) * 1440 / intStep) * intStep + (intI + 1) * intStep) / 1440
                    .MAZ(intI) = cSky.splint(dblMT, dblMAZ, dblMAZ2, (.intN + 1) \ intInterp, dblTM)
                    .MAL(intI) = cSky.splint(dblMT, dblMAL, dblMAL2, (.intN + 1) \ intInterp, dblTM)
                    If lngGraphType < 3 Then .MAL(intI) = .MAL(intI) + cHBody.Refract(.MAL(intI), True, udtWeatherNow, blnRefrValid)
                Next
            End If
        'End If
        End With
    Else
        udtObj(intHBody).intN = -1 'It or the primary object does not rise
    End If
    End If
End Sub
